/**
 * <copyright>
 * </copyright>
 *
 * $Id: CallchainPackage.java,v 1.3 2008/04/13 20:29:19 urs Exp $
 */
package de.urszeidler.eclipse.callchain;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see de.urszeidler.eclipse.callchain.CallchainFactory
 * @model kind="package"
 * @generated
 */
public interface CallchainPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "callchain";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://urszeidler.de/callchain/2010/flowmodel";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "transformFlow";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	CallchainPackage eINSTANCE = de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl.init();

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.Documentable <em>Documentable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.Documentable
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getDocumentable()
	 * @generated
	 */
	int DOCUMENTABLE = 10;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENTABLE__COMMENTS = 0;

	/**
	 * The number of structural features of the '<em>Documentable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENTABLE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.ArtifactImpl <em>Artifact</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.ArtifactImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getArtifact()
	 * @generated
	 */
	int ARTIFACT = 8;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT__COMMENTS = DOCUMENTABLE__COMMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT__NAME = DOCUMENTABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT__URI = DOCUMENTABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Derived</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT__DERIVED = DOCUMENTABLE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Artifact</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARTIFACT_FEATURE_COUNT = DOCUMENTABLE_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.ModelImpl <em>Model</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.ModelImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getModel()
	 * @generated
	 */
	int MODEL = 0;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__COMMENTS = ARTIFACT__COMMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__NAME = ARTIFACT__NAME;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__URI = ARTIFACT__URI;

	/**
	 * The feature id for the '<em><b>Derived</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__DERIVED = ARTIFACT__DERIVED;

	/**
	 * The feature id for the '<em><b>Mm</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__MM = ARTIFACT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Is Temporary</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__IS_TEMPORARY = ARTIFACT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_FEATURE_COUNT = ARTIFACT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.AtlResImpl <em>Atl Res</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.AtlResImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getAtlRes()
	 * @generated
	 */
	int ATL_RES = 1;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATL_RES__COMMENTS = ARTIFACT__COMMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATL_RES__NAME = ARTIFACT__NAME;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATL_RES__URI = ARTIFACT__URI;

	/**
	 * The feature id for the '<em><b>Derived</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATL_RES__DERIVED = ARTIFACT__DERIVED;

	/**
	 * The feature id for the '<em><b>Superimpose</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATL_RES__SUPERIMPOSE = ARTIFACT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Atl Res</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATL_RES_FEATURE_COUNT = ARTIFACT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.CallImpl <em>Call</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.CallImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getCall()
	 * @generated
	 */
	int CALL = 2;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__COMMENTS = DOCUMENTABLE__COMMENTS;

	/**
	 * The feature id for the '<em><b>Next</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__NEXT = DOCUMENTABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__NAME = DOCUMENTABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Refresh Workspace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__REFRESH_WORKSPACE = DOCUMENTABLE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Predicate</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__PREDICATE = DOCUMENTABLE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>In</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__IN = DOCUMENTABLE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Out</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__OUT = DOCUMENTABLE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Res</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__RES = DOCUMENTABLE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Libarys</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__LIBARYS = DOCUMENTABLE_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Allow Inter Model References</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__ALLOW_INTER_MODEL_REFERENCES = DOCUMENTABLE_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Continue After Errors</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__CONTINUE_AFTER_ERRORS = DOCUMENTABLE_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Artifact</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__ARTIFACT = DOCUMENTABLE_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>Enviorment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__ENVIORMENT = DOCUMENTABLE_FEATURE_COUNT + 11;

	/**
	 * The feature id for the '<em><b>Show Summary</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__SHOW_SUMMARY = DOCUMENTABLE_FEATURE_COUNT + 12;

	/**
	 * The feature id for the '<em><b>Print Execution Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__PRINT_EXECUTION_TIME = DOCUMENTABLE_FEATURE_COUNT + 13;

	/**
	 * The feature id for the '<em><b>Disable Attribute Helper Cache</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__DISABLE_ATTRIBUTE_HELPER_CACHE = DOCUMENTABLE_FEATURE_COUNT + 14;

	/**
	 * The feature id for the '<em><b>Profile</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL__PROFILE = DOCUMENTABLE_FEATURE_COUNT + 15;

	/**
	 * The number of structural features of the '<em>Call</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_FEATURE_COUNT = DOCUMENTABLE_FEATURE_COUNT + 16;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.MMImpl <em>MM</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.MMImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getMM()
	 * @generated
	 */
	int MM = 3;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM__COMMENTS = ARTIFACT__COMMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM__NAME = ARTIFACT__NAME;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM__URI = ARTIFACT__URI;

	/**
	 * The feature id for the '<em><b>Derived</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM__DERIVED = ARTIFACT__DERIVED;

	/**
	 * The feature id for the '<em><b>Handler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM__HANDLER = ARTIFACT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>MM</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM_FEATURE_COUNT = ARTIFACT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.CallsImpl <em>Calls</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.CallsImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getCalls()
	 * @generated
	 */
	int CALLS = 4;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__COMMENTS = DOCUMENTABLE__COMMENTS;

	/**
	 * The feature id for the '<em><b>Call</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__CALL = DOCUMENTABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Generators</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__GENERATORS = DOCUMENTABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Artifacts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__ARTIFACTS = DOCUMENTABLE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Properties</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__PROPERTIES = DOCUMENTABLE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Default Lib</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__DEFAULT_LIB = DOCUMENTABLE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Default Super Imposed</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__DEFAULT_SUPER_IMPOSED = DOCUMENTABLE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Start Points</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__START_POINTS = DOCUMENTABLE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Default Start Point</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__DEFAULT_START_POINT = DOCUMENTABLE_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Log Default</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__LOG_DEFAULT = DOCUMENTABLE_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Switches</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__SWITCHES = DOCUMENTABLE_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Extern Callables</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__EXTERN_CALLABLES = DOCUMENTABLE_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__NAME = DOCUMENTABLE_FEATURE_COUNT + 11;

	/**
	 * The feature id for the '<em><b>Stop Elements</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS__STOP_ELEMENTS = DOCUMENTABLE_FEATURE_COUNT + 12;

	/**
	 * The number of structural features of the '<em>Calls</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLS_FEATURE_COUNT = DOCUMENTABLE_FEATURE_COUNT + 13;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.AtlLibaryImpl <em>Atl Libary</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.AtlLibaryImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getAtlLibary()
	 * @generated
	 */
	int ATL_LIBARY = 5;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATL_LIBARY__COMMENTS = ARTIFACT__COMMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATL_LIBARY__NAME = ARTIFACT__NAME;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATL_LIBARY__URI = ARTIFACT__URI;

	/**
	 * The feature id for the '<em><b>Derived</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATL_LIBARY__DERIVED = ARTIFACT__DERIVED;

	/**
	 * The number of structural features of the '<em>Atl Libary</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATL_LIBARY_FEATURE_COUNT = ARTIFACT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.ModelAliasImpl <em>Model Alias</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.ModelAliasImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getModelAlias()
	 * @generated
	 */
	int MODEL_ALIAS = 6;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ALIAS__COMMENTS = MODEL__COMMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ALIAS__NAME = MODEL__NAME;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ALIAS__URI = MODEL__URI;

	/**
	 * The feature id for the '<em><b>Derived</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ALIAS__DERIVED = MODEL__DERIVED;

	/**
	 * The feature id for the '<em><b>Mm</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ALIAS__MM = MODEL__MM;

	/**
	 * The feature id for the '<em><b>Is Temporary</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ALIAS__IS_TEMPORARY = MODEL__IS_TEMPORARY;

	/**
	 * The feature id for the '<em><b>Decoratedmodel</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ALIAS__DECORATEDMODEL = MODEL_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Alias Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ALIAS__ALIAS_NAME = MODEL_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Model Alias</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ALIAS_FEATURE_COUNT = MODEL_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.GeneratorImpl <em>Generator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.GeneratorImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getGenerator()
	 * @generated
	 */
	int GENERATOR = 7;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERATOR__COMMENTS = DOCUMENTABLE__COMMENTS;

	/**
	 * The feature id for the '<em><b>Next</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERATOR__NEXT = DOCUMENTABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERATOR__NAME = DOCUMENTABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Refresh Workspace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERATOR__REFRESH_WORKSPACE = DOCUMENTABLE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Predicate</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERATOR__PREDICATE = DOCUMENTABLE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Uses</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERATOR__USES = DOCUMENTABLE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Produce</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERATOR__PRODUCE = DOCUMENTABLE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Enviorment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERATOR__ENVIORMENT = DOCUMENTABLE_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the '<em>Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERATOR_FEATURE_COUNT = DOCUMENTABLE_FEATURE_COUNT + 7;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.MMAliasImpl <em>MM Alias</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.MMAliasImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getMMAlias()
	 * @generated
	 */
	int MM_ALIAS = 9;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM_ALIAS__COMMENTS = MM__COMMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM_ALIAS__NAME = MM__NAME;

	/**
	 * The feature id for the '<em><b>Uri</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM_ALIAS__URI = MM__URI;

	/**
	 * The feature id for the '<em><b>Derived</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM_ALIAS__DERIVED = MM__DERIVED;

	/**
	 * The feature id for the '<em><b>Handler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM_ALIAS__HANDLER = MM__HANDLER;

	/**
	 * The feature id for the '<em><b>Decoratedmodel</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM_ALIAS__DECORATEDMODEL = MM_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Alias Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM_ALIAS__ALIAS_NAME = MM_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>MM Alias</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MM_ALIAS_FEATURE_COUNT = MM_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.CommentImpl <em>Comment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.CommentImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getComment()
	 * @generated
	 */
	int COMMENT = 11;

	/**
	 * The feature id for the '<em><b>Doc</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMENT__DOC = 0;

	/**
	 * The feature id for the '<em><b>Documented Element</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMENT__DOCUMENTED_ELEMENT = 1;

	/**
	 * The feature id for the '<em><b>Owner</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMENT__OWNER = 2;

	/**
	 * The number of structural features of the '<em>Comment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMMENT_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.Callable <em>Callable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.Callable
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getCallable()
	 * @generated
	 */
	int CALLABLE = 12;

	/**
	 * The feature id for the '<em><b>Next</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLABLE__NEXT = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLABLE__NAME = 1;

	/**
	 * The feature id for the '<em><b>Refresh Workspace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLABLE__REFRESH_WORKSPACE = 2;

	/**
	 * The number of structural features of the '<em>Callable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLABLE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.Generic_GeneratorImpl <em>Generic Generator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.Generic_GeneratorImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getGeneric_Generator()
	 * @generated
	 */
	int GENERIC_GENERATOR = 13;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_GENERATOR__COMMENTS = GENERATOR__COMMENTS;

	/**
	 * The feature id for the '<em><b>Next</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_GENERATOR__NEXT = GENERATOR__NEXT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_GENERATOR__NAME = GENERATOR__NAME;

	/**
	 * The feature id for the '<em><b>Refresh Workspace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_GENERATOR__REFRESH_WORKSPACE = GENERATOR__REFRESH_WORKSPACE;

	/**
	 * The feature id for the '<em><b>Predicate</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_GENERATOR__PREDICATE = GENERATOR__PREDICATE;

	/**
	 * The feature id for the '<em><b>Uses</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_GENERATOR__USES = GENERATOR__USES;

	/**
	 * The feature id for the '<em><b>Produce</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_GENERATOR__PRODUCE = GENERATOR__PRODUCE;

	/**
	 * The feature id for the '<em><b>Enviorment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_GENERATOR__ENVIORMENT = GENERATOR__ENVIORMENT;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_GENERATOR__ID = GENERATOR_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Generator Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_GENERATOR__GENERATOR_TYPE = GENERATOR_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Generic Generator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_GENERATOR_FEATURE_COUNT = GENERATOR_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.PropertyImpl <em>Property</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.PropertyImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getProperty()
	 * @generated
	 */
	int PROPERTY = 14;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__COMMENTS = DOCUMENTABLE__COMMENTS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__NAME = DOCUMENTABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Default Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__DEFAULT_VALUE = DOCUMENTABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY__VALUE = DOCUMENTABLE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Property</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_FEATURE_COUNT = DOCUMENTABLE_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.SwitchImpl <em>Switch</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.SwitchImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getSwitch()
	 * @generated
	 */
	int SWITCH = 15;

	/**
	 * The feature id for the '<em><b>Next</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWITCH__NEXT = CALLABLE__NEXT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWITCH__NAME = CALLABLE__NAME;

	/**
	 * The feature id for the '<em><b>Refresh Workspace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWITCH__REFRESH_WORKSPACE = CALLABLE__REFRESH_WORKSPACE;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWITCH__COMMENTS = CALLABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>All Callables</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWITCH__ALL_CALLABLES = CALLABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Enviorment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWITCH__ENVIORMENT = CALLABLE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Switch</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SWITCH_FEATURE_COUNT = CALLABLE_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.PredicateSwitchImpl <em>Predicate Switch</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.PredicateSwitchImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getPredicateSwitch()
	 * @generated
	 */
	int PREDICATE_SWITCH = 16;

	/**
	 * The feature id for the '<em><b>Next</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICATE_SWITCH__NEXT = SWITCH__NEXT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICATE_SWITCH__NAME = SWITCH__NAME;

	/**
	 * The feature id for the '<em><b>Refresh Workspace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICATE_SWITCH__REFRESH_WORKSPACE = SWITCH__REFRESH_WORKSPACE;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICATE_SWITCH__COMMENTS = SWITCH__COMMENTS;

	/**
	 * The feature id for the '<em><b>All Callables</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICATE_SWITCH__ALL_CALLABLES = SWITCH__ALL_CALLABLES;

	/**
	 * The feature id for the '<em><b>Enviorment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICATE_SWITCH__ENVIORMENT = SWITCH__ENVIORMENT;

	/**
	 * The feature id for the '<em><b>True Callable</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICATE_SWITCH__TRUE_CALLABLE = SWITCH_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>False Callable</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICATE_SWITCH__FALSE_CALLABLE = SWITCH_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Predicate</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICATE_SWITCH__PREDICATE = SWITCH_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Predicate Switch</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICATE_SWITCH_FEATURE_COUNT = SWITCH_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.NamedSwitchImpl <em>Named Switch</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.NamedSwitchImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getNamedSwitch()
	 * @generated
	 */
	int NAMED_SWITCH = 17;

	/**
	 * The feature id for the '<em><b>Next</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_SWITCH__NEXT = SWITCH__NEXT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_SWITCH__NAME = SWITCH__NAME;

	/**
	 * The feature id for the '<em><b>Refresh Workspace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_SWITCH__REFRESH_WORKSPACE = SWITCH__REFRESH_WORKSPACE;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_SWITCH__COMMENTS = SWITCH__COMMENTS;

	/**
	 * The feature id for the '<em><b>All Callables</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_SWITCH__ALL_CALLABLES = SWITCH__ALL_CALLABLES;

	/**
	 * The feature id for the '<em><b>Enviorment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_SWITCH__ENVIORMENT = SWITCH__ENVIORMENT;

	/**
	 * The feature id for the '<em><b>Transitions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_SWITCH__TRANSITIONS = SWITCH_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Default Call</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_SWITCH__DEFAULT_CALL = SWITCH_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Named Switch</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NAMED_SWITCH_FEATURE_COUNT = SWITCH_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.TransitionImpl <em>Transition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.TransitionImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getTransition()
	 * @generated
	 */
	int TRANSITION = 18;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSITION__NAME = 0;

	/**
	 * The feature id for the '<em><b>Callable</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSITION__CALLABLE = 1;

	/**
	 * The feature id for the '<em><b>Named Switch</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSITION__NAMED_SWITCH = 2;

	/**
	 * The number of structural features of the '<em>Transition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSITION_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.Predicate <em>Predicate</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.Predicate
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getPredicate()
	 * @generated
	 */
	int PREDICATE = 19;

	/**
	 * The number of structural features of the '<em>Predicate</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREDICATE_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.PropertyPredicateImpl <em>Property Predicate</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.PropertyPredicateImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getPropertyPredicate()
	 * @generated
	 */
	int PROPERTY_PREDICATE = 20;

	/**
	 * The number of structural features of the '<em>Property Predicate</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_PREDICATE_FEATURE_COUNT = PREDICATE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.PropertyHasValueImpl <em>Property Has Value</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.PropertyHasValueImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getPropertyHasValue()
	 * @generated
	 */
	int PROPERTY_HAS_VALUE = 21;

	/**
	 * The feature id for the '<em><b>Property</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_HAS_VALUE__PROPERTY = PROPERTY_PREDICATE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_HAS_VALUE__VALUE = PROPERTY_PREDICATE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Property Has Value</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_HAS_VALUE_FEATURE_COUNT = PROPERTY_PREDICATE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.PropertyExistImpl <em>Property Exist</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.PropertyExistImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getPropertyExist()
	 * @generated
	 */
	int PROPERTY_EXIST = 22;

	/**
	 * The feature id for the '<em><b>Property Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EXIST__PROPERTY_NAME = PROPERTY_PREDICATE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Property Exist</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_EXIST_FEATURE_COUNT = PROPERTY_PREDICATE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.ResourcePredicateImpl <em>Resource Predicate</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.ResourcePredicateImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getResourcePredicate()
	 * @generated
	 */
	int RESOURCE_PREDICATE = 23;

	/**
	 * The feature id for the '<em><b>Resource</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_PREDICATE__RESOURCE = PREDICATE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Resource Predicate</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_PREDICATE_FEATURE_COUNT = PREDICATE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.ResourceExistPredicateImpl <em>Resource Exist Predicate</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.ResourceExistPredicateImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getResourceExistPredicate()
	 * @generated
	 */
	int RESOURCE_EXIST_PREDICATE = 24;

	/**
	 * The feature id for the '<em><b>Resource</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_EXIST_PREDICATE__RESOURCE = RESOURCE_PREDICATE__RESOURCE;

	/**
	 * The number of structural features of the '<em>Resource Exist Predicate</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_EXIST_PREDICATE_FEATURE_COUNT = RESOURCE_PREDICATE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.CompositePredicateImpl <em>Composite Predicate</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.CompositePredicateImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getCompositePredicate()
	 * @generated
	 */
	int COMPOSITE_PREDICATE = 25;

	/**
	 * The feature id for the '<em><b>Predicates</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_PREDICATE__PREDICATES = PREDICATE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Composite Predicate</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_PREDICATE_FEATURE_COUNT = PREDICATE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.AndPredicateImpl <em>And Predicate</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.AndPredicateImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getAndPredicate()
	 * @generated
	 */
	int AND_PREDICATE = 26;

	/**
	 * The feature id for the '<em><b>Predicates</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND_PREDICATE__PREDICATES = COMPOSITE_PREDICATE__PREDICATES;

	/**
	 * The number of structural features of the '<em>And Predicate</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND_PREDICATE_FEATURE_COUNT = COMPOSITE_PREDICATE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.OrPredicateImpl <em>Or Predicate</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.OrPredicateImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getOrPredicate()
	 * @generated
	 */
	int OR_PREDICATE = 27;

	/**
	 * The feature id for the '<em><b>Predicates</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR_PREDICATE__PREDICATES = COMPOSITE_PREDICATE__PREDICATES;

	/**
	 * The number of structural features of the '<em>Or Predicate</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR_PREDICATE_FEATURE_COUNT = COMPOSITE_PREDICATE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.NotPredicateImpl <em>Not Predicate</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.NotPredicateImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getNotPredicate()
	 * @generated
	 */
	int NOT_PREDICATE = 28;

	/**
	 * The feature id for the '<em><b>Predicate</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NOT_PREDICATE__PREDICATE = PREDICATE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Not Predicate</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NOT_PREDICATE_FEATURE_COUNT = PREDICATE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.PropertyValueSwitchImpl <em>Property Value Switch</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.PropertyValueSwitchImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getPropertyValueSwitch()
	 * @generated
	 */
	int PROPERTY_VALUE_SWITCH = 29;

	/**
	 * The feature id for the '<em><b>Next</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_SWITCH__NEXT = NAMED_SWITCH__NEXT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_SWITCH__NAME = NAMED_SWITCH__NAME;

	/**
	 * The feature id for the '<em><b>Refresh Workspace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_SWITCH__REFRESH_WORKSPACE = NAMED_SWITCH__REFRESH_WORKSPACE;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_SWITCH__COMMENTS = NAMED_SWITCH__COMMENTS;

	/**
	 * The feature id for the '<em><b>All Callables</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_SWITCH__ALL_CALLABLES = NAMED_SWITCH__ALL_CALLABLES;

	/**
	 * The feature id for the '<em><b>Enviorment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_SWITCH__ENVIORMENT = NAMED_SWITCH__ENVIORMENT;

	/**
	 * The feature id for the '<em><b>Transitions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_SWITCH__TRANSITIONS = NAMED_SWITCH__TRANSITIONS;

	/**
	 * The feature id for the '<em><b>Default Call</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_SWITCH__DEFAULT_CALL = NAMED_SWITCH__DEFAULT_CALL;

	/**
	 * The feature id for the '<em><b>Property</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_SWITCH__PROPERTY = NAMED_SWITCH_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Property Value Switch</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_SWITCH_FEATURE_COUNT = NAMED_SWITCH_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.ExternalCallableImpl <em>External Callable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.ExternalCallableImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getExternalCallable()
	 * @generated
	 */
	int EXTERNAL_CALLABLE = 30;

	/**
	 * The feature id for the '<em><b>Next</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALLABLE__NEXT = CALLABLE__NEXT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALLABLE__NAME = CALLABLE__NAME;

	/**
	 * The feature id for the '<em><b>Refresh Workspace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALLABLE__REFRESH_WORKSPACE = CALLABLE__REFRESH_WORKSPACE;

	/**
	 * The feature id for the '<em><b>Comments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALLABLE__COMMENTS = CALLABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Predicate</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALLABLE__PREDICATE = CALLABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Delegated Callable</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALLABLE__DELEGATED_CALLABLE = CALLABLE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Enviorment</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALLABLE__ENVIORMENT = CALLABLE_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>External Callable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXTERNAL_CALLABLE_FEATURE_COUNT = CALLABLE_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.StopCallImpl <em>Stop Call</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.StopCallImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getStopCall()
	 * @generated
	 */
	int STOP_CALL = 31;

	/**
	 * The feature id for the '<em><b>Next</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STOP_CALL__NEXT = CALLABLE__NEXT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STOP_CALL__NAME = CALLABLE__NAME;

	/**
	 * The feature id for the '<em><b>Refresh Workspace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STOP_CALL__REFRESH_WORKSPACE = CALLABLE__REFRESH_WORKSPACE;

	/**
	 * The number of structural features of the '<em>Stop Call</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STOP_CALL_FEATURE_COUNT = CALLABLE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.impl.BooleanPredicateImpl <em>Boolean Predicate</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.impl.BooleanPredicateImpl
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getBooleanPredicate()
	 * @generated
	 */
	int BOOLEAN_PREDICATE = 32;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN_PREDICATE__VALUE = PREDICATE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Boolean Predicate</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN_PREDICATE_FEATURE_COUNT = PREDICATE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.Eavaluateable <em>Eavaluateable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.Eavaluateable
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getEavaluateable()
	 * @generated
	 */
	int EAVALUATEABLE = 33;

	/**
	 * The feature id for the '<em><b>Predicate</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EAVALUATEABLE__PREDICATE = 0;

	/**
	 * The number of structural features of the '<em>Eavaluateable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EAVALUATEABLE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link de.urszeidler.eclipse.callchain.MMhandler <em>MMhandler</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.urszeidler.eclipse.callchain.MMhandler
	 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getMMhandler()
	 * @generated
	 */
	int MMHANDLER = 34;

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Model <em>Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model</em>'.
	 * @see de.urszeidler.eclipse.callchain.Model
	 * @generated
	 */
	EClass getModel();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.Model#getMm <em>Mm</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Mm</em>'.
	 * @see de.urszeidler.eclipse.callchain.Model#getMm()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Mm();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Model#isIsTemporary <em>Is Temporary</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Temporary</em>'.
	 * @see de.urszeidler.eclipse.callchain.Model#isIsTemporary()
	 * @see #getModel()
	 * @generated
	 */
	EAttribute getModel_IsTemporary();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.AtlRes <em>Atl Res</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Atl Res</em>'.
	 * @see de.urszeidler.eclipse.callchain.AtlRes
	 * @generated
	 */
	EClass getAtlRes();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.AtlRes#getSuperimpose <em>Superimpose</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Superimpose</em>'.
	 * @see de.urszeidler.eclipse.callchain.AtlRes#getSuperimpose()
	 * @see #getAtlRes()
	 * @generated
	 */
	EReference getAtlRes_Superimpose();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Call <em>Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Call</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call
	 * @generated
	 */
	EClass getCall();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.Call#getIn <em>In</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>In</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#getIn()
	 * @see #getCall()
	 * @generated
	 */
	EReference getCall_In();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.Call#getOut <em>Out</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Out</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#getOut()
	 * @see #getCall()
	 * @generated
	 */
	EReference getCall_Out();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.Call#getRes <em>Res</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Res</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#getRes()
	 * @see #getCall()
	 * @generated
	 */
	EReference getCall_Res();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.Call#getLibarys <em>Libarys</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Libarys</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#getLibarys()
	 * @see #getCall()
	 * @generated
	 */
	EReference getCall_Libarys();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Call#isAllowInterModelReferences <em>Allow Inter Model References</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Allow Inter Model References</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#isAllowInterModelReferences()
	 * @see #getCall()
	 * @generated
	 */
	EAttribute getCall_AllowInterModelReferences();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Call#isContinueAfterErrors <em>Continue After Errors</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Continue After Errors</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#isContinueAfterErrors()
	 * @see #getCall()
	 * @generated
	 */
	EAttribute getCall_ContinueAfterErrors();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.Call#getArtifact <em>Artifact</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Artifact</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#getArtifact()
	 * @see #getCall()
	 * @generated
	 */
	EReference getCall_Artifact();

	/**
	 * Returns the meta object for the container reference '{@link de.urszeidler.eclipse.callchain.Call#getEnviorment <em>Enviorment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Enviorment</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#getEnviorment()
	 * @see #getCall()
	 * @generated
	 */
	EReference getCall_Enviorment();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Call#isShowSummary <em>Show Summary</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Show Summary</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#isShowSummary()
	 * @see #getCall()
	 * @generated
	 */
	EAttribute getCall_ShowSummary();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Call#isPrintExecutionTime <em>Print Execution Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Print Execution Time</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#isPrintExecutionTime()
	 * @see #getCall()
	 * @generated
	 */
	EAttribute getCall_PrintExecutionTime();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Call#isDisableAttributeHelperCache <em>Disable Attribute Helper Cache</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Disable Attribute Helper Cache</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#isDisableAttributeHelperCache()
	 * @see #getCall()
	 * @generated
	 */
	EAttribute getCall_DisableAttributeHelperCache();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Call#isProfile <em>Profile</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Profile</em>'.
	 * @see de.urszeidler.eclipse.callchain.Call#isProfile()
	 * @see #getCall()
	 * @generated
	 */
	EAttribute getCall_Profile();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.MM <em>MM</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MM</em>'.
	 * @see de.urszeidler.eclipse.callchain.MM
	 * @generated
	 */
	EClass getMM();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.MM#getHandler <em>Handler</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Handler</em>'.
	 * @see de.urszeidler.eclipse.callchain.MM#getHandler()
	 * @see #getMM()
	 * @generated
	 */
	EAttribute getMM_Handler();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Calls <em>Calls</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Calls</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls
	 * @generated
	 */
	EClass getCalls();

	/**
	 * Returns the meta object for the containment reference list '{@link de.urszeidler.eclipse.callchain.Calls#getCall <em>Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Call</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#getCall()
	 * @see #getCalls()
	 * @generated
	 */
	EReference getCalls_Call();

	/**
	 * Returns the meta object for the containment reference list '{@link de.urszeidler.eclipse.callchain.Calls#getGenerators <em>Generators</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Generators</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#getGenerators()
	 * @see #getCalls()
	 * @generated
	 */
	EReference getCalls_Generators();

	/**
	 * Returns the meta object for the containment reference list '{@link de.urszeidler.eclipse.callchain.Calls#getArtifacts <em>Artifacts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Artifacts</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#getArtifacts()
	 * @see #getCalls()
	 * @generated
	 */
	EReference getCalls_Artifacts();

	/**
	 * Returns the meta object for the containment reference list '{@link de.urszeidler.eclipse.callchain.Calls#getProperties <em>Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Properties</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#getProperties()
	 * @see #getCalls()
	 * @generated
	 */
	EReference getCalls_Properties();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.Calls#getDefaultLib <em>Default Lib</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Default Lib</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#getDefaultLib()
	 * @see #getCalls()
	 * @generated
	 */
	EReference getCalls_DefaultLib();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.Calls#getDefaultSuperImposed <em>Default Super Imposed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Default Super Imposed</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#getDefaultSuperImposed()
	 * @see #getCalls()
	 * @generated
	 */
	EReference getCalls_DefaultSuperImposed();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.Calls#getStartPoints <em>Start Points</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Start Points</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#getStartPoints()
	 * @see #getCalls()
	 * @generated
	 */
	EReference getCalls_StartPoints();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.Calls#getDefaultStartPoint <em>Default Start Point</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Default Start Point</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#getDefaultStartPoint()
	 * @see #getCalls()
	 * @generated
	 */
	EReference getCalls_DefaultStartPoint();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Calls#isLogDefault <em>Log Default</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Log Default</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#isLogDefault()
	 * @see #getCalls()
	 * @generated
	 */
	EAttribute getCalls_LogDefault();

	/**
	 * Returns the meta object for the containment reference list '{@link de.urszeidler.eclipse.callchain.Calls#getSwitches <em>Switches</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Switches</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#getSwitches()
	 * @see #getCalls()
	 * @generated
	 */
	EReference getCalls_Switches();

	/**
	 * Returns the meta object for the containment reference list '{@link de.urszeidler.eclipse.callchain.Calls#getExternCallables <em>Extern Callables</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Extern Callables</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#getExternCallables()
	 * @see #getCalls()
	 * @generated
	 */
	EReference getCalls_ExternCallables();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Calls#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#getName()
	 * @see #getCalls()
	 * @generated
	 */
	EAttribute getCalls_Name();

	/**
	 * Returns the meta object for the containment reference list '{@link de.urszeidler.eclipse.callchain.Calls#getStopElements <em>Stop Elements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Stop Elements</em>'.
	 * @see de.urszeidler.eclipse.callchain.Calls#getStopElements()
	 * @see #getCalls()
	 * @generated
	 */
	EReference getCalls_StopElements();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.AtlLibary <em>Atl Libary</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Atl Libary</em>'.
	 * @see de.urszeidler.eclipse.callchain.AtlLibary
	 * @generated
	 */
	EClass getAtlLibary();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.ModelAlias <em>Model Alias</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model Alias</em>'.
	 * @see de.urszeidler.eclipse.callchain.ModelAlias
	 * @generated
	 */
	EClass getModelAlias();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.ModelAlias#getDecoratedmodel <em>Decoratedmodel</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Decoratedmodel</em>'.
	 * @see de.urszeidler.eclipse.callchain.ModelAlias#getDecoratedmodel()
	 * @see #getModelAlias()
	 * @generated
	 */
	EReference getModelAlias_Decoratedmodel();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.ModelAlias#getAliasName <em>Alias Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Alias Name</em>'.
	 * @see de.urszeidler.eclipse.callchain.ModelAlias#getAliasName()
	 * @see #getModelAlias()
	 * @generated
	 */
	EAttribute getModelAlias_AliasName();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Generator <em>Generator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Generator</em>'.
	 * @see de.urszeidler.eclipse.callchain.Generator
	 * @generated
	 */
	EClass getGenerator();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.Generator#getUses <em>Uses</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Uses</em>'.
	 * @see de.urszeidler.eclipse.callchain.Generator#getUses()
	 * @see #getGenerator()
	 * @generated
	 */
	EReference getGenerator_Uses();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.Generator#getProduce <em>Produce</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Produce</em>'.
	 * @see de.urszeidler.eclipse.callchain.Generator#getProduce()
	 * @see #getGenerator()
	 * @generated
	 */
	EReference getGenerator_Produce();

	/**
	 * Returns the meta object for the container reference '{@link de.urszeidler.eclipse.callchain.Generator#getEnviorment <em>Enviorment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Enviorment</em>'.
	 * @see de.urszeidler.eclipse.callchain.Generator#getEnviorment()
	 * @see #getGenerator()
	 * @generated
	 */
	EReference getGenerator_Enviorment();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Artifact <em>Artifact</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Artifact</em>'.
	 * @see de.urszeidler.eclipse.callchain.Artifact
	 * @generated
	 */
	EClass getArtifact();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Artifact#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see de.urszeidler.eclipse.callchain.Artifact#getName()
	 * @see #getArtifact()
	 * @generated
	 */
	EAttribute getArtifact_Name();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Artifact#getUri <em>Uri</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Uri</em>'.
	 * @see de.urszeidler.eclipse.callchain.Artifact#getUri()
	 * @see #getArtifact()
	 * @generated
	 */
	EAttribute getArtifact_Uri();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Artifact#isDerived <em>Derived</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Derived</em>'.
	 * @see de.urszeidler.eclipse.callchain.Artifact#isDerived()
	 * @see #getArtifact()
	 * @generated
	 */
	EAttribute getArtifact_Derived();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.MMAlias <em>MM Alias</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MM Alias</em>'.
	 * @see de.urszeidler.eclipse.callchain.MMAlias
	 * @generated
	 */
	EClass getMMAlias();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.MMAlias#getDecoratedmodel <em>Decoratedmodel</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Decoratedmodel</em>'.
	 * @see de.urszeidler.eclipse.callchain.MMAlias#getDecoratedmodel()
	 * @see #getMMAlias()
	 * @generated
	 */
	EReference getMMAlias_Decoratedmodel();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.MMAlias#getAliasName <em>Alias Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Alias Name</em>'.
	 * @see de.urszeidler.eclipse.callchain.MMAlias#getAliasName()
	 * @see #getMMAlias()
	 * @generated
	 */
	EAttribute getMMAlias_AliasName();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Documentable <em>Documentable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Documentable</em>'.
	 * @see de.urszeidler.eclipse.callchain.Documentable
	 * @generated
	 */
	EClass getDocumentable();

	/**
	 * Returns the meta object for the containment reference list '{@link de.urszeidler.eclipse.callchain.Documentable#getComments <em>Comments</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Comments</em>'.
	 * @see de.urszeidler.eclipse.callchain.Documentable#getComments()
	 * @see #getDocumentable()
	 * @generated
	 */
	EReference getDocumentable_Comments();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Comment <em>Comment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Comment</em>'.
	 * @see de.urszeidler.eclipse.callchain.Comment
	 * @generated
	 */
	EClass getComment();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Comment#getDoc <em>Doc</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Doc</em>'.
	 * @see de.urszeidler.eclipse.callchain.Comment#getDoc()
	 * @see #getComment()
	 * @generated
	 */
	EAttribute getComment_Doc();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.Comment#getDocumentedElement <em>Documented Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Documented Element</em>'.
	 * @see de.urszeidler.eclipse.callchain.Comment#getDocumentedElement()
	 * @see #getComment()
	 * @generated
	 */
	EReference getComment_DocumentedElement();

	/**
	 * Returns the meta object for the container reference '{@link de.urszeidler.eclipse.callchain.Comment#getOwner <em>Owner</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Owner</em>'.
	 * @see de.urszeidler.eclipse.callchain.Comment#getOwner()
	 * @see #getComment()
	 * @generated
	 */
	EReference getComment_Owner();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Callable <em>Callable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Callable</em>'.
	 * @see de.urszeidler.eclipse.callchain.Callable
	 * @generated
	 */
	EClass getCallable();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.Callable#getNext <em>Next</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Next</em>'.
	 * @see de.urszeidler.eclipse.callchain.Callable#getNext()
	 * @see #getCallable()
	 * @generated
	 */
	EReference getCallable_Next();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Callable#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see de.urszeidler.eclipse.callchain.Callable#getName()
	 * @see #getCallable()
	 * @generated
	 */
	EAttribute getCallable_Name();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Callable#isRefreshWorkspace <em>Refresh Workspace</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Refresh Workspace</em>'.
	 * @see de.urszeidler.eclipse.callchain.Callable#isRefreshWorkspace()
	 * @see #getCallable()
	 * @generated
	 */
	EAttribute getCallable_RefreshWorkspace();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Generic_Generator <em>Generic Generator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Generic Generator</em>'.
	 * @see de.urszeidler.eclipse.callchain.Generic_Generator
	 * @generated
	 */
	EClass getGeneric_Generator();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Generic_Generator#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see de.urszeidler.eclipse.callchain.Generic_Generator#getId()
	 * @see #getGeneric_Generator()
	 * @generated
	 */
	EAttribute getGeneric_Generator_Id();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Generic_Generator#getGeneratorType <em>Generator Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Generator Type</em>'.
	 * @see de.urszeidler.eclipse.callchain.Generic_Generator#getGeneratorType()
	 * @see #getGeneric_Generator()
	 * @generated
	 */
	EAttribute getGeneric_Generator_GeneratorType();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Property <em>Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property</em>'.
	 * @see de.urszeidler.eclipse.callchain.Property
	 * @generated
	 */
	EClass getProperty();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Property#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see de.urszeidler.eclipse.callchain.Property#getName()
	 * @see #getProperty()
	 * @generated
	 */
	EAttribute getProperty_Name();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Property#getDefaultValue <em>Default Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Default Value</em>'.
	 * @see de.urszeidler.eclipse.callchain.Property#getDefaultValue()
	 * @see #getProperty()
	 * @generated
	 */
	EAttribute getProperty_DefaultValue();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Property#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see de.urszeidler.eclipse.callchain.Property#getValue()
	 * @see #getProperty()
	 * @generated
	 */
	EAttribute getProperty_Value();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Switch <em>Switch</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Switch</em>'.
	 * @see de.urszeidler.eclipse.callchain.Switch
	 * @generated
	 */
	EClass getSwitch();

	/**
	 * Returns the meta object for the reference list '{@link de.urszeidler.eclipse.callchain.Switch#getAllCallables <em>All Callables</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>All Callables</em>'.
	 * @see de.urszeidler.eclipse.callchain.Switch#getAllCallables()
	 * @see #getSwitch()
	 * @generated
	 */
	EReference getSwitch_AllCallables();

	/**
	 * Returns the meta object for the container reference '{@link de.urszeidler.eclipse.callchain.Switch#getEnviorment <em>Enviorment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Enviorment</em>'.
	 * @see de.urszeidler.eclipse.callchain.Switch#getEnviorment()
	 * @see #getSwitch()
	 * @generated
	 */
	EReference getSwitch_Enviorment();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.PredicateSwitch <em>Predicate Switch</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Predicate Switch</em>'.
	 * @see de.urszeidler.eclipse.callchain.PredicateSwitch
	 * @generated
	 */
	EClass getPredicateSwitch();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.PredicateSwitch#getTrueCallable <em>True Callable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>True Callable</em>'.
	 * @see de.urszeidler.eclipse.callchain.PredicateSwitch#getTrueCallable()
	 * @see #getPredicateSwitch()
	 * @generated
	 */
	EReference getPredicateSwitch_TrueCallable();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.PredicateSwitch#getFalseCallable <em>False Callable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>False Callable</em>'.
	 * @see de.urszeidler.eclipse.callchain.PredicateSwitch#getFalseCallable()
	 * @see #getPredicateSwitch()
	 * @generated
	 */
	EReference getPredicateSwitch_FalseCallable();

	/**
	 * Returns the meta object for the containment reference '{@link de.urszeidler.eclipse.callchain.PredicateSwitch#getPredicate <em>Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Predicate</em>'.
	 * @see de.urszeidler.eclipse.callchain.PredicateSwitch#getPredicate()
	 * @see #getPredicateSwitch()
	 * @generated
	 */
	EReference getPredicateSwitch_Predicate();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.NamedSwitch <em>Named Switch</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Named Switch</em>'.
	 * @see de.urszeidler.eclipse.callchain.NamedSwitch
	 * @generated
	 */
	EClass getNamedSwitch();

	/**
	 * Returns the meta object for the containment reference list '{@link de.urszeidler.eclipse.callchain.NamedSwitch#getTransitions <em>Transitions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Transitions</em>'.
	 * @see de.urszeidler.eclipse.callchain.NamedSwitch#getTransitions()
	 * @see #getNamedSwitch()
	 * @generated
	 */
	EReference getNamedSwitch_Transitions();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.NamedSwitch#getDefaultCall <em>Default Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Default Call</em>'.
	 * @see de.urszeidler.eclipse.callchain.NamedSwitch#getDefaultCall()
	 * @see #getNamedSwitch()
	 * @generated
	 */
	EReference getNamedSwitch_DefaultCall();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Transition <em>Transition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Transition</em>'.
	 * @see de.urszeidler.eclipse.callchain.Transition
	 * @generated
	 */
	EClass getTransition();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.Transition#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see de.urszeidler.eclipse.callchain.Transition#getName()
	 * @see #getTransition()
	 * @generated
	 */
	EAttribute getTransition_Name();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.Transition#getCallable <em>Callable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Callable</em>'.
	 * @see de.urszeidler.eclipse.callchain.Transition#getCallable()
	 * @see #getTransition()
	 * @generated
	 */
	EReference getTransition_Callable();

	/**
	 * Returns the meta object for the container reference '{@link de.urszeidler.eclipse.callchain.Transition#getNamedSwitch <em>Named Switch</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Named Switch</em>'.
	 * @see de.urszeidler.eclipse.callchain.Transition#getNamedSwitch()
	 * @see #getTransition()
	 * @generated
	 */
	EReference getTransition_NamedSwitch();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Predicate <em>Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Predicate</em>'.
	 * @see de.urszeidler.eclipse.callchain.Predicate
	 * @generated
	 */
	EClass getPredicate();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.PropertyPredicate <em>Property Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Predicate</em>'.
	 * @see de.urszeidler.eclipse.callchain.PropertyPredicate
	 * @generated
	 */
	EClass getPropertyPredicate();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.PropertyHasValue <em>Property Has Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Has Value</em>'.
	 * @see de.urszeidler.eclipse.callchain.PropertyHasValue
	 * @generated
	 */
	EClass getPropertyHasValue();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.PropertyHasValue#getProperty <em>Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Property</em>'.
	 * @see de.urszeidler.eclipse.callchain.PropertyHasValue#getProperty()
	 * @see #getPropertyHasValue()
	 * @generated
	 */
	EReference getPropertyHasValue_Property();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.PropertyHasValue#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see de.urszeidler.eclipse.callchain.PropertyHasValue#getValue()
	 * @see #getPropertyHasValue()
	 * @generated
	 */
	EAttribute getPropertyHasValue_Value();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.PropertyExist <em>Property Exist</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Exist</em>'.
	 * @see de.urszeidler.eclipse.callchain.PropertyExist
	 * @generated
	 */
	EClass getPropertyExist();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.PropertyExist#getPropertyName <em>Property Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Property Name</em>'.
	 * @see de.urszeidler.eclipse.callchain.PropertyExist#getPropertyName()
	 * @see #getPropertyExist()
	 * @generated
	 */
	EAttribute getPropertyExist_PropertyName();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.ResourcePredicate <em>Resource Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Resource Predicate</em>'.
	 * @see de.urszeidler.eclipse.callchain.ResourcePredicate
	 * @generated
	 */
	EClass getResourcePredicate();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.ResourcePredicate#getResource <em>Resource</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Resource</em>'.
	 * @see de.urszeidler.eclipse.callchain.ResourcePredicate#getResource()
	 * @see #getResourcePredicate()
	 * @generated
	 */
	EReference getResourcePredicate_Resource();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.ResourceExistPredicate <em>Resource Exist Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Resource Exist Predicate</em>'.
	 * @see de.urszeidler.eclipse.callchain.ResourceExistPredicate
	 * @generated
	 */
	EClass getResourceExistPredicate();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.CompositePredicate <em>Composite Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Composite Predicate</em>'.
	 * @see de.urszeidler.eclipse.callchain.CompositePredicate
	 * @generated
	 */
	EClass getCompositePredicate();

	/**
	 * Returns the meta object for the containment reference list '{@link de.urszeidler.eclipse.callchain.CompositePredicate#getPredicates <em>Predicates</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Predicates</em>'.
	 * @see de.urszeidler.eclipse.callchain.CompositePredicate#getPredicates()
	 * @see #getCompositePredicate()
	 * @generated
	 */
	EReference getCompositePredicate_Predicates();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.AndPredicate <em>And Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>And Predicate</em>'.
	 * @see de.urszeidler.eclipse.callchain.AndPredicate
	 * @generated
	 */
	EClass getAndPredicate();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.OrPredicate <em>Or Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Or Predicate</em>'.
	 * @see de.urszeidler.eclipse.callchain.OrPredicate
	 * @generated
	 */
	EClass getOrPredicate();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.NotPredicate <em>Not Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Not Predicate</em>'.
	 * @see de.urszeidler.eclipse.callchain.NotPredicate
	 * @generated
	 */
	EClass getNotPredicate();

	/**
	 * Returns the meta object for the containment reference '{@link de.urszeidler.eclipse.callchain.NotPredicate#getPredicate <em>Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Predicate</em>'.
	 * @see de.urszeidler.eclipse.callchain.NotPredicate#getPredicate()
	 * @see #getNotPredicate()
	 * @generated
	 */
	EReference getNotPredicate_Predicate();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.PropertyValueSwitch <em>Property Value Switch</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Value Switch</em>'.
	 * @see de.urszeidler.eclipse.callchain.PropertyValueSwitch
	 * @generated
	 */
	EClass getPropertyValueSwitch();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.PropertyValueSwitch#getProperty <em>Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Property</em>'.
	 * @see de.urszeidler.eclipse.callchain.PropertyValueSwitch#getProperty()
	 * @see #getPropertyValueSwitch()
	 * @generated
	 */
	EReference getPropertyValueSwitch_Property();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.ExternalCallable <em>External Callable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>External Callable</em>'.
	 * @see de.urszeidler.eclipse.callchain.ExternalCallable
	 * @generated
	 */
	EClass getExternalCallable();

	/**
	 * Returns the meta object for the reference '{@link de.urszeidler.eclipse.callchain.ExternalCallable#getDelegatedCallable <em>Delegated Callable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Delegated Callable</em>'.
	 * @see de.urszeidler.eclipse.callchain.ExternalCallable#getDelegatedCallable()
	 * @see #getExternalCallable()
	 * @generated
	 */
	EReference getExternalCallable_DelegatedCallable();

	/**
	 * Returns the meta object for the container reference '{@link de.urszeidler.eclipse.callchain.ExternalCallable#getEnviorment <em>Enviorment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Enviorment</em>'.
	 * @see de.urszeidler.eclipse.callchain.ExternalCallable#getEnviorment()
	 * @see #getExternalCallable()
	 * @generated
	 */
	EReference getExternalCallable_Enviorment();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.StopCall <em>Stop Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Stop Call</em>'.
	 * @see de.urszeidler.eclipse.callchain.StopCall
	 * @generated
	 */
	EClass getStopCall();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.BooleanPredicate <em>Boolean Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Boolean Predicate</em>'.
	 * @see de.urszeidler.eclipse.callchain.BooleanPredicate
	 * @generated
	 */
	EClass getBooleanPredicate();

	/**
	 * Returns the meta object for the attribute '{@link de.urszeidler.eclipse.callchain.BooleanPredicate#isValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see de.urszeidler.eclipse.callchain.BooleanPredicate#isValue()
	 * @see #getBooleanPredicate()
	 * @generated
	 */
	EAttribute getBooleanPredicate_Value();

	/**
	 * Returns the meta object for class '{@link de.urszeidler.eclipse.callchain.Eavaluateable <em>Eavaluateable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Eavaluateable</em>'.
	 * @see de.urszeidler.eclipse.callchain.Eavaluateable
	 * @generated
	 */
	EClass getEavaluateable();

	/**
	 * Returns the meta object for the containment reference '{@link de.urszeidler.eclipse.callchain.Eavaluateable#getPredicate <em>Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Predicate</em>'.
	 * @see de.urszeidler.eclipse.callchain.Eavaluateable#getPredicate()
	 * @see #getEavaluateable()
	 * @generated
	 */
	EReference getEavaluateable_Predicate();

	/**
	 * Returns the meta object for enum '{@link de.urszeidler.eclipse.callchain.MMhandler <em>MMhandler</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>MMhandler</em>'.
	 * @see de.urszeidler.eclipse.callchain.MMhandler
	 * @generated
	 */
	EEnum getMMhandler();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	CallchainFactory getCallchainFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.ModelImpl <em>Model</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.ModelImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getModel()
		 * @generated
		 */
		EClass MODEL = eINSTANCE.getModel();

		/**
		 * The meta object literal for the '<em><b>Mm</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL__MM = eINSTANCE.getModel_Mm();

		/**
		 * The meta object literal for the '<em><b>Is Temporary</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL__IS_TEMPORARY = eINSTANCE.getModel_IsTemporary();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.AtlResImpl <em>Atl Res</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.AtlResImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getAtlRes()
		 * @generated
		 */
		EClass ATL_RES = eINSTANCE.getAtlRes();

		/**
		 * The meta object literal for the '<em><b>Superimpose</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ATL_RES__SUPERIMPOSE = eINSTANCE.getAtlRes_Superimpose();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.CallImpl <em>Call</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.CallImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getCall()
		 * @generated
		 */
		EClass CALL = eINSTANCE.getCall();

		/**
		 * The meta object literal for the '<em><b>In</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALL__IN = eINSTANCE.getCall_In();

		/**
		 * The meta object literal for the '<em><b>Out</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALL__OUT = eINSTANCE.getCall_Out();

		/**
		 * The meta object literal for the '<em><b>Res</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALL__RES = eINSTANCE.getCall_Res();

		/**
		 * The meta object literal for the '<em><b>Libarys</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALL__LIBARYS = eINSTANCE.getCall_Libarys();

		/**
		 * The meta object literal for the '<em><b>Allow Inter Model References</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALL__ALLOW_INTER_MODEL_REFERENCES = eINSTANCE.getCall_AllowInterModelReferences();

		/**
		 * The meta object literal for the '<em><b>Continue After Errors</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALL__CONTINUE_AFTER_ERRORS = eINSTANCE.getCall_ContinueAfterErrors();

		/**
		 * The meta object literal for the '<em><b>Artifact</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALL__ARTIFACT = eINSTANCE.getCall_Artifact();

		/**
		 * The meta object literal for the '<em><b>Enviorment</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALL__ENVIORMENT = eINSTANCE.getCall_Enviorment();

		/**
		 * The meta object literal for the '<em><b>Show Summary</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALL__SHOW_SUMMARY = eINSTANCE.getCall_ShowSummary();

		/**
		 * The meta object literal for the '<em><b>Print Execution Time</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALL__PRINT_EXECUTION_TIME = eINSTANCE.getCall_PrintExecutionTime();

		/**
		 * The meta object literal for the '<em><b>Disable Attribute Helper Cache</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALL__DISABLE_ATTRIBUTE_HELPER_CACHE = eINSTANCE.getCall_DisableAttributeHelperCache();

		/**
		 * The meta object literal for the '<em><b>Profile</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALL__PROFILE = eINSTANCE.getCall_Profile();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.MMImpl <em>MM</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.MMImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getMM()
		 * @generated
		 */
		EClass MM = eINSTANCE.getMM();

		/**
		 * The meta object literal for the '<em><b>Handler</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MM__HANDLER = eINSTANCE.getMM_Handler();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.CallsImpl <em>Calls</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.CallsImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getCalls()
		 * @generated
		 */
		EClass CALLS = eINSTANCE.getCalls();

		/**
		 * The meta object literal for the '<em><b>Call</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLS__CALL = eINSTANCE.getCalls_Call();

		/**
		 * The meta object literal for the '<em><b>Generators</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLS__GENERATORS = eINSTANCE.getCalls_Generators();

		/**
		 * The meta object literal for the '<em><b>Artifacts</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLS__ARTIFACTS = eINSTANCE.getCalls_Artifacts();

		/**
		 * The meta object literal for the '<em><b>Properties</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLS__PROPERTIES = eINSTANCE.getCalls_Properties();

		/**
		 * The meta object literal for the '<em><b>Default Lib</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLS__DEFAULT_LIB = eINSTANCE.getCalls_DefaultLib();

		/**
		 * The meta object literal for the '<em><b>Default Super Imposed</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLS__DEFAULT_SUPER_IMPOSED = eINSTANCE.getCalls_DefaultSuperImposed();

		/**
		 * The meta object literal for the '<em><b>Start Points</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLS__START_POINTS = eINSTANCE.getCalls_StartPoints();

		/**
		 * The meta object literal for the '<em><b>Default Start Point</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLS__DEFAULT_START_POINT = eINSTANCE.getCalls_DefaultStartPoint();

		/**
		 * The meta object literal for the '<em><b>Log Default</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALLS__LOG_DEFAULT = eINSTANCE.getCalls_LogDefault();

		/**
		 * The meta object literal for the '<em><b>Switches</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLS__SWITCHES = eINSTANCE.getCalls_Switches();

		/**
		 * The meta object literal for the '<em><b>Extern Callables</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLS__EXTERN_CALLABLES = eINSTANCE.getCalls_ExternCallables();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALLS__NAME = eINSTANCE.getCalls_Name();

		/**
		 * The meta object literal for the '<em><b>Stop Elements</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLS__STOP_ELEMENTS = eINSTANCE.getCalls_StopElements();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.AtlLibaryImpl <em>Atl Libary</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.AtlLibaryImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getAtlLibary()
		 * @generated
		 */
		EClass ATL_LIBARY = eINSTANCE.getAtlLibary();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.ModelAliasImpl <em>Model Alias</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.ModelAliasImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getModelAlias()
		 * @generated
		 */
		EClass MODEL_ALIAS = eINSTANCE.getModelAlias();

		/**
		 * The meta object literal for the '<em><b>Decoratedmodel</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_ALIAS__DECORATEDMODEL = eINSTANCE.getModelAlias_Decoratedmodel();

		/**
		 * The meta object literal for the '<em><b>Alias Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL_ALIAS__ALIAS_NAME = eINSTANCE.getModelAlias_AliasName();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.GeneratorImpl <em>Generator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.GeneratorImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getGenerator()
		 * @generated
		 */
		EClass GENERATOR = eINSTANCE.getGenerator();

		/**
		 * The meta object literal for the '<em><b>Uses</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GENERATOR__USES = eINSTANCE.getGenerator_Uses();

		/**
		 * The meta object literal for the '<em><b>Produce</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GENERATOR__PRODUCE = eINSTANCE.getGenerator_Produce();

		/**
		 * The meta object literal for the '<em><b>Enviorment</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GENERATOR__ENVIORMENT = eINSTANCE.getGenerator_Enviorment();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.ArtifactImpl <em>Artifact</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.ArtifactImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getArtifact()
		 * @generated
		 */
		EClass ARTIFACT = eINSTANCE.getArtifact();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ARTIFACT__NAME = eINSTANCE.getArtifact_Name();

		/**
		 * The meta object literal for the '<em><b>Uri</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ARTIFACT__URI = eINSTANCE.getArtifact_Uri();

		/**
		 * The meta object literal for the '<em><b>Derived</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ARTIFACT__DERIVED = eINSTANCE.getArtifact_Derived();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.MMAliasImpl <em>MM Alias</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.MMAliasImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getMMAlias()
		 * @generated
		 */
		EClass MM_ALIAS = eINSTANCE.getMMAlias();

		/**
		 * The meta object literal for the '<em><b>Decoratedmodel</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MM_ALIAS__DECORATEDMODEL = eINSTANCE.getMMAlias_Decoratedmodel();

		/**
		 * The meta object literal for the '<em><b>Alias Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MM_ALIAS__ALIAS_NAME = eINSTANCE.getMMAlias_AliasName();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.Documentable <em>Documentable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.Documentable
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getDocumentable()
		 * @generated
		 */
		EClass DOCUMENTABLE = eINSTANCE.getDocumentable();

		/**
		 * The meta object literal for the '<em><b>Comments</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENTABLE__COMMENTS = eINSTANCE.getDocumentable_Comments();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.CommentImpl <em>Comment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.CommentImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getComment()
		 * @generated
		 */
		EClass COMMENT = eINSTANCE.getComment();

		/**
		 * The meta object literal for the '<em><b>Doc</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COMMENT__DOC = eINSTANCE.getComment_Doc();

		/**
		 * The meta object literal for the '<em><b>Documented Element</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMMENT__DOCUMENTED_ELEMENT = eINSTANCE.getComment_DocumentedElement();

		/**
		 * The meta object literal for the '<em><b>Owner</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMMENT__OWNER = eINSTANCE.getComment_Owner();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.Callable <em>Callable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.Callable
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getCallable()
		 * @generated
		 */
		EClass CALLABLE = eINSTANCE.getCallable();

		/**
		 * The meta object literal for the '<em><b>Next</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CALLABLE__NEXT = eINSTANCE.getCallable_Next();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALLABLE__NAME = eINSTANCE.getCallable_Name();

		/**
		 * The meta object literal for the '<em><b>Refresh Workspace</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CALLABLE__REFRESH_WORKSPACE = eINSTANCE.getCallable_RefreshWorkspace();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.Generic_GeneratorImpl <em>Generic Generator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.Generic_GeneratorImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getGeneric_Generator()
		 * @generated
		 */
		EClass GENERIC_GENERATOR = eINSTANCE.getGeneric_Generator();

		/**
		 * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute GENERIC_GENERATOR__ID = eINSTANCE.getGeneric_Generator_Id();

		/**
		 * The meta object literal for the '<em><b>Generator Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute GENERIC_GENERATOR__GENERATOR_TYPE = eINSTANCE.getGeneric_Generator_GeneratorType();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.PropertyImpl <em>Property</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.PropertyImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getProperty()
		 * @generated
		 */
		EClass PROPERTY = eINSTANCE.getProperty();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY__NAME = eINSTANCE.getProperty_Name();

		/**
		 * The meta object literal for the '<em><b>Default Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY__DEFAULT_VALUE = eINSTANCE.getProperty_DefaultValue();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY__VALUE = eINSTANCE.getProperty_Value();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.SwitchImpl <em>Switch</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.SwitchImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getSwitch()
		 * @generated
		 */
		EClass SWITCH = eINSTANCE.getSwitch();

		/**
		 * The meta object literal for the '<em><b>All Callables</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SWITCH__ALL_CALLABLES = eINSTANCE.getSwitch_AllCallables();

		/**
		 * The meta object literal for the '<em><b>Enviorment</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SWITCH__ENVIORMENT = eINSTANCE.getSwitch_Enviorment();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.PredicateSwitchImpl <em>Predicate Switch</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.PredicateSwitchImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getPredicateSwitch()
		 * @generated
		 */
		EClass PREDICATE_SWITCH = eINSTANCE.getPredicateSwitch();

		/**
		 * The meta object literal for the '<em><b>True Callable</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PREDICATE_SWITCH__TRUE_CALLABLE = eINSTANCE.getPredicateSwitch_TrueCallable();

		/**
		 * The meta object literal for the '<em><b>False Callable</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PREDICATE_SWITCH__FALSE_CALLABLE = eINSTANCE.getPredicateSwitch_FalseCallable();

		/**
		 * The meta object literal for the '<em><b>Predicate</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PREDICATE_SWITCH__PREDICATE = eINSTANCE.getPredicateSwitch_Predicate();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.NamedSwitchImpl <em>Named Switch</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.NamedSwitchImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getNamedSwitch()
		 * @generated
		 */
		EClass NAMED_SWITCH = eINSTANCE.getNamedSwitch();

		/**
		 * The meta object literal for the '<em><b>Transitions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NAMED_SWITCH__TRANSITIONS = eINSTANCE.getNamedSwitch_Transitions();

		/**
		 * The meta object literal for the '<em><b>Default Call</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NAMED_SWITCH__DEFAULT_CALL = eINSTANCE.getNamedSwitch_DefaultCall();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.TransitionImpl <em>Transition</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.TransitionImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getTransition()
		 * @generated
		 */
		EClass TRANSITION = eINSTANCE.getTransition();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TRANSITION__NAME = eINSTANCE.getTransition_Name();

		/**
		 * The meta object literal for the '<em><b>Callable</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TRANSITION__CALLABLE = eINSTANCE.getTransition_Callable();

		/**
		 * The meta object literal for the '<em><b>Named Switch</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TRANSITION__NAMED_SWITCH = eINSTANCE.getTransition_NamedSwitch();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.Predicate <em>Predicate</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.Predicate
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getPredicate()
		 * @generated
		 */
		EClass PREDICATE = eINSTANCE.getPredicate();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.PropertyPredicateImpl <em>Property Predicate</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.PropertyPredicateImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getPropertyPredicate()
		 * @generated
		 */
		EClass PROPERTY_PREDICATE = eINSTANCE.getPropertyPredicate();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.PropertyHasValueImpl <em>Property Has Value</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.PropertyHasValueImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getPropertyHasValue()
		 * @generated
		 */
		EClass PROPERTY_HAS_VALUE = eINSTANCE.getPropertyHasValue();

		/**
		 * The meta object literal for the '<em><b>Property</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROPERTY_HAS_VALUE__PROPERTY = eINSTANCE.getPropertyHasValue_Property();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY_HAS_VALUE__VALUE = eINSTANCE.getPropertyHasValue_Value();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.PropertyExistImpl <em>Property Exist</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.PropertyExistImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getPropertyExist()
		 * @generated
		 */
		EClass PROPERTY_EXIST = eINSTANCE.getPropertyExist();

		/**
		 * The meta object literal for the '<em><b>Property Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY_EXIST__PROPERTY_NAME = eINSTANCE.getPropertyExist_PropertyName();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.ResourcePredicateImpl <em>Resource Predicate</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.ResourcePredicateImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getResourcePredicate()
		 * @generated
		 */
		EClass RESOURCE_PREDICATE = eINSTANCE.getResourcePredicate();

		/**
		 * The meta object literal for the '<em><b>Resource</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RESOURCE_PREDICATE__RESOURCE = eINSTANCE.getResourcePredicate_Resource();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.ResourceExistPredicateImpl <em>Resource Exist Predicate</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.ResourceExistPredicateImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getResourceExistPredicate()
		 * @generated
		 */
		EClass RESOURCE_EXIST_PREDICATE = eINSTANCE.getResourceExistPredicate();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.CompositePredicateImpl <em>Composite Predicate</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.CompositePredicateImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getCompositePredicate()
		 * @generated
		 */
		EClass COMPOSITE_PREDICATE = eINSTANCE.getCompositePredicate();

		/**
		 * The meta object literal for the '<em><b>Predicates</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPOSITE_PREDICATE__PREDICATES = eINSTANCE.getCompositePredicate_Predicates();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.AndPredicateImpl <em>And Predicate</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.AndPredicateImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getAndPredicate()
		 * @generated
		 */
		EClass AND_PREDICATE = eINSTANCE.getAndPredicate();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.OrPredicateImpl <em>Or Predicate</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.OrPredicateImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getOrPredicate()
		 * @generated
		 */
		EClass OR_PREDICATE = eINSTANCE.getOrPredicate();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.NotPredicateImpl <em>Not Predicate</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.NotPredicateImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getNotPredicate()
		 * @generated
		 */
		EClass NOT_PREDICATE = eINSTANCE.getNotPredicate();

		/**
		 * The meta object literal for the '<em><b>Predicate</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NOT_PREDICATE__PREDICATE = eINSTANCE.getNotPredicate_Predicate();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.PropertyValueSwitchImpl <em>Property Value Switch</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.PropertyValueSwitchImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getPropertyValueSwitch()
		 * @generated
		 */
		EClass PROPERTY_VALUE_SWITCH = eINSTANCE.getPropertyValueSwitch();

		/**
		 * The meta object literal for the '<em><b>Property</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROPERTY_VALUE_SWITCH__PROPERTY = eINSTANCE.getPropertyValueSwitch_Property();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.ExternalCallableImpl <em>External Callable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.ExternalCallableImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getExternalCallable()
		 * @generated
		 */
		EClass EXTERNAL_CALLABLE = eINSTANCE.getExternalCallable();

		/**
		 * The meta object literal for the '<em><b>Delegated Callable</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EXTERNAL_CALLABLE__DELEGATED_CALLABLE = eINSTANCE.getExternalCallable_DelegatedCallable();

		/**
		 * The meta object literal for the '<em><b>Enviorment</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EXTERNAL_CALLABLE__ENVIORMENT = eINSTANCE.getExternalCallable_Enviorment();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.StopCallImpl <em>Stop Call</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.StopCallImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getStopCall()
		 * @generated
		 */
		EClass STOP_CALL = eINSTANCE.getStopCall();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.impl.BooleanPredicateImpl <em>Boolean Predicate</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.impl.BooleanPredicateImpl
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getBooleanPredicate()
		 * @generated
		 */
		EClass BOOLEAN_PREDICATE = eINSTANCE.getBooleanPredicate();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BOOLEAN_PREDICATE__VALUE = eINSTANCE.getBooleanPredicate_Value();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.Eavaluateable <em>Eavaluateable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.Eavaluateable
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getEavaluateable()
		 * @generated
		 */
		EClass EAVALUATEABLE = eINSTANCE.getEavaluateable();

		/**
		 * The meta object literal for the '<em><b>Predicate</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EAVALUATEABLE__PREDICATE = eINSTANCE.getEavaluateable_Predicate();

		/**
		 * The meta object literal for the '{@link de.urszeidler.eclipse.callchain.MMhandler <em>MMhandler</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.urszeidler.eclipse.callchain.MMhandler
		 * @see de.urszeidler.eclipse.callchain.impl.CallchainPackageImpl#getMMhandler()
		 * @generated
		 */
		EEnum MMHANDLER = eINSTANCE.getMMhandler();

	}

} //CallchainPackage
