/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.components;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.BasicDiagnostic;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.WrappedException;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.util.Diagnostician;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.context.PropertiesEditingContext;
import org.eclipse.emf.eef.runtime.impl.components.SinglePartPropertiesEditingComponent;
import org.eclipse.emf.eef.runtime.impl.utils.EEFConverterUtil;

import de.urszeidler.eclipse.callchain.Artifact;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.parts.ArtifactPropertiesEditionPart;
import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;


/**
 * @author Urs Zeidler
 * @generated
 */
public class ArtifactPropertiesEditionComponent extends SinglePartPropertiesEditingComponent {

	/**
	 * @generated
	 */
	
	public static String BASE_PART = "Base"; //$NON-NLS-1$

	
	/**
	 * Default constructor
	 * @generated
	 */
	public ArtifactPropertiesEditionComponent(PropertiesEditingContext editingContext, EObject artifact, String editing_mode) {
    super(editingContext, artifact, editing_mode);
    parts = new String[] { BASE_PART };
    repositoryKey = CallchainViewsRepository.class;
    partKey = CallchainViewsRepository.Artifact.class;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#initPart(java.lang.Object, int, org.eclipse.emf.ecore.EObject, 
	 *      org.eclipse.emf.ecore.resource.ResourceSet)
	 * @generated
	 */
	public void initPart(Object key, int kind, EObject elt, ResourceSet allResource) {
    setInitializing(true);
    if (editingPart != null && key == partKey) {
      editingPart.setContext(elt, allResource);
      final Artifact artifact = (Artifact)elt;
      final ArtifactPropertiesEditionPart basePart = (ArtifactPropertiesEditionPart)editingPart;
      // init values
      if (artifact.getName() != null && isAccessible(CallchainViewsRepository.Artifact.Properties.name))
        basePart.setName(EEFConverterUtil.convertToString(EcorePackage.eINSTANCE.getEString(), artifact.getName()));
      
        if (artifact.getUri() != null && isAccessible(CallchainViewsRepository.Artifact.Properties.uri)) {
          basePart.setUri(EEFConverterUtil.convertToString(CallchainPackage.eINSTANCE.getArtifact_Uri().getEAttributeType(), artifact.getUri()));
        }
      
      if (isAccessible(CallchainViewsRepository.Artifact.Properties.derived)) {
        basePart.setDerived(artifact.isDerived());
      }
      // init filters
      
      
      
      // init values for referenced views
      
      // init filters for referenced views
      
    }
    setInitializing(false);
  }






	/**
   * {@inheritDoc}
   * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#associatedFeature(java.lang.Object)
   */
  public EStructuralFeature associatedFeature(Object editorKey) {
    if (editorKey == CallchainViewsRepository.Artifact.Properties.name) {
      return CallchainPackage.eINSTANCE.getArtifact_Name();
    }
    if (editorKey == CallchainViewsRepository.Artifact.Properties.uri) {
      return CallchainPackage.eINSTANCE.getArtifact_Uri();
    }
    if (editorKey == CallchainViewsRepository.Artifact.Properties.derived) {
      return CallchainPackage.eINSTANCE.getArtifact_Derived();
    }
    return super.associatedFeature(editorKey);
  }

  /**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updateSemanticModel(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void updateSemanticModel(final IPropertiesEditionEvent event) {
    Artifact artifact = (Artifact)semanticObject;
    if (CallchainViewsRepository.Artifact.Properties.name == event.getAffectedEditor()) {
      artifact.setName((java.lang.String)EEFConverterUtil.createFromString(EcorePackage.eINSTANCE.getEString(), (String)event.getNewValue()));
    }
    if (CallchainViewsRepository.Artifact.Properties.uri == event.getAffectedEditor()) {
      artifact.setUri((String)event.getNewValue());
    }
    if (CallchainViewsRepository.Artifact.Properties.derived == event.getAffectedEditor()) {
      artifact.setDerived((Boolean)event.getNewValue());
    }
  }

	/**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updatePart(org.eclipse.emf.common.notify.Notification)
	 */
	public void updatePart(Notification msg) {
		if (editingPart.isVisible()) {	
			ArtifactPropertiesEditionPart basePart = (ArtifactPropertiesEditionPart)editingPart;
			if (CallchainPackage.eINSTANCE.getArtifact_Name().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Artifact.Properties.name)) {
				if (msg.getNewValue() != null) {
					basePart.setName(EcoreUtil.convertToString(EcorePackage.eINSTANCE.getEString(), msg.getNewValue()));
				} else {
					basePart.setName("");
				}
			}
			if (CallchainPackage.eINSTANCE.getArtifact_Uri().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Artifact.Properties.uri)) {
				if (msg.getNewValue() != null) {
					basePart.setUri(EcoreUtil.convertToString(CallchainPackage.eINSTANCE.getArtifact_Uri().getEAttributeType(), msg.getNewValue()));
				} else {
					basePart.setUri("");
				}
			}
			if (CallchainPackage.eINSTANCE.getArtifact_Derived().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Artifact.Properties.derived))
				basePart.setDerived((Boolean)msg.getNewValue());
			
			
		}
	}


	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#isRequired(java.lang.Object, int)
	 * @generated
	 */
	public boolean isRequired(Object key, int kind) {
    return key == CallchainViewsRepository.Artifact.Properties.name || key == CallchainViewsRepository.Artifact.Properties.uri || key == CallchainViewsRepository.Artifact.Properties.derived;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#validateValue(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public Diagnostic validateValue(IPropertiesEditionEvent event) {
    Diagnostic ret = Diagnostic.OK_INSTANCE;
    if (event.getNewValue() != null) {
      try {
        if (CallchainViewsRepository.Artifact.Properties.name == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getArtifact_Name().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getArtifact_Name().getEAttributeType(), newValue);
        }
        if (CallchainViewsRepository.Artifact.Properties.uri == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getArtifact_Uri().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getArtifact_Uri().getEAttributeType(), newValue);
        }
        if (CallchainViewsRepository.Artifact.Properties.derived == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getArtifact_Derived().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getArtifact_Derived().getEAttributeType(), newValue);
        }
      } catch (IllegalArgumentException iae) {
        ret = BasicDiagnostic.toDiagnostic(iae);
      } catch (WrappedException we) {
        ret = BasicDiagnostic.toDiagnostic(we);
      }
    }
    return ret;
  }

}
