/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.components;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.BasicDiagnostic;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.WrappedException;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.util.Diagnostician;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.context.PropertiesEditingContext;
import org.eclipse.emf.eef.runtime.impl.components.SinglePartPropertiesEditingComponent;
import org.eclipse.emf.eef.runtime.impl.filters.EObjectFilter;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.utils.EEFConverterUtil;
import org.eclipse.emf.eef.runtime.ui.widgets.referencestable.ReferencesTableSettings;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;

import de.urszeidler.eclipse.callchain.AtlRes;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.parts.AtlResPropertiesEditionPart;
import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;


/**
 * @author Urs Zeidler
 * @generated
 */
public class AtlResPropertiesEditionComponent extends SinglePartPropertiesEditingComponent {

	/**
	 * @generated
	 */
	
	public static String BASE_PART = "Base"; //$NON-NLS-1$

	
	/**
	 * Settings for superimpose ReferencesTable
	 */
	private	ReferencesTableSettings superimposeSettings;
	
	/**
	 * Default constructor
	 * @generated
	 */
	public AtlResPropertiesEditionComponent(PropertiesEditingContext editingContext, EObject atlRes, String editing_mode) {
    super(editingContext, atlRes, editing_mode);
    parts = new String[] { BASE_PART };
    repositoryKey = CallchainViewsRepository.class;
    partKey = CallchainViewsRepository.AtlRes.class;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#initPart(java.lang.Object, int, org.eclipse.emf.ecore.EObject, 
	 *      org.eclipse.emf.ecore.resource.ResourceSet)
	 * @generated
	 */
	public void initPart(Object key, int kind, EObject elt, ResourceSet allResource) {
    setInitializing(true);
    if (editingPart != null && key == partKey) {
      editingPart.setContext(elt, allResource);
      final AtlRes atlRes = (AtlRes)elt;
      final AtlResPropertiesEditionPart basePart = (AtlResPropertiesEditionPart)editingPart;
      // init values
      if (atlRes.getName() != null && isAccessible(CallchainViewsRepository.AtlRes.Properties.name))
        basePart.setName(EEFConverterUtil.convertToString(EcorePackage.eINSTANCE.getEString(), atlRes.getName()));
      
        if (atlRes.getUri() != null && isAccessible(CallchainViewsRepository.AtlRes.Properties.uri)) {
          basePart.setUri(EEFConverterUtil.convertToString(CallchainPackage.eINSTANCE.getArtifact_Uri().getEAttributeType(), atlRes.getUri()));
        }
      
      if (isAccessible(CallchainViewsRepository.AtlRes.Properties.superimpose)) {
        superimposeSettings = new ReferencesTableSettings(atlRes, CallchainPackage.eINSTANCE.getAtlRes_Superimpose());
        basePart.initSuperimpose(superimposeSettings);
      }
      // init filters
      
      
      basePart.addFilterToSuperimpose(new ViewerFilter() {
      
        /**
         * {@inheritDoc}
         * 
         * @see org.eclipse.jface.viewers.ViewerFilter#select(org.eclipse.jface.viewers.Viewer, java.lang.Object, java.lang.Object)
         */
        public boolean select(Viewer viewer, Object parentElement, Object element) {
          if (element instanceof EObject)
            return (!basePart.isContainedInSuperimposeTable((EObject)element));
          return element instanceof Resource;
        }
      
      });
      basePart.addFilterToSuperimpose(new EObjectFilter(CallchainPackage.eINSTANCE.getAtlRes()));
      
      // init values for referenced views
      
      // init filters for referenced views
      
    }
    setInitializing(false);
  }






	/**
   * {@inheritDoc}
   * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#associatedFeature(java.lang.Object)
   */
  public EStructuralFeature associatedFeature(Object editorKey) {
    if (editorKey == CallchainViewsRepository.AtlRes.Properties.name) {
      return CallchainPackage.eINSTANCE.getArtifact_Name();
    }
    if (editorKey == CallchainViewsRepository.AtlRes.Properties.uri) {
      return CallchainPackage.eINSTANCE.getArtifact_Uri();
    }
    if (editorKey == CallchainViewsRepository.AtlRes.Properties.superimpose) {
      return CallchainPackage.eINSTANCE.getAtlRes_Superimpose();
    }
    return super.associatedFeature(editorKey);
  }

  /**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updateSemanticModel(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void updateSemanticModel(final IPropertiesEditionEvent event) {
    AtlRes atlRes = (AtlRes)semanticObject;
    if (CallchainViewsRepository.AtlRes.Properties.name == event.getAffectedEditor()) {
      atlRes.setName((java.lang.String)EEFConverterUtil.createFromString(EcorePackage.eINSTANCE.getEString(), (String)event.getNewValue()));
    }
    if (CallchainViewsRepository.AtlRes.Properties.uri == event.getAffectedEditor()) {
      atlRes.setUri((String)event.getNewValue());
    }
    if (CallchainViewsRepository.AtlRes.Properties.superimpose == event.getAffectedEditor()) {
      if (event.getKind() == PropertiesEditionEvent.ADD) {
        if (event.getNewValue() instanceof AtlRes) {
          superimposeSettings.addToReference((EObject) event.getNewValue());
        }
      } else if (event.getKind() == PropertiesEditionEvent.REMOVE) {
        superimposeSettings.removeFromReference((EObject) event.getNewValue());
      } else if (event.getKind() == PropertiesEditionEvent.MOVE) {
        superimposeSettings.move(event.getNewIndex(), (AtlRes) event.getNewValue());
      }
    }
  }

	/**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updatePart(org.eclipse.emf.common.notify.Notification)
	 */
	public void updatePart(Notification msg) {
		if (editingPart.isVisible()) {	
			AtlResPropertiesEditionPart basePart = (AtlResPropertiesEditionPart)editingPart;
			if (CallchainPackage.eINSTANCE.getArtifact_Name().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.AtlRes.Properties.name)) {
				if (msg.getNewValue() != null) {
					basePart.setName(EcoreUtil.convertToString(EcorePackage.eINSTANCE.getEString(), msg.getNewValue()));
				} else {
					basePart.setName("");
				}
			}
			if (CallchainPackage.eINSTANCE.getArtifact_Uri().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.AtlRes.Properties.uri)) {
				if (msg.getNewValue() != null) {
					basePart.setUri(EcoreUtil.convertToString(CallchainPackage.eINSTANCE.getArtifact_Uri().getEAttributeType(), msg.getNewValue()));
				} else {
					basePart.setUri("");
				}
			}
			if (CallchainPackage.eINSTANCE.getAtlRes_Superimpose().equals(msg.getFeature())  && isAccessible(CallchainViewsRepository.AtlRes.Properties.superimpose))
				basePart.updateSuperimpose();
			
		}
	}


	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#isRequired(java.lang.Object, int)
	 * @generated
	 */
	public boolean isRequired(Object key, int kind) {
    return key == CallchainViewsRepository.AtlRes.Properties.name || key == CallchainViewsRepository.AtlRes.Properties.uri;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#validateValue(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public Diagnostic validateValue(IPropertiesEditionEvent event) {
    Diagnostic ret = Diagnostic.OK_INSTANCE;
    if (event.getNewValue() != null) {
      try {
        if (CallchainViewsRepository.AtlRes.Properties.name == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getArtifact_Name().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getArtifact_Name().getEAttributeType(), newValue);
        }
        if (CallchainViewsRepository.AtlRes.Properties.uri == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getArtifact_Uri().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getArtifact_Uri().getEAttributeType(), newValue);
        }
      } catch (IllegalArgumentException iae) {
        ret = BasicDiagnostic.toDiagnostic(iae);
      } catch (WrappedException we) {
        ret = BasicDiagnostic.toDiagnostic(we);
      }
    }
    return ret;
  }

}
