/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.components;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.BasicDiagnostic;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.WrappedException;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.util.Diagnostician;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.context.PropertiesEditingContext;
import org.eclipse.emf.eef.runtime.context.impl.EReferencePropertiesEditionContext;
import org.eclipse.emf.eef.runtime.impl.components.SinglePartPropertiesEditingComponent;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.utils.EEFConverterUtil;
import org.eclipse.emf.eef.runtime.policies.PropertiesEditingPolicy;
import org.eclipse.emf.eef.runtime.policies.impl.CreateEditingPolicy;
import org.eclipse.emf.eef.runtime.providers.PropertiesEditingProvider;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;

import de.urszeidler.eclipse.callchain.Callable;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.ExternalCallable;
import de.urszeidler.eclipse.callchain.Predicate;
import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.ExternalCallablePropertiesEditionPart;


/**
 * @author Urs Zeidler
 * @generated
 */
public class ExternalCallablePropertiesEditionComponent extends SinglePartPropertiesEditingComponent {

	/**
	 * @generated
	 */
	
	public static String BASE_PART = "Base"; //$NON-NLS-1$

	
	/**
	 * Settings for delegatedCallable EObjectFlatComboViewer
	 */
	private	EObjectFlatComboSettings delegatedCallableSettings;
	
	/**
   * Settings for predicate EObjectFlatComboViewer
   */
  private	EObjectFlatComboSettings predicateSettings;

  /**
	 * Default constructor
	 * @generated
	 */
	public ExternalCallablePropertiesEditionComponent(PropertiesEditingContext editingContext, EObject externalCallable, String editing_mode) {
    super(editingContext, externalCallable, editing_mode);
    parts = new String[] { BASE_PART };
    repositoryKey = CallchainViewsRepository.class;
    partKey = CallchainViewsRepository.ExternalCallable.class;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#initPart(java.lang.Object, int, org.eclipse.emf.ecore.EObject, 
	 *      org.eclipse.emf.ecore.resource.ResourceSet)
	 * @generated
	 */
	public void initPart(Object key, int kind, EObject elt, ResourceSet allResource) {
    setInitializing(true);
    if (editingPart != null && key == partKey) {
      editingPart.setContext(elt, allResource);
      final ExternalCallable externalCallable = (ExternalCallable)elt;
      final ExternalCallablePropertiesEditionPart basePart = (ExternalCallablePropertiesEditionPart)editingPart;
      // init values
      if (externalCallable.getName() != null && isAccessible(CallchainViewsRepository.ExternalCallable.Properties.name))
        basePart.setName(EEFConverterUtil.convertToString(EcorePackage.eINSTANCE.getEString(), externalCallable.getName()));
      
      if (isAccessible(CallchainViewsRepository.ExternalCallable.Properties.delegatedCallable)) {
        // init part
        delegatedCallableSettings = new EObjectFlatComboSettings(externalCallable, CallchainPackage.eINSTANCE.getExternalCallable_DelegatedCallable());
        basePart.initDelegatedCallable(delegatedCallableSettings);
        // set the button mode
        basePart.setDelegatedCallableButtonMode(ButtonsModeEnum.BROWSE);
      }
      if (isAccessible(CallchainViewsRepository.ExternalCallable.Properties.refreshWorkspace)) {
        basePart.setRefreshWorkspace(externalCallable.isRefreshWorkspace());
      }
      if (isAccessible(CallchainViewsRepository.ExternalCallable.Properties.predicate)) {
        // init part
        predicateSettings = new EObjectFlatComboSettings(externalCallable, CallchainPackage.eINSTANCE.getEavaluateable_Predicate());
        basePart.initPredicate(predicateSettings);
        // set the button mode
        basePart.setPredicateButtonMode(ButtonsModeEnum.CREATE);
      }
      // init filters
      
      basePart.addFilterToDelegatedCallable(new ViewerFilter() {
      
      /**
       * {@inheritDoc}
       * 
       * @see org.eclipse.jface.viewers.ViewerFilter#select(org.eclipse.jface.viewers.Viewer, java.lang.Object, java.lang.Object)
       */
      public boolean select(Viewer viewer, Object parentElement, Object element) {
        return (element instanceof Callable);
        }
      
      });
      
      
      
      // init values for referenced views
      
      // init filters for referenced views
      
    }
    setInitializing(false);
  }





	/**
   * {@inheritDoc}
   * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#associatedFeature(java.lang.Object)
   */
  public EStructuralFeature associatedFeature(Object editorKey) {
    if (editorKey == CallchainViewsRepository.ExternalCallable.Properties.name) {
      return CallchainPackage.eINSTANCE.getCallable_Name();
    }
    if (editorKey == CallchainViewsRepository.ExternalCallable.Properties.delegatedCallable) {
      return CallchainPackage.eINSTANCE.getExternalCallable_DelegatedCallable();
    }
    if (editorKey == CallchainViewsRepository.ExternalCallable.Properties.refreshWorkspace) {
      return CallchainPackage.eINSTANCE.getCallable_RefreshWorkspace();
    }
    if (editorKey == CallchainViewsRepository.ExternalCallable.Properties.predicate) {
      return CallchainPackage.eINSTANCE.getEavaluateable_Predicate();
    }
    return super.associatedFeature(editorKey);
  }

  /**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updateSemanticModel(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void updateSemanticModel(final IPropertiesEditionEvent event) {
    ExternalCallable externalCallable = (ExternalCallable)semanticObject;
    if (CallchainViewsRepository.ExternalCallable.Properties.name == event.getAffectedEditor()) {
      externalCallable.setName((java.lang.String)EEFConverterUtil.createFromString(EcorePackage.eINSTANCE.getEString(), (String)event.getNewValue()));
    }
    if (CallchainViewsRepository.ExternalCallable.Properties.delegatedCallable == event.getAffectedEditor()) {
      if (event.getKind() == PropertiesEditionEvent.SET) {
        delegatedCallableSettings.setToReference((Callable)event.getNewValue());
      } else if (event.getKind() == PropertiesEditionEvent.ADD) {
        EReferencePropertiesEditionContext context = new EReferencePropertiesEditionContext(editingContext, this, delegatedCallableSettings, editingContext.getAdapterFactory());
        PropertiesEditingProvider provider = (PropertiesEditingProvider)editingContext.getAdapterFactory().adapt(semanticObject, PropertiesEditingProvider.class);
        if (provider != null) {
          PropertiesEditingPolicy policy = provider.getPolicy(context);
          if (policy instanceof CreateEditingPolicy) {
            policy.execute();
          }
        }
      }
    }
    if (CallchainViewsRepository.ExternalCallable.Properties.refreshWorkspace == event.getAffectedEditor()) {
      externalCallable.setRefreshWorkspace((Boolean)event.getNewValue());
    }
    if (CallchainViewsRepository.ExternalCallable.Properties.predicate == event.getAffectedEditor()) {
      if (event.getKind() == PropertiesEditionEvent.SET) {
        predicateSettings.setToReference((Predicate)event.getNewValue());
      } else if (event.getKind() == PropertiesEditionEvent.ADD) {
        EReferencePropertiesEditionContext context = new EReferencePropertiesEditionContext(editingContext, this, predicateSettings, editingContext.getAdapterFactory());
        PropertiesEditingProvider provider = (PropertiesEditingProvider)editingContext.getAdapterFactory().adapt(semanticObject, PropertiesEditingProvider.class);
        if (provider != null) {
          PropertiesEditingPolicy policy = provider.getPolicy(context);
          if (policy instanceof CreateEditingPolicy) {
            policy.execute();
          }
        }
      }
    }
  }

	/**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updatePart(org.eclipse.emf.common.notify.Notification)
	 */
	public void updatePart(Notification msg) {
		if (editingPart.isVisible()) {	
			ExternalCallablePropertiesEditionPart basePart = (ExternalCallablePropertiesEditionPart)editingPart;
			if (CallchainPackage.eINSTANCE.getCallable_Name().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.ExternalCallable.Properties.name)) {
				if (msg.getNewValue() != null) {
					basePart.setName(EcoreUtil.convertToString(EcorePackage.eINSTANCE.getEString(), msg.getNewValue()));
				} else {
					basePart.setName("");
				}
			}
			if (CallchainPackage.eINSTANCE.getExternalCallable_DelegatedCallable().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.ExternalCallable.Properties.delegatedCallable))
				basePart.setDelegatedCallable((EObject)msg.getNewValue());
			
		}
	}


	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#isRequired(java.lang.Object, int)
	 * @generated
	 */
	public boolean isRequired(Object key, int kind) {
    return key == CallchainViewsRepository.ExternalCallable.Properties.delegatedCallable || key == CallchainViewsRepository.ExternalCallable.Properties.refreshWorkspace;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#validateValue(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public Diagnostic validateValue(IPropertiesEditionEvent event) {
    Diagnostic ret = Diagnostic.OK_INSTANCE;
    if (event.getNewValue() != null) {
      try {
        if (CallchainViewsRepository.ExternalCallable.Properties.name == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getCallable_Name().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getCallable_Name().getEAttributeType(), newValue);
        }
        if (CallchainViewsRepository.ExternalCallable.Properties.refreshWorkspace == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getCallable_RefreshWorkspace().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getCallable_RefreshWorkspace().getEAttributeType(), newValue);
        }
      } catch (IllegalArgumentException iae) {
        ret = BasicDiagnostic.toDiagnostic(iae);
      } catch (WrappedException we) {
        ret = BasicDiagnostic.toDiagnostic(we);
      }
    }
    return ret;
  }

}
