/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.components;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.BasicDiagnostic;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.WrappedException;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.util.Diagnostician;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.context.PropertiesEditingContext;
import org.eclipse.emf.eef.runtime.context.impl.EReferencePropertiesEditionContext;
import org.eclipse.emf.eef.runtime.impl.components.SinglePartPropertiesEditingComponent;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.utils.EEFConverterUtil;
import org.eclipse.emf.eef.runtime.policies.PropertiesEditingPolicy;
import org.eclipse.emf.eef.runtime.policies.impl.CreateEditingPolicy;
import org.eclipse.emf.eef.runtime.providers.PropertiesEditingProvider;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;

import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.Generic_Generator;
import de.urszeidler.eclipse.callchain.Predicate;
import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.Generic_GeneratorPropertiesEditionPart;


/**
 * @author Urs Zeidler
 * @generated
 */
public class Generic_GeneratorPropertiesEditionComponent extends SinglePartPropertiesEditingComponent {

	/**
	 * @generated
	 */
	
	public static String BASE_PART = "Base"; //$NON-NLS-1$

	
	/**
   * Settings for predicate EObjectFlatComboViewer
   */
  private	EObjectFlatComboSettings predicateSettings;


  /**
	 * Default constructor
	 * @generated
	 */
	public Generic_GeneratorPropertiesEditionComponent(PropertiesEditingContext editingContext, EObject generic_Generator, String editing_mode) {
    super(editingContext, generic_Generator, editing_mode);
    parts = new String[] { BASE_PART };
    repositoryKey = CallchainViewsRepository.class;
    partKey = CallchainViewsRepository.Generic_Generator.class;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#initPart(java.lang.Object, int, org.eclipse.emf.ecore.EObject, 
	 *      org.eclipse.emf.ecore.resource.ResourceSet)
	 * @generated
	 */
	public void initPart(Object key, int kind, EObject elt, ResourceSet allResource) {
    setInitializing(true);
    if (editingPart != null && key == partKey) {
      editingPart.setContext(elt, allResource);
      final Generic_Generator generic_Generator = (Generic_Generator)elt;
      final Generic_GeneratorPropertiesEditionPart basePart = (Generic_GeneratorPropertiesEditionPart)editingPart;
      // init values
      if (generic_Generator.getName() != null && isAccessible(CallchainViewsRepository.Generic_Generator.Properties.name))
        basePart.setName(EEFConverterUtil.convertToString(EcorePackage.eINSTANCE.getEString(), generic_Generator.getName()));
      
      if (generic_Generator.getGeneratorType() != null && isAccessible(CallchainViewsRepository.Generic_Generator.Properties.generatorType))
        basePart.setGeneratorType(EEFConverterUtil.convertToString(EcorePackage.eINSTANCE.getEString(), generic_Generator.getGeneratorType()));
      
      if (isAccessible(CallchainViewsRepository.Generic_Generator.Properties.refreshWorkspace)) {
        basePart.setRefreshWorkspace(generic_Generator.isRefreshWorkspace());
      }
      if (generic_Generator.getId() != null && isAccessible(CallchainViewsRepository.Generic_Generator.Properties.id))
        basePart.setId(EEFConverterUtil.convertToString(EcorePackage.eINSTANCE.getEString(), generic_Generator.getId()));
      
      if (isAccessible(CallchainViewsRepository.Generic_Generator.Properties.predicate)) {
        // init part
        predicateSettings = new EObjectFlatComboSettings(generic_Generator, CallchainPackage.eINSTANCE.getEavaluateable_Predicate());
        basePart.initPredicate(predicateSettings);
        // set the button mode
        basePart.setPredicateButtonMode(ButtonsModeEnum.CREATE);
      }
      // init filters
      
      
      
      
      
      // init values for referenced views
      
      // init filters for referenced views
      
    }
    setInitializing(false);
  }






	/**
   * {@inheritDoc}
   * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#associatedFeature(java.lang.Object)
   */
  public EStructuralFeature associatedFeature(Object editorKey) {
    if (editorKey == CallchainViewsRepository.Generic_Generator.Properties.name) {
      return CallchainPackage.eINSTANCE.getCallable_Name();
    }
    if (editorKey == CallchainViewsRepository.Generic_Generator.Properties.generatorType) {
      return CallchainPackage.eINSTANCE.getGeneric_Generator_GeneratorType();
    }
    if (editorKey == CallchainViewsRepository.Generic_Generator.Properties.refreshWorkspace) {
      return CallchainPackage.eINSTANCE.getCallable_RefreshWorkspace();
    }
    if (editorKey == CallchainViewsRepository.Generic_Generator.Properties.id) {
      return CallchainPackage.eINSTANCE.getGeneric_Generator_Id();
    }
    if (editorKey == CallchainViewsRepository.Generic_Generator.Properties.predicate) {
      return CallchainPackage.eINSTANCE.getEavaluateable_Predicate();
    }
    return super.associatedFeature(editorKey);
  }

  /**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updateSemanticModel(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void updateSemanticModel(final IPropertiesEditionEvent event) {
    Generic_Generator generic_Generator = (Generic_Generator)semanticObject;
    if (CallchainViewsRepository.Generic_Generator.Properties.name == event.getAffectedEditor()) {
      generic_Generator.setName((java.lang.String)EEFConverterUtil.createFromString(EcorePackage.eINSTANCE.getEString(), (String)event.getNewValue()));
    }
    if (CallchainViewsRepository.Generic_Generator.Properties.generatorType == event.getAffectedEditor()) {
      generic_Generator.setGeneratorType((java.lang.String)EEFConverterUtil.createFromString(EcorePackage.eINSTANCE.getEString(), (String)event.getNewValue()));
    }
    if (CallchainViewsRepository.Generic_Generator.Properties.refreshWorkspace == event.getAffectedEditor()) {
      generic_Generator.setRefreshWorkspace((Boolean)event.getNewValue());
    }
    if (CallchainViewsRepository.Generic_Generator.Properties.id == event.getAffectedEditor()) {
      generic_Generator.setId((java.lang.String)EEFConverterUtil.createFromString(EcorePackage.eINSTANCE.getEString(), (String)event.getNewValue()));
    }
    if (CallchainViewsRepository.Generic_Generator.Properties.predicate == event.getAffectedEditor()) {
      if (event.getKind() == PropertiesEditionEvent.SET) {
        predicateSettings.setToReference((Predicate)event.getNewValue());
      } else if (event.getKind() == PropertiesEditionEvent.ADD) {
        EReferencePropertiesEditionContext context = new EReferencePropertiesEditionContext(editingContext, this, predicateSettings, editingContext.getAdapterFactory());
        PropertiesEditingProvider provider = (PropertiesEditingProvider)editingContext.getAdapterFactory().adapt(semanticObject, PropertiesEditingProvider.class);
        if (provider != null) {
          PropertiesEditingPolicy policy = provider.getPolicy(context);
          if (policy instanceof CreateEditingPolicy) {
            policy.execute();
          }
        }
      }
    }
  }

	/**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updatePart(org.eclipse.emf.common.notify.Notification)
	 */
	public void updatePart(Notification msg) {
		if (editingPart.isVisible()) {	
			Generic_GeneratorPropertiesEditionPart basePart = (Generic_GeneratorPropertiesEditionPart)editingPart;
			if (CallchainPackage.eINSTANCE.getCallable_Name().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Generic_Generator.Properties.name)) {
				if (msg.getNewValue() != null) {
					basePart.setName(EcoreUtil.convertToString(EcorePackage.eINSTANCE.getEString(), msg.getNewValue()));
				} else {
					basePart.setName("");
				}
			}
			if (CallchainPackage.eINSTANCE.getGeneric_Generator_GeneratorType().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Generic_Generator.Properties.generatorType)) {
				if (msg.getNewValue() != null) {
					basePart.setGeneratorType(EcoreUtil.convertToString(EcorePackage.eINSTANCE.getEString(), msg.getNewValue()));
				} else {
					basePart.setGeneratorType("");
				}
			}
			if (CallchainPackage.eINSTANCE.getGeneric_Generator_Id().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.Generic_Generator.Properties.id)) {
				if (msg.getNewValue() != null) {
					basePart.setId(EcoreUtil.convertToString(EcorePackage.eINSTANCE.getEString(), msg.getNewValue()));
				} else {
					basePart.setId("");
				}
			}
			
		}
	}


	/**
   * {@inheritDoc}
   * 
   * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#isRequired(java.lang.Object, int)
   * @generated
   */
  public boolean isRequired(Object key, int kind) {
    return key == CallchainViewsRepository.Generic_Generator.Properties.refreshWorkspace;
  }

  /**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#validateValue(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public Diagnostic validateValue(IPropertiesEditionEvent event) {
    Diagnostic ret = Diagnostic.OK_INSTANCE;
    if (event.getNewValue() != null) {
      try {
        if (CallchainViewsRepository.Generic_Generator.Properties.name == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getCallable_Name().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getCallable_Name().getEAttributeType(), newValue);
        }
        if (CallchainViewsRepository.Generic_Generator.Properties.generatorType == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getGeneric_Generator_GeneratorType().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getGeneric_Generator_GeneratorType().getEAttributeType(), newValue);
        }
        if (CallchainViewsRepository.Generic_Generator.Properties.refreshWorkspace == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getCallable_RefreshWorkspace().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getCallable_RefreshWorkspace().getEAttributeType(), newValue);
        }
        if (CallchainViewsRepository.Generic_Generator.Properties.id == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getGeneric_Generator_Id().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getGeneric_Generator_Id().getEAttributeType(), newValue);
        }
      } catch (IllegalArgumentException iae) {
        ret = BasicDiagnostic.toDiagnostic(iae);
      } catch (WrappedException we) {
        ret = BasicDiagnostic.toDiagnostic(we);
      }
    }
    return ret;
  }

}
