/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.components;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.BasicDiagnostic;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.WrappedException;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.util.Diagnostician;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.context.PropertiesEditingContext;
import org.eclipse.emf.eef.runtime.context.impl.EObjectPropertiesEditionContext;
import org.eclipse.emf.eef.runtime.impl.components.SinglePartPropertiesEditingComponent;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.utils.EEFConverterUtil;
import org.eclipse.emf.eef.runtime.policies.PropertiesEditingPolicy;
import org.eclipse.emf.eef.runtime.providers.PropertiesEditingProvider;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;

import de.urszeidler.eclipse.callchain.CallchainFactory;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.MMAlias;
import de.urszeidler.eclipse.callchain.Model;
import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.MMAliasPropertiesEditionPart;


/**
 * @author Urs Zeidler
 * @generated
 */
public class MMAliasPropertiesEditionComponent extends SinglePartPropertiesEditingComponent {

	/**
	 * @generated
	 */
	
	public static String BASE_PART = "Base"; //$NON-NLS-1$

	
	/**
	 * Settings for decoratedmodel EObjectFlatComboViewer
	 */
	private	EObjectFlatComboSettings decoratedmodelSettings;
	
	/**
	 * Default constructor
	 * @generated
	 */
	public MMAliasPropertiesEditionComponent(PropertiesEditingContext editingContext, EObject mMAlias, String editing_mode) {
    super(editingContext, mMAlias, editing_mode);
    parts = new String[] { BASE_PART };
    repositoryKey = CallchainViewsRepository.class;
    partKey = CallchainViewsRepository.MMAlias.class;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#initPart(java.lang.Object, int, org.eclipse.emf.ecore.EObject, 
	 *      org.eclipse.emf.ecore.resource.ResourceSet)
	 * @generated
	 */
	public void initPart(Object key, int kind, EObject elt, ResourceSet allResource) {
    setInitializing(true);
    if (editingPart != null && key == partKey) {
      editingPart.setContext(elt, allResource);
      final MMAlias mMAlias = (MMAlias)elt;
      final MMAliasPropertiesEditionPart basePart = (MMAliasPropertiesEditionPart)editingPart;
      // init values
      if (mMAlias.getAliasName() != null && isAccessible(CallchainViewsRepository.MMAlias.Properties.aliasName))
        basePart.setAliasName(EEFConverterUtil.convertToString(EcorePackage.eINSTANCE.getEString(), mMAlias.getAliasName()));
      
      if (isAccessible(CallchainViewsRepository.MMAlias.Properties.decoratedmodel)) {
        // init part
        decoratedmodelSettings = new EObjectFlatComboSettings(mMAlias, CallchainPackage.eINSTANCE.getMMAlias_Decoratedmodel());
        basePart.initDecoratedmodel(decoratedmodelSettings);
        // set the button mode
        basePart.setDecoratedmodelButtonMode(ButtonsModeEnum.BROWSE);
      }
      // init filters
      
      basePart.addFilterToDecoratedmodel(new ViewerFilter() {
      
      /**
       * {@inheritDoc}
       * 
       * @see org.eclipse.jface.viewers.ViewerFilter#select(org.eclipse.jface.viewers.Viewer, java.lang.Object, java.lang.Object)
       */
      public boolean select(Viewer viewer, Object parentElement, Object element) {
        return (element instanceof String && element.equals("")) || (element instanceof Model); //$NON-NLS-1$ 
        }
      
      });
      
      // init values for referenced views
      
      // init filters for referenced views
      
    }
    setInitializing(false);
  }





	/**
   * {@inheritDoc}
   * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#associatedFeature(java.lang.Object)
   */
  public EStructuralFeature associatedFeature(Object editorKey) {
    if (editorKey == CallchainViewsRepository.MMAlias.Properties.aliasName) {
      return CallchainPackage.eINSTANCE.getMMAlias_AliasName();
    }
    if (editorKey == CallchainViewsRepository.MMAlias.Properties.decoratedmodel) {
      return CallchainPackage.eINSTANCE.getMMAlias_Decoratedmodel();
    }
    return super.associatedFeature(editorKey);
  }

  /**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updateSemanticModel(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void updateSemanticModel(final IPropertiesEditionEvent event) {
    MMAlias mMAlias = (MMAlias)semanticObject;
    if (CallchainViewsRepository.MMAlias.Properties.aliasName == event.getAffectedEditor()) {
      mMAlias.setAliasName((java.lang.String)EEFConverterUtil.createFromString(EcorePackage.eINSTANCE.getEString(), (String)event.getNewValue()));
    }
    if (CallchainViewsRepository.MMAlias.Properties.decoratedmodel == event.getAffectedEditor()) {
      if (event.getKind() == PropertiesEditionEvent.SET) {
        decoratedmodelSettings.setToReference((Model)event.getNewValue());
      } else if (event.getKind() == PropertiesEditionEvent.ADD) {
        Model eObject = CallchainFactory.eINSTANCE.createModel();
        EObjectPropertiesEditionContext context = new EObjectPropertiesEditionContext(editingContext, this, eObject, editingContext.getAdapterFactory());
        PropertiesEditingProvider provider = (PropertiesEditingProvider)editingContext.getAdapterFactory().adapt(eObject, PropertiesEditingProvider.class);
        if (provider != null) {
          PropertiesEditingPolicy policy = provider.getPolicy(context);
          if (policy != null) {
            policy.execute();
          }
        }
        decoratedmodelSettings.setToReference(eObject);
      }
    }
  }

	/**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updatePart(org.eclipse.emf.common.notify.Notification)
	 */
	public void updatePart(Notification msg) {
		if (editingPart.isVisible()) {	
			MMAliasPropertiesEditionPart basePart = (MMAliasPropertiesEditionPart)editingPart;
			if (CallchainPackage.eINSTANCE.getMMAlias_AliasName().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.MMAlias.Properties.aliasName)) {
				if (msg.getNewValue() != null) {
					basePart.setAliasName(EcoreUtil.convertToString(EcorePackage.eINSTANCE.getEString(), msg.getNewValue()));
				} else {
					basePart.setAliasName("");
				}
			}
			if (CallchainPackage.eINSTANCE.getMMAlias_Decoratedmodel().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.MMAlias.Properties.decoratedmodel))
				basePart.setDecoratedmodel((EObject)msg.getNewValue());
			
		}
	}


	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#validateValue(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public Diagnostic validateValue(IPropertiesEditionEvent event) {
    Diagnostic ret = Diagnostic.OK_INSTANCE;
    if (event.getNewValue() != null) {
      try {
        if (CallchainViewsRepository.MMAlias.Properties.aliasName == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getMMAlias_AliasName().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getMMAlias_AliasName().getEAttributeType(), newValue);
        }
      } catch (IllegalArgumentException iae) {
        ret = BasicDiagnostic.toDiagnostic(iae);
      } catch (WrappedException we) {
        ret = BasicDiagnostic.toDiagnostic(we);
      }
    }
    return ret;
  }

}
