/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.components;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.BasicDiagnostic;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.Enumerator;
import org.eclipse.emf.common.util.WrappedException;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.util.Diagnostician;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.context.PropertiesEditingContext;
import org.eclipse.emf.eef.runtime.impl.components.SinglePartPropertiesEditingComponent;
import org.eclipse.emf.eef.runtime.impl.utils.EEFConverterUtil;

import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.MM;
import de.urszeidler.eclipse.callchain.MMhandler;
import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.MMPropertiesEditionPart;


/**
 * @author Urs Zeidler
 * @generated
 */
public class MMPropertiesEditionComponent extends SinglePartPropertiesEditingComponent {

	/**
	 * @generated
	 */
	
	public static String BASE_PART = "Base"; //$NON-NLS-1$

	
	/**
	 * Default constructor
	 * @generated
	 */
	public MMPropertiesEditionComponent(PropertiesEditingContext editingContext, EObject mM, String editing_mode) {
    super(editingContext, mM, editing_mode);
    parts = new String[] { BASE_PART };
    repositoryKey = CallchainViewsRepository.class;
    partKey = CallchainViewsRepository.MM.class;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#initPart(java.lang.Object, int, org.eclipse.emf.ecore.EObject, 
	 *      org.eclipse.emf.ecore.resource.ResourceSet)
	 * @generated
	 */
	public void initPart(Object key, int kind, EObject elt, ResourceSet allResource) {
    setInitializing(true);
    if (editingPart != null && key == partKey) {
      editingPart.setContext(elt, allResource);
      final MM mM = (MM)elt;
      final MMPropertiesEditionPart basePart = (MMPropertiesEditionPart)editingPart;
      // init values
      if (mM.getName() != null && isAccessible(CallchainViewsRepository.MM.Properties.name))
        basePart.setName(EEFConverterUtil.convertToString(EcorePackage.eINSTANCE.getEString(), mM.getName()));
      
        if (mM.getUri() != null && isAccessible(CallchainViewsRepository.MM.Properties.uri)) {
          basePart.setUri(EEFConverterUtil.convertToString(CallchainPackage.eINSTANCE.getArtifact_Uri().getEAttributeType(), mM.getUri()));
        }
      
      if (isAccessible(CallchainViewsRepository.MM.Properties.handler)) {
        basePart.initHandler((EEnum) CallchainPackage.eINSTANCE.getMM_Handler().getEType(), mM.getHandler());
      }
      // init filters
      
      
      
      // init values for referenced views
      
      // init filters for referenced views
      
    }
    setInitializing(false);
  }






	/**
   * {@inheritDoc}
   * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#associatedFeature(java.lang.Object)
   */
  public EStructuralFeature associatedFeature(Object editorKey) {
    if (editorKey == CallchainViewsRepository.MM.Properties.name) {
      return CallchainPackage.eINSTANCE.getArtifact_Name();
    }
    if (editorKey == CallchainViewsRepository.MM.Properties.uri) {
      return CallchainPackage.eINSTANCE.getArtifact_Uri();
    }
    if (editorKey == CallchainViewsRepository.MM.Properties.handler) {
      return CallchainPackage.eINSTANCE.getMM_Handler();
    }
    return super.associatedFeature(editorKey);
  }

  /**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updateSemanticModel(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void updateSemanticModel(final IPropertiesEditionEvent event) {
    MM mM = (MM)semanticObject;
    if (CallchainViewsRepository.MM.Properties.name == event.getAffectedEditor()) {
      mM.setName((java.lang.String)EEFConverterUtil.createFromString(EcorePackage.eINSTANCE.getEString(), (String)event.getNewValue()));
    }
    if (CallchainViewsRepository.MM.Properties.uri == event.getAffectedEditor()) {
      mM.setUri((String)event.getNewValue());
    }
    if (CallchainViewsRepository.MM.Properties.handler == event.getAffectedEditor()) {
      mM.setHandler((MMhandler)event.getNewValue());
    }
  }

	/**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updatePart(org.eclipse.emf.common.notify.Notification)
	 */
	public void updatePart(Notification msg) {
		if (editingPart.isVisible()) {	
			MMPropertiesEditionPart basePart = (MMPropertiesEditionPart)editingPart;
			if (CallchainPackage.eINSTANCE.getArtifact_Name().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.MM.Properties.name)) {
				if (msg.getNewValue() != null) {
					basePart.setName(EcoreUtil.convertToString(EcorePackage.eINSTANCE.getEString(), msg.getNewValue()));
				} else {
					basePart.setName("");
				}
			}
			if (CallchainPackage.eINSTANCE.getArtifact_Uri().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.MM.Properties.uri)) {
				if (msg.getNewValue() != null) {
					basePart.setUri(EcoreUtil.convertToString(CallchainPackage.eINSTANCE.getArtifact_Uri().getEAttributeType(), msg.getNewValue()));
				} else {
					basePart.setUri("");
				}
			}
			if (CallchainPackage.eINSTANCE.getMM_Handler().equals(msg.getFeature()) && isAccessible(CallchainViewsRepository.MM.Properties.handler))
				basePart.setHandler((Enumerator)msg.getNewValue());
			
			
		}
	}


	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#isRequired(java.lang.Object, int)
	 * @generated
	 */
	public boolean isRequired(Object key, int kind) {
    return key == CallchainViewsRepository.MM.Properties.name || key == CallchainViewsRepository.MM.Properties.uri;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#validateValue(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public Diagnostic validateValue(IPropertiesEditionEvent event) {
    Diagnostic ret = Diagnostic.OK_INSTANCE;
    if (event.getNewValue() != null) {
      try {
        if (CallchainViewsRepository.MM.Properties.name == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getArtifact_Name().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getArtifact_Name().getEAttributeType(), newValue);
        }
        if (CallchainViewsRepository.MM.Properties.uri == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getArtifact_Uri().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getArtifact_Uri().getEAttributeType(), newValue);
        }
        if (CallchainViewsRepository.MM.Properties.handler == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getMM_Handler().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getMM_Handler().getEAttributeType(), newValue);
        }
      } catch (IllegalArgumentException iae) {
        ret = BasicDiagnostic.toDiagnostic(iae);
      } catch (WrappedException we) {
        ret = BasicDiagnostic.toDiagnostic(we);
      }
    }
    return ret;
  }

}
