/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.components;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.BasicDiagnostic;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.WrappedException;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.context.PropertiesEditingContext;
import org.eclipse.emf.eef.runtime.context.impl.EObjectPropertiesEditionContext;
import org.eclipse.emf.eef.runtime.context.impl.EReferencePropertiesEditionContext;
import org.eclipse.emf.eef.runtime.impl.components.SinglePartPropertiesEditingComponent;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.policies.PropertiesEditingPolicy;
import org.eclipse.emf.eef.runtime.policies.impl.CreateEditingPolicy;
import org.eclipse.emf.eef.runtime.providers.PropertiesEditingProvider;
import org.eclipse.emf.eef.runtime.ui.widgets.referencestable.ReferencesTableSettings;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;

import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.OrPredicate;
import de.urszeidler.eclipse.callchain.Predicate;
import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.OrPredicatePropertiesEditionPart;


/**
 * @author Urs Zeidler
 * @generated
 */
public class OrPredicatePropertiesEditionComponent extends SinglePartPropertiesEditingComponent {

	/**
	 * @generated
	 */
	
	public static String BASE_PART = "Base"; //$NON-NLS-1$

	
	/**
	 * Settings for predicates ReferencesTable
	 */
	protected ReferencesTableSettings predicatesSettings;
	
	/**
	 * Default constructor
	 * @generated
	 */
	public OrPredicatePropertiesEditionComponent(PropertiesEditingContext editingContext, EObject orPredicate, String editing_mode) {
    super(editingContext, orPredicate, editing_mode);
    parts = new String[] { BASE_PART };
    repositoryKey = CallchainViewsRepository.class;
    partKey = CallchainViewsRepository.OrPredicate.class;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#initPart(java.lang.Object, int, org.eclipse.emf.ecore.EObject, 
	 *      org.eclipse.emf.ecore.resource.ResourceSet)
	 * @generated
	 */
	public void initPart(Object key, int kind, EObject elt, ResourceSet allResource) {
    setInitializing(true);
    if (editingPart != null && key == partKey) {
      editingPart.setContext(elt, allResource);
      final OrPredicate orPredicate = (OrPredicate)elt;
      final OrPredicatePropertiesEditionPart basePart = (OrPredicatePropertiesEditionPart)editingPart;
      // init values
      if (isAccessible(CallchainViewsRepository.OrPredicate.Properties.predicates)) {
        predicatesSettings = new ReferencesTableSettings(orPredicate, CallchainPackage.eINSTANCE.getCompositePredicate_Predicates());
        basePart.initPredicates(predicatesSettings);
      }
      // init filters
      basePart.addFilterToPredicates(new ViewerFilter() {
      
          /**
           * {@inheritDoc}
           * 
           * @see org.eclipse.jface.viewers.ViewerFilter#select(org.eclipse.jface.viewers.Viewer, java.lang.Object, java.lang.Object)
           */
          public boolean select(Viewer viewer, Object parentElement, Object element) {
            return (element instanceof Predicate);
          }
      
      });
      
      // init values for referenced views
      
      // init filters for referenced views
      
    }
    setInitializing(false);
  }




	/**
   * {@inheritDoc}
   * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#associatedFeature(java.lang.Object)
   */
  public EStructuralFeature associatedFeature(Object editorKey) {
    if (editorKey == CallchainViewsRepository.OrPredicate.Properties.predicates) {
      return CallchainPackage.eINSTANCE.getCompositePredicate_Predicates();
    }
    return super.associatedFeature(editorKey);
  }

  /**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updateSemanticModel(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void updateSemanticModel(final IPropertiesEditionEvent event) {
    OrPredicate orPredicate = (OrPredicate)semanticObject;
    if (CallchainViewsRepository.OrPredicate.Properties.predicates == event.getAffectedEditor()) {
      if (event.getKind() == PropertiesEditionEvent.ADD) {
        EReferencePropertiesEditionContext context = new EReferencePropertiesEditionContext(editingContext, this, predicatesSettings, editingContext.getAdapterFactory());
        PropertiesEditingProvider provider = (PropertiesEditingProvider)editingContext.getAdapterFactory().adapt(semanticObject, PropertiesEditingProvider.class);
        if (provider != null) {
          PropertiesEditingPolicy policy = provider.getPolicy(context);
          if (policy instanceof CreateEditingPolicy) {
            policy.execute();
          }
        }
      } else if (event.getKind() == PropertiesEditionEvent.EDIT) {
        EObjectPropertiesEditionContext context = new EObjectPropertiesEditionContext(editingContext, this, (EObject) event.getNewValue(), editingContext.getAdapterFactory());
        PropertiesEditingProvider provider = (PropertiesEditingProvider)editingContext.getAdapterFactory().adapt((EObject) event.getNewValue(), PropertiesEditingProvider.class);
        if (provider != null) {
          PropertiesEditingPolicy editionPolicy = provider.getPolicy(context);
          if (editionPolicy != null) {
            editionPolicy.execute();
          }
        }
      } else if (event.getKind() == PropertiesEditionEvent.REMOVE) {
        predicatesSettings.removeFromReference((EObject) event.getNewValue());
      } else if (event.getKind() == PropertiesEditionEvent.MOVE) {
        predicatesSettings.move(event.getNewIndex(), (Predicate) event.getNewValue());
      }
    }
  }

	/**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updatePart(org.eclipse.emf.common.notify.Notification)
	 */
	public void updatePart(Notification msg) {
		if (editingPart.isVisible()) {	
			OrPredicatePropertiesEditionPart basePart = (OrPredicatePropertiesEditionPart)editingPart;
			if (CallchainPackage.eINSTANCE.getCompositePredicate_Predicates().equals(msg.getFeature()) && isAccessible(CallchainViewsRepository.OrPredicate.Properties.predicates))
				basePart.updatePredicates();
			
		}
	}


	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#isRequired(java.lang.Object, int)
	 * @generated
	 */
	public boolean isRequired(Object key, int kind) {
    return key == CallchainViewsRepository.OrPredicate.Properties.predicates;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#validateValue(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public Diagnostic validateValue(IPropertiesEditionEvent event) {
    Diagnostic ret = Diagnostic.OK_INSTANCE;
    if (event.getNewValue() != null) {
      try {
      } catch (IllegalArgumentException iae) {
        ret = BasicDiagnostic.toDiagnostic(iae);
      } catch (WrappedException we) {
        ret = BasicDiagnostic.toDiagnostic(we);
      }
    }
    return ret;
  }

}
