/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.components;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.BasicDiagnostic;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.WrappedException;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.util.Diagnostician;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.context.PropertiesEditingContext;
import org.eclipse.emf.eef.runtime.impl.components.SinglePartPropertiesEditingComponent;
import org.eclipse.emf.eef.runtime.impl.utils.EEFConverterUtil;

import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.StopCall;
import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.StopCallPropertiesEditionPart;


/**
 * @author Urs Zeidler
 * @generated
 */
public class StopCallPropertiesEditionComponent extends SinglePartPropertiesEditingComponent {

	/**
	 * @generated
	 */
	
	public static String BASE_PART = "Base"; //$NON-NLS-1$

	
	/**
	 * Default constructor
	 * @generated
	 */
	public StopCallPropertiesEditionComponent(PropertiesEditingContext editingContext, EObject stopCall, String editing_mode) {
    super(editingContext, stopCall, editing_mode);
    parts = new String[] { BASE_PART };
    repositoryKey = CallchainViewsRepository.class;
    partKey = CallchainViewsRepository.StopCall.class;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#initPart(java.lang.Object, int, org.eclipse.emf.ecore.EObject, 
	 *      org.eclipse.emf.ecore.resource.ResourceSet)
	 * @generated
	 */
	public void initPart(Object key, int kind, EObject elt, ResourceSet allResource) {
    setInitializing(true);
    if (editingPart != null && key == partKey) {
      editingPart.setContext(elt, allResource);
      final StopCall stopCall = (StopCall)elt;
      final StopCallPropertiesEditionPart basePart = (StopCallPropertiesEditionPart)editingPart;
      // init values
      if (stopCall.getName() != null && isAccessible(CallchainViewsRepository.StopCall.Properties.name))
        basePart.setName(EEFConverterUtil.convertToString(EcorePackage.eINSTANCE.getEString(), stopCall.getName()));
      
      if (isAccessible(CallchainViewsRepository.StopCall.Properties.refreshWorkspace)) {
        basePart.setRefreshWorkspace(stopCall.isRefreshWorkspace());
      }
      // init filters
      
      
      // init values for referenced views
      
      // init filters for referenced views
      
    }
    setInitializing(false);
  }





	/**
   * {@inheritDoc}
   * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#associatedFeature(java.lang.Object)
   */
  public EStructuralFeature associatedFeature(Object editorKey) {
    if (editorKey == CallchainViewsRepository.StopCall.Properties.name) {
      return CallchainPackage.eINSTANCE.getCallable_Name();
    }
    if (editorKey == CallchainViewsRepository.StopCall.Properties.refreshWorkspace) {
      return CallchainPackage.eINSTANCE.getCallable_RefreshWorkspace();
    }
    return super.associatedFeature(editorKey);
  }

  /**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updateSemanticModel(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void updateSemanticModel(final IPropertiesEditionEvent event) {
    StopCall stopCall = (StopCall)semanticObject;
    if (CallchainViewsRepository.StopCall.Properties.name == event.getAffectedEditor()) {
      stopCall.setName((java.lang.String)EEFConverterUtil.createFromString(EcorePackage.eINSTANCE.getEString(), (String)event.getNewValue()));
    }
    if (CallchainViewsRepository.StopCall.Properties.refreshWorkspace == event.getAffectedEditor()) {
      stopCall.setRefreshWorkspace((Boolean)event.getNewValue());
    }
  }

	/**
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#updatePart(org.eclipse.emf.common.notify.Notification)
	 */
	public void updatePart(Notification msg) {
		if (editingPart.isVisible()) {	
			StopCallPropertiesEditionPart basePart = (StopCallPropertiesEditionPart)editingPart;
			if (CallchainPackage.eINSTANCE.getCallable_Name().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.StopCall.Properties.name)) {
				if (msg.getNewValue() != null) {
					basePart.setName(EcoreUtil.convertToString(EcorePackage.eINSTANCE.getEString(), msg.getNewValue()));
				} else {
					basePart.setName("");
				}
			}
			if (CallchainPackage.eINSTANCE.getCallable_RefreshWorkspace().equals(msg.getFeature()) && basePart != null && isAccessible(CallchainViewsRepository.StopCall.Properties.refreshWorkspace))
				basePart.setRefreshWorkspace((Boolean)msg.getNewValue());
			
			
		}
	}


	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.impl.components.StandardPropertiesEditionComponent#isRequired(java.lang.Object, int)
	 * @generated
	 */
	public boolean isRequired(Object key, int kind) {
    return key == CallchainViewsRepository.StopCall.Properties.refreshWorkspace;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent#validateValue(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public Diagnostic validateValue(IPropertiesEditionEvent event) {
    Diagnostic ret = Diagnostic.OK_INSTANCE;
    if (event.getNewValue() != null) {
      try {
        if (CallchainViewsRepository.StopCall.Properties.name == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getCallable_Name().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getCallable_Name().getEAttributeType(), newValue);
        }
        if (CallchainViewsRepository.StopCall.Properties.refreshWorkspace == event.getAffectedEditor()) {
          Object newValue = event.getNewValue();
          if (newValue instanceof String) {
            newValue = EcoreUtil.createFromString(CallchainPackage.eINSTANCE.getCallable_RefreshWorkspace().getEAttributeType(), (String)newValue);
          }
          ret = Diagnostician.INSTANCE.validate(CallchainPackage.eINSTANCE.getCallable_RefreshWorkspace().getEAttributeType(), newValue);
        }
      } catch (IllegalArgumentException iae) {
        ret = BasicDiagnostic.toDiagnostic(iae);
      } catch (WrappedException we) {
        ret = BasicDiagnostic.toDiagnostic(we);
      }
    }
    return ret;
  }

}
