/**
 * 
 */
package de.urszeidler.eclipse.callchain.diagram;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.ui.services.action.contributionitem.AbstractContributionItemProvider;
import org.eclipse.gmf.runtime.common.ui.services.action.contributionitem.ActionRegistry;
import org.eclipse.gmf.runtime.common.ui.util.IWorkbenchPartDescriptor;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.action.IMenuListener;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.ui.IWorkbenchPage;

import de.urszeidler.eclipse.callchain.ui.emf.actions.ExecuteCallableAction;
import de.urszeidler.eclipse.callchain.ui.emf.actions.ExecuteGenerator;
import de.urszeidler.eclipse.callchain.ui.emf.actions.ExecuteSingleCallAction;
import de.urszeidler.eclipse.callchain.ui.emf.actions.OpenResourceAction;
import de.urszeidler.eclipse.callchain.ui.emf.actions.SelectionAction;

/**
 * @author urs
 *
 */
public class PopupContributionItemProvider extends
		AbstractContributionItemProvider {

	/**
	 * 
	 */
	public PopupContributionItemProvider() {
		super();
	}

	@Override
	protected IMenuManager createMenuManager(String menuId, IWorkbenchPartDescriptor partDescriptor) {
//		if (!MENU_APPLY_STEREOTYPE.equals(menuId)) {
//			return super.createMenuManager(menuId, partDescriptor);
//		}
		MenuManager menuManager = new MenuManager("test");
		MenuBuilder builder = new MenuBuilder(partDescriptor);
		//XXX: build initial content -- otherwise menu is never shown
		builder.buildMenu(menuManager);

		menuManager.addMenuListener(builder);
		return menuManager;
	}

	
	@Override
	protected IAction createAction(String actionId,
			IWorkbenchPartDescriptor partDescriptor) {
		IWorkbenchPage workbenchPage = partDescriptor.getPartPage();

		if (actionId.equals(ExecuteGenerator.ID))
			return new ExecuteGenerator(workbenchPage);
		if (actionId.equals(OpenResourceAction.ID))
			return new OpenResourceAction(workbenchPage);
		if (actionId.equals(ExecuteCallableAction.ID))
			return new ExecuteCallableAction(workbenchPage);
		if (actionId.equals(ExecuteSingleCallAction.ID))
			return new ExecuteSingleCallAction(workbenchPage);
		return super.createAction(actionId, partDescriptor);
	}
	
	@Override
	protected IAction getActionFromRegistry(String actionId,
			IWorkbenchPartDescriptor partDescriptor, ActionRegistry registry) {
		
		 IAction actionFromRegistry = super.getActionFromRegistry(actionId, partDescriptor, registry);
		 if (actionFromRegistry instanceof SelectionAction) {
			SelectionAction se = (SelectionAction) actionFromRegistry;
			se.setInterSelection( partDescriptor.getPartPage().getActivePart().getSite().getSelectionProvider().getSelection() );
		}
		 return actionFromRegistry;
	}
	
	

	private class MenuBuilder implements IMenuListener {
		private final IWorkbenchPartDescriptor myWorkbenchPart;

		public MenuBuilder(IWorkbenchPartDescriptor workbenchPart){
			myWorkbenchPart = workbenchPart;
		}
		
		public void menuAboutToShow(IMenuManager manager) {
			buildMenu(manager);
		}
		
		public void buildMenu(IMenuManager manager) {
			manager.removeAll();
			IGraphicalEditPart selected = (IGraphicalEditPart) getSelectedObject(myWorkbenchPart);
			EObject selectedElement = selected.getNotationView().getElement();
//			if (false == selectedElement instanceof Element) {
//				return;
//			}
//			Element element = (Element)selectedElement ;
//			EList<Stereotype> stereotypes = element.getApplicableStereotypes();
//			for (Stereotype stereotype: stereotypes) {
//				ApplyStereotypeAction action = new ApplyStereotypeAction(getWorkbenchPage(), element, stereotype);
//				action.init();
//				manager.add(action);
//			}
		}

//		private IWorkbenchPage getWorkbenchPage(){
//			return myWorkbenchPart.getPartPage();
//		}
	}

 
	
	
	
	
	
	 //C:\Programme\eclipse3.3\eclipse\eclipse.exe -clean  -dev "file:D:/javaprojekte/workspace_E33/.metadata/.plugins/org.eclipse.pde.core/callchain all/dev.properties" -debug "D:\javaprojekte\workspace_E33\.metadata\.plugins\org.eclipse.pde.core\callchain all/.options"      -vmargs -Xms320m -Xmx512m -XX:PermSize=128m 	
	
	
}
