package de.urszeidler.eclipse.callchain.diagram.edit.parts;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.ToolbarLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.graphics.Color;

import de.urszeidler.eclipse.callchain.diagram.edit.policies.AtlResItemSemanticEditPolicy;
import de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry;
import de.urszeidler.eclipse.callchain.diagram.providers.CallchainElementTypes;

/**
 * @generated
 */
public class AtlResEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2016;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public AtlResEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE, new AtlResItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {
		org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy lep = new org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(EditPart child) {
				EditPolicy result = child.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null) {
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		return primaryShape = new AtlResFigure();
	}

	/**
	 * @generated
	 */
	public AtlResFigure getPrimaryShape() {
		return (AtlResFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof AtlResNameEditPart) {
			((AtlResNameEditPart) childEditPart).setLabel(getPrimaryShape().getFigureAtlResnameFigure());
			return true;
		}
		if (childEditPart instanceof AtlResUriEditPart) {
			((AtlResUriEditPart) childEditPart).setLabel(getPrimaryShape().getFigureAtlResuriFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof AtlResNameEditPart) {
			return true;
		}
		if (childEditPart instanceof AtlResUriEditPart) {
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {
		return getContentPane();
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(40, 40);
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(5);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(CallchainVisualIDRegistry.getType(AtlResNameEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSource() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(CallchainElementTypes.AtlResSuperimpose_4019);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSourceAndTarget(IGraphicalEditPart targetEditPart) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (targetEditPart instanceof de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResEditPart) {
			types.add(CallchainElementTypes.AtlResSuperimpose_4019);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForTarget(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == CallchainElementTypes.AtlResSuperimpose_4019) {
			types.add(CallchainElementTypes.AtlRes_2016);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnTarget() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(6);
		types.add(CallchainElementTypes.AtlResSuperimpose_4019);
		types.add(CallchainElementTypes.CallRes_4022);
		types.add(CallchainElementTypes.CallArtifact_4024);
		types.add(CallchainElementTypes.CommentDocumentedElement_4025);
		types.add(CallchainElementTypes.GeneratorUses_4026);
		types.add(CallchainElementTypes.GeneratorProduce_4027);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForSource(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == CallchainElementTypes.AtlResSuperimpose_4019) {
			types.add(CallchainElementTypes.AtlRes_2016);
		} else if (relationshipType == CallchainElementTypes.CallRes_4022) {
			types.add(CallchainElementTypes.Call_2017);
		} else if (relationshipType == CallchainElementTypes.CallArtifact_4024) {
			types.add(CallchainElementTypes.Call_2017);
		} else if (relationshipType == CallchainElementTypes.CommentDocumentedElement_4025) {
			types.add(CallchainElementTypes.Comment_2024);
		} else if (relationshipType == CallchainElementTypes.GeneratorUses_4026) {
			types.add(CallchainElementTypes.Generic_Generator_2027);
		} else if (relationshipType == CallchainElementTypes.GeneratorProduce_4027) {
			types.add(CallchainElementTypes.Generic_Generator_2027);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public class AtlResFigure extends RectangleFigure {

		/**
		 * @generated
		 */
		private WrappingLabel fFigureAtlResuriFigure;
		/**
		 * @generated
		 */
		private WrappingLabel fFigureAtlResnameFigure;

		/**
		 * @generated
		 */
		public AtlResFigure() {

			ToolbarLayout layoutThis = new ToolbarLayout();

			layoutThis.setStretchMinorAxis(true);

			layoutThis.setMinorAlignment(0);

			this.setLayoutManager(layoutThis);

			this.setMinimumSize(new Dimension(getMapMode().DPtoLP(100), getMapMode().DPtoLP(50)));

			this.setBorder(new MarginBorder(getMapMode().DPtoLP(5), getMapMode().DPtoLP(5), getMapMode().DPtoLP(5),
					getMapMode().DPtoLP(5)));
			createContents();
		}

		/**
		 * @generated not
		 */
		private void createContents() {

			WrappingLabel atlRes0 = new WrappingLabel("AtlRes", CallchainElementTypes.getImage(((View) getModel())
					.getElement().eClass()));
			atlRes0.setAlignment(PositionConstants.CENTER);
			this.add(atlRes0);

			fFigureAtlResnameFigure = new WrappingLabel();
			fFigureAtlResnameFigure.setText("[null]");
			fFigureAtlResnameFigure.setAlignment(PositionConstants.CENTER);
			this.add(fFigureAtlResnameFigure);

			fFigureAtlResuriFigure = new WrappingLabel();
			fFigureAtlResuriFigure.setText("[null]");
			fFigureAtlResuriFigure.setAlignment(PositionConstants.CENTER);
			this.add(fFigureAtlResuriFigure);

		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureAtlResuriFigure() {
			return fFigureAtlResuriFigure;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureAtlResnameFigure() {
			return fFigureAtlResnameFigure;
		}

	}

}
