package de.urszeidler.eclipse.callchain.diagram.edit.parts;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.geometry.Insets;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.diagram.ui.figures.NoteFigure;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.graphics.Color;

import de.urszeidler.eclipse.callchain.diagram.edit.policies.CommentItemSemanticEditPolicy;
import de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry;
import de.urszeidler.eclipse.callchain.diagram.providers.CallchainElementTypes;

/**
 * @generated
 */
public class CommentEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2024;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public CommentEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE, new CommentItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {
		org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy lep = new org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(EditPart child) {
				EditPolicy result = child.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null) {
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		return primaryShape = new CommentFigure();
	}

	/**
	 * @generated
	 */
	public CommentFigure getPrimaryShape() {
		return (CommentFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof CommentDocEditPart) {
			((CommentDocEditPart) childEditPart).setLabel(getPrimaryShape().getFigureCommentdocFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof CommentDocEditPart) {
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {
		return getContentPane();
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(40, 40);
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(5);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(CallchainVisualIDRegistry.getType(CommentDocEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSource() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(CallchainElementTypes.CommentDocumentedElement_4025);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSourceAndTarget(IGraphicalEditPart targetEditPart) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (targetEditPart instanceof PredicateSwitchEditPart) {
			types.add(CallchainElementTypes.CommentDocumentedElement_4025);
		}
		if (targetEditPart instanceof MMEditPart) {
			types.add(CallchainElementTypes.CommentDocumentedElement_4025);
		}
		if (targetEditPart instanceof ModelEditPart) {
			types.add(CallchainElementTypes.CommentDocumentedElement_4025);
		}
		if (targetEditPart instanceof AtlLibaryEditPart) {
			types.add(CallchainElementTypes.CommentDocumentedElement_4025);
		}
		if (targetEditPart instanceof ExternalCallableEditPart) {
			types.add(CallchainElementTypes.CommentDocumentedElement_4025);
		}
		if (targetEditPart instanceof CallEditPart) {
			types.add(CallchainElementTypes.CommentDocumentedElement_4025);
		}
		if (targetEditPart instanceof Generic_GeneratorEditPart) {
			types.add(CallchainElementTypes.CommentDocumentedElement_4025);
		}
		if (targetEditPart instanceof PropertyValueSwitchEditPart) {
			types.add(CallchainElementTypes.CommentDocumentedElement_4025);
		}
		if (targetEditPart instanceof AtlResEditPart) {
			types.add(CallchainElementTypes.CommentDocumentedElement_4025);
		}
		if (targetEditPart instanceof ArtifactEditPart) {
			types.add(CallchainElementTypes.CommentDocumentedElement_4025);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForTarget(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == CallchainElementTypes.CommentDocumentedElement_4025) {
			types.add(CallchainElementTypes.PredicateSwitch_2028);
			types.add(CallchainElementTypes.MM_2018);
			types.add(CallchainElementTypes.Model_2015);
			types.add(CallchainElementTypes.AtlLibary_2019);
			types.add(CallchainElementTypes.ExternalCallable_2029);
			types.add(CallchainElementTypes.Call_2017);
			types.add(CallchainElementTypes.Generic_Generator_2027);
			types.add(CallchainElementTypes.PropertyValueSwitch_2030);
			types.add(CallchainElementTypes.AtlRes_2016);
			types.add(CallchainElementTypes.Artifact_2020);
		}
		return types;
	}

	/**
	 * @generated NOT
	 */
	public class CommentFigure extends NoteFigure {

		/**
		 * @generated NOT
		 */
		private WrappingLabel fFigureCommentdocFigure;

		/**
		 * @generated NOT
		 */
		public CommentFigure() {
			super(100, 56, new Insets(5, 5, 5, 14));
			this.setBackgroundColor(THIS_BACK);
			createContents();
		}

		/**
		 * @generated not
		 */
		private void createContents() {

			fFigureCommentdocFigure = new WrappingLabel();
			fFigureCommentdocFigure.setText("");
			fFigureCommentdocFigure.setAlignment(PositionConstants.CENTER);
			fFigureCommentdocFigure.setTextWrap(true);
			this.add(fFigureCommentdocFigure);

		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureCommentdocFigure() {
			return fFigureCommentdocFigure;
		}

	}

	/**
	 * @generated
	 */
	static final Color THIS_BACK = new Color(null, 255, 255, 179);

}
