package de.urszeidler.eclipse.callchain.diagram.edit.parts;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.BorderLayout;
import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PositionConstants;
import org.eclipse.draw2d.RoundedRectangle;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gef.editpolicies.NonResizableEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.draw2d.ui.figures.ConstrainedToolbarLayout;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.widgets.Display;

import de.urszeidler.eclipse.callchain.diagram.edit.policies.ExternalCallableItemSemanticEditPolicy;
import de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry;
import de.urszeidler.eclipse.callchain.diagram.providers.CallchainElementTypes;

/**
 * @generated
 */
public class ExternalCallableEditPart extends ShapeNodeEditPart {

	/**
	 * @generated
	 */
	public static final int VISUAL_ID = 2029;

	/**
	 * @generated
	 */
	protected IFigure contentPane;

	/**
	 * @generated
	 */
	protected IFigure primaryShape;

	/**
	 * @generated
	 */
	public ExternalCallableEditPart(View view) {
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies() {
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE, new ExternalCallableItemSemanticEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy() {
		org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy lep = new org.eclipse.gmf.runtime.diagram.ui.editpolicies.LayoutEditPolicy() {

			protected EditPolicy createChildEditPolicy(EditPart child) {
				EditPolicy result = child.getEditPolicy(EditPolicy.PRIMARY_DRAG_ROLE);
				if (result == null) {
					result = new NonResizableEditPolicy();
				}
				return result;
			}

			protected Command getMoveChildrenCommand(Request request) {
				return null;
			}

			protected Command getCreateCommand(CreateRequest request) {
				return null;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape() {
		return primaryShape = new ExternalCallableFigure();
	}

	/**
	 * @generated
	 */
	public ExternalCallableFigure getPrimaryShape() {
		return (ExternalCallableFigure) primaryShape;
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof ExternalCallableNameEditPart) {
			((ExternalCallableNameEditPart) childEditPart).setLabel(getPrimaryShape()
					.getFigureExternalCallablenameFigure());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart) {
		if (childEditPart instanceof ExternalCallableNameEditPart) {
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index) {
		if (addFixedChild(childEditPart)) {
			return;
		}
		super.addChildVisual(childEditPart, -1);
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart) {
		if (removeFixedChild(childEditPart)) {
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * @generated
	 */
	protected IFigure getContentPaneFor(IGraphicalEditPart editPart) {
		return getContentPane();
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate() {
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(150, 50);
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure() {
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape) {
		if (nodeShape.getLayoutManager() == null) {
			ConstrainedToolbarLayout layout = new ConstrainedToolbarLayout();
			layout.setSpacing(5);
			nodeShape.setLayoutManager(layout);
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane() {
		if (contentPane != null) {
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color) {
		if (primaryShape != null) {
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style) {
		if (primaryShape instanceof Shape) {
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public EditPart getPrimaryChildEditPart() {
		return getChildBySemanticHint(CallchainVisualIDRegistry.getType(ExternalCallableNameEditPart.VISUAL_ID));
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSource() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(CallchainElementTypes.CallableNext_4028);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSourceAndTarget(IGraphicalEditPart targetEditPart) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (targetEditPart instanceof PredicateSwitchEditPart) {
			types.add(CallchainElementTypes.CallableNext_4028);
		}
		if (targetEditPart instanceof de.urszeidler.eclipse.callchain.diagram.edit.parts.ExternalCallableEditPart) {
			types.add(CallchainElementTypes.CallableNext_4028);
		}
		if (targetEditPart instanceof CallEditPart) {
			types.add(CallchainElementTypes.CallableNext_4028);
		}
		if (targetEditPart instanceof Generic_GeneratorEditPart) {
			types.add(CallchainElementTypes.CallableNext_4028);
		}
		if (targetEditPart instanceof PropertyValueSwitchEditPart) {
			types.add(CallchainElementTypes.CallableNext_4028);
		}
		if (targetEditPart instanceof StopCallEditPart) {
			types.add(CallchainElementTypes.CallableNext_4028);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForTarget(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == CallchainElementTypes.CallableNext_4028) {
			types.add(CallchainElementTypes.PredicateSwitch_2028);
			types.add(CallchainElementTypes.ExternalCallable_2029);
			types.add(CallchainElementTypes.Call_2017);
			types.add(CallchainElementTypes.Generic_Generator_2027);
			types.add(CallchainElementTypes.PropertyValueSwitch_2030);
			types.add(CallchainElementTypes.StopCall_2031);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnTarget() {
		ArrayList<IElementType> types = new ArrayList<IElementType>(6);
		types.add(CallchainElementTypes.Transition_4029);
		types.add(CallchainElementTypes.CommentDocumentedElement_4025);
		types.add(CallchainElementTypes.PredicateSwitchTrueCallable_4030);
		types.add(CallchainElementTypes.PredicateSwitchFalseCallable_4031);
		types.add(CallchainElementTypes.CallableNext_4028);
		types.add(CallchainElementTypes.NamedSwitchDefaultCall_4032);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForSource(IElementType relationshipType) {
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == CallchainElementTypes.Transition_4029) {
			types.add(CallchainElementTypes.PropertyValueSwitch_2030);
		} else if (relationshipType == CallchainElementTypes.CommentDocumentedElement_4025) {
			types.add(CallchainElementTypes.Comment_2024);
		} else if (relationshipType == CallchainElementTypes.PredicateSwitchTrueCallable_4030) {
			types.add(CallchainElementTypes.PredicateSwitch_2028);
		} else if (relationshipType == CallchainElementTypes.PredicateSwitchFalseCallable_4031) {
			types.add(CallchainElementTypes.PredicateSwitch_2028);
		} else if (relationshipType == CallchainElementTypes.CallableNext_4028) {
			types.add(CallchainElementTypes.PredicateSwitch_2028);
			types.add(CallchainElementTypes.ExternalCallable_2029);
			types.add(CallchainElementTypes.Call_2017);
			types.add(CallchainElementTypes.Generic_Generator_2027);
			types.add(CallchainElementTypes.PropertyValueSwitch_2030);
			types.add(CallchainElementTypes.StopCall_2031);
		} else if (relationshipType == CallchainElementTypes.NamedSwitchDefaultCall_4032) {
			types.add(CallchainElementTypes.PropertyValueSwitch_2030);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public class ExternalCallableFigure extends RoundedRectangle {

		/**
		 * @generated
		 */
		private WrappingLabel fFigureExternalCallablenameFigure;

		/**
		 * @generated
		 */
		public ExternalCallableFigure() {

			BorderLayout layoutThis = new BorderLayout();
			this.setLayoutManager(layoutThis);

			this.setCornerDimensions(new Dimension(getMapMode().DPtoLP(30), getMapMode().DPtoLP(30)));
			this.setForegroundColor(THIS_FORE);
			this.setBackgroundColor(ColorConstants.white);

			this.setFont(THIS_FONT);

			this.setPreferredSize(new Dimension(getMapMode().DPtoLP(150), getMapMode().DPtoLP(50)));
			createContents();
		}

		/**
		 * @generated not
		 */
		private void createContents() {

			fFigureExternalCallablenameFigure = new WrappingLabel();
			fFigureExternalCallablenameFigure.setText("[null]");
			fFigureExternalCallablenameFigure.setAlignment(PositionConstants.CENTER);
			fFigureExternalCallablenameFigure.setTextJustification(WrappingLabel.CENTER);
			fFigureExternalCallablenameFigure.setForegroundColor(FFIGUREEXTERNALCALLABLENAMEFIGURE_FORE);

			this.add(fFigureExternalCallablenameFigure, BorderLayout.CENTER);

		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureExternalCallablenameFigure() {
			return fFigureExternalCallablenameFigure;
		}

	}

	/**
	 * @generated
	 */
	static final Color THIS_FORE = new Color(null, 128, 128, 0);

	/**
	 * @generated
	 */
	static final Font THIS_FONT = new Font(Display.getCurrent(),
			Display.getDefault().getSystemFont().getFontData()[0].getName(), 11, SWT.NORMAL);

	/**
	 * @generated
	 */
	static final Color FFIGUREEXTERNALCALLABLENAMEFIGURE_FORE = new Color(null, 128, 128, 0);

}
