package de.urszeidler.eclipse.callchain.diagram.edit.policies;

import java.util.Iterator;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.diagram.core.commands.DeleteCommand;
import org.eclipse.gmf.runtime.emf.commands.core.command.CompositeTransactionalCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyReferenceCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyReferenceRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientReferenceRelationshipRequest;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.View;

import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallArtifactCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallArtifactReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallLibarysCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CallLibarysReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CommentDocumentedElementCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.CommentDocumentedElementReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.GeneratorProduceCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.GeneratorProduceReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.GeneratorUsesCreateCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.commands.GeneratorUsesReorientCommand;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallArtifactEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallLibarysEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentDocumentedElementEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GeneratorProduceEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GeneratorUsesEditPart;
import de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry;
import de.urszeidler.eclipse.callchain.diagram.providers.CallchainElementTypes;

/**
 * @generated
 */
public class AtlLibaryItemSemanticEditPolicy extends CallchainBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	public AtlLibaryItemSemanticEditPolicy() {
		super(CallchainElementTypes.AtlLibary_2019);
	}

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		View view = (View) getHost().getModel();
		CompositeTransactionalCommand cmd = new CompositeTransactionalCommand(getEditingDomain(), null);
		cmd.setTransactionNestingEnabled(false);
		for (Iterator<?> it = view.getTargetEdges().iterator(); it.hasNext();) {
			Edge incomingLink = (Edge) it.next();
			if (CallchainVisualIDRegistry.getVisualID(incomingLink) == CallLibarysEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(incomingLink.getSource().getElement(), null,
						incomingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
			if (CallchainVisualIDRegistry.getVisualID(incomingLink) == CallArtifactEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(incomingLink.getSource().getElement(), null,
						incomingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
			if (CallchainVisualIDRegistry.getVisualID(incomingLink) == CommentDocumentedElementEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(incomingLink.getSource().getElement(), null,
						incomingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
			if (CallchainVisualIDRegistry.getVisualID(incomingLink) == GeneratorUsesEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(incomingLink.getSource().getElement(), null,
						incomingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
			if (CallchainVisualIDRegistry.getVisualID(incomingLink) == GeneratorProduceEditPart.VISUAL_ID) {
				DestroyReferenceRequest r = new DestroyReferenceRequest(incomingLink.getSource().getElement(), null,
						incomingLink.getTarget().getElement(), false);
				cmd.add(new DestroyReferenceCommand(r));
				cmd.add(new DeleteCommand(getEditingDomain(), incomingLink));
				continue;
			}
		}
		EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
		if (annotation == null) {
			// there are indirectly referenced children, need extra commands: false
			addDestroyShortcutsCommand(cmd, view);
			// delete host element
			cmd.add(new DestroyElementCommand(req));
		} else {
			cmd.add(new DeleteCommand(getEditingDomain(), view));
		}
		return getGEFWrapper(cmd.reduce());
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		Command command = req.getTarget() == null ? getStartCreateRelationshipCommand(req)
				: getCompleteCreateRelationshipCommand(req);
		return command != null ? command : super.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getStartCreateRelationshipCommand(CreateRelationshipRequest req) {
		if (CallchainElementTypes.CallLibarys_4023 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CallArtifact_4024 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.CommentDocumentedElement_4025 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.GeneratorUses_4026 == req.getElementType()) {
			return null;
		}
		if (CallchainElementTypes.GeneratorProduce_4027 == req.getElementType()) {
			return null;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getCompleteCreateRelationshipCommand(CreateRelationshipRequest req) {
		if (CallchainElementTypes.CallLibarys_4023 == req.getElementType()) {
			return getGEFWrapper(new CallLibarysCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.CallArtifact_4024 == req.getElementType()) {
			return getGEFWrapper(new CallArtifactCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.CommentDocumentedElement_4025 == req.getElementType()) {
			return getGEFWrapper(new CommentDocumentedElementCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.GeneratorUses_4026 == req.getElementType()) {
			return getGEFWrapper(new GeneratorUsesCreateCommand(req, req.getSource(), req.getTarget()));
		}
		if (CallchainElementTypes.GeneratorProduce_4027 == req.getElementType()) {
			return getGEFWrapper(new GeneratorProduceCreateCommand(req, req.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * Returns command to reorient EReference based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientReferenceRelationshipCommand(ReorientReferenceRelationshipRequest req) {
		switch (getVisualID(req)) {
		case CallLibarysEditPart.VISUAL_ID:
			return getGEFWrapper(new CallLibarysReorientCommand(req));
		case CallArtifactEditPart.VISUAL_ID:
			return getGEFWrapper(new CallArtifactReorientCommand(req));
		case CommentDocumentedElementEditPart.VISUAL_ID:
			return getGEFWrapper(new CommentDocumentedElementReorientCommand(req));
		case GeneratorUsesEditPart.VISUAL_ID:
			return getGEFWrapper(new GeneratorUsesReorientCommand(req));
		case GeneratorProduceEditPart.VISUAL_ID:
			return getGEFWrapper(new GeneratorProduceReorientCommand(req));
		}
		return super.getReorientReferenceRelationshipCommand(req);
	}

}
