package de.urszeidler.eclipse.callchain.diagram.part;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;

import de.urszeidler.eclipse.callchain.Artifact;
import de.urszeidler.eclipse.callchain.AtlLibary;
import de.urszeidler.eclipse.callchain.AtlRes;
import de.urszeidler.eclipse.callchain.Call;
import de.urszeidler.eclipse.callchain.Callable;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.Calls;
import de.urszeidler.eclipse.callchain.Comment;
import de.urszeidler.eclipse.callchain.Documentable;
import de.urszeidler.eclipse.callchain.ExternalCallable;
import de.urszeidler.eclipse.callchain.Generator;
import de.urszeidler.eclipse.callchain.Generic_Generator;
import de.urszeidler.eclipse.callchain.MMAlias;
import de.urszeidler.eclipse.callchain.Model;
import de.urszeidler.eclipse.callchain.ModelAlias;
import de.urszeidler.eclipse.callchain.NamedSwitch;
import de.urszeidler.eclipse.callchain.PredicateSwitch;
import de.urszeidler.eclipse.callchain.PropertyValueSwitch;
import de.urszeidler.eclipse.callchain.StopCall;
import de.urszeidler.eclipse.callchain.Switch;
import de.urszeidler.eclipse.callchain.Transition;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ArtifactEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlLibaryEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResSuperimposeEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallArtifactEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallInEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallLibarysEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallOutEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallResEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallableNextEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallsEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentDocumentedElementEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ExternalCallableEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GeneratorProduceEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GeneratorUsesEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Generic_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMAliasEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelAliasEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelMmEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.NamedSwitchDefaultCallEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.PredicateSwitchEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.PredicateSwitchFalseCallableEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.PredicateSwitchTrueCallableEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.PropertyValueSwitchEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.StopCallEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.TransitionEditPart;
import de.urszeidler.eclipse.callchain.diagram.providers.CallchainElementTypes;

/**
 * @generated
 */
public class CallchainDiagramUpdater {

	/**
	 * @generated
	 */
	public static List<CallchainNodeDescriptor> getSemanticChildren(View view) {
		switch (CallchainVisualIDRegistry.getVisualID(view)) {
		case CallsEditPart.VISUAL_ID:
			return getCalls_1000SemanticChildren(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<CallchainNodeDescriptor> getCalls_1000SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.emptyList();
		}
		Calls modelElement = (Calls) view.getElement();
		LinkedList<CallchainNodeDescriptor> result = new LinkedList<CallchainNodeDescriptor>();
		for (Iterator<?> it = modelElement.getSwitches().iterator(); it.hasNext();) {
			Switch childElement = (Switch) it.next();
			int visualID = CallchainVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == PredicateSwitchEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == PropertyValueSwitchEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getArtifacts().iterator(); it.hasNext();) {
			Artifact childElement = (Artifact) it.next();
			int visualID = CallchainVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == MMEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == ModelEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AtlLibaryEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == AtlResEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == ArtifactEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getComments().iterator(); it.hasNext();) {
			Comment childElement = (Comment) it.next();
			int visualID = CallchainVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == CommentEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getExternCallables().iterator(); it.hasNext();) {
			ExternalCallable childElement = (ExternalCallable) it.next();
			int visualID = CallchainVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == ExternalCallableEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getCall().iterator(); it.hasNext();) {
			Call childElement = (Call) it.next();
			int visualID = CallchainVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == CallEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getGenerators().iterator(); it.hasNext();) {
			Generator childElement = (Generator) it.next();
			int visualID = CallchainVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == Generic_GeneratorEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getStopElements().iterator(); it.hasNext();) {
			StopCall childElement = (StopCall) it.next();
			int visualID = CallchainVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == StopCallEditPart.VISUAL_ID) {
				result.add(new CallchainNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getContainedLinks(View view) {
		switch (CallchainVisualIDRegistry.getVisualID(view)) {
		case CallsEditPart.VISUAL_ID:
			return getCalls_1000ContainedLinks(view);
		case PredicateSwitchEditPart.VISUAL_ID:
			return getPredicateSwitch_2028ContainedLinks(view);
		case MMEditPart.VISUAL_ID:
			return getMM_2018ContainedLinks(view);
		case ModelEditPart.VISUAL_ID:
			return getModel_2015ContainedLinks(view);
		case AtlLibaryEditPart.VISUAL_ID:
			return getAtlLibary_2019ContainedLinks(view);
		case CommentEditPart.VISUAL_ID:
			return getComment_2024ContainedLinks(view);
		case ExternalCallableEditPart.VISUAL_ID:
			return getExternalCallable_2029ContainedLinks(view);
		case CallEditPart.VISUAL_ID:
			return getCall_2017ContainedLinks(view);
		case Generic_GeneratorEditPart.VISUAL_ID:
			return getGeneric_Generator_2027ContainedLinks(view);
		case PropertyValueSwitchEditPart.VISUAL_ID:
			return getPropertyValueSwitch_2030ContainedLinks(view);
		case AtlResEditPart.VISUAL_ID:
			return getAtlRes_2016ContainedLinks(view);
		case ArtifactEditPart.VISUAL_ID:
			return getArtifact_2020ContainedLinks(view);
		case StopCallEditPart.VISUAL_ID:
			return getStopCall_2031ContainedLinks(view);
		case ModelAliasEditPart.VISUAL_ID:
			return getModelAlias_4016ContainedLinks(view);
		case MMAliasEditPart.VISUAL_ID:
			return getMMAlias_4017ContainedLinks(view);
		case TransitionEditPart.VISUAL_ID:
			return getTransition_4029ContainedLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getIncomingLinks(View view) {
		switch (CallchainVisualIDRegistry.getVisualID(view)) {
		case PredicateSwitchEditPart.VISUAL_ID:
			return getPredicateSwitch_2028IncomingLinks(view);
		case MMEditPart.VISUAL_ID:
			return getMM_2018IncomingLinks(view);
		case ModelEditPart.VISUAL_ID:
			return getModel_2015IncomingLinks(view);
		case AtlLibaryEditPart.VISUAL_ID:
			return getAtlLibary_2019IncomingLinks(view);
		case CommentEditPart.VISUAL_ID:
			return getComment_2024IncomingLinks(view);
		case ExternalCallableEditPart.VISUAL_ID:
			return getExternalCallable_2029IncomingLinks(view);
		case CallEditPart.VISUAL_ID:
			return getCall_2017IncomingLinks(view);
		case Generic_GeneratorEditPart.VISUAL_ID:
			return getGeneric_Generator_2027IncomingLinks(view);
		case PropertyValueSwitchEditPart.VISUAL_ID:
			return getPropertyValueSwitch_2030IncomingLinks(view);
		case AtlResEditPart.VISUAL_ID:
			return getAtlRes_2016IncomingLinks(view);
		case ArtifactEditPart.VISUAL_ID:
			return getArtifact_2020IncomingLinks(view);
		case StopCallEditPart.VISUAL_ID:
			return getStopCall_2031IncomingLinks(view);
		case ModelAliasEditPart.VISUAL_ID:
			return getModelAlias_4016IncomingLinks(view);
		case MMAliasEditPart.VISUAL_ID:
			return getMMAlias_4017IncomingLinks(view);
		case TransitionEditPart.VISUAL_ID:
			return getTransition_4029IncomingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getOutgoingLinks(View view) {
		switch (CallchainVisualIDRegistry.getVisualID(view)) {
		case PredicateSwitchEditPart.VISUAL_ID:
			return getPredicateSwitch_2028OutgoingLinks(view);
		case MMEditPart.VISUAL_ID:
			return getMM_2018OutgoingLinks(view);
		case ModelEditPart.VISUAL_ID:
			return getModel_2015OutgoingLinks(view);
		case AtlLibaryEditPart.VISUAL_ID:
			return getAtlLibary_2019OutgoingLinks(view);
		case CommentEditPart.VISUAL_ID:
			return getComment_2024OutgoingLinks(view);
		case ExternalCallableEditPart.VISUAL_ID:
			return getExternalCallable_2029OutgoingLinks(view);
		case CallEditPart.VISUAL_ID:
			return getCall_2017OutgoingLinks(view);
		case Generic_GeneratorEditPart.VISUAL_ID:
			return getGeneric_Generator_2027OutgoingLinks(view);
		case PropertyValueSwitchEditPart.VISUAL_ID:
			return getPropertyValueSwitch_2030OutgoingLinks(view);
		case AtlResEditPart.VISUAL_ID:
			return getAtlRes_2016OutgoingLinks(view);
		case ArtifactEditPart.VISUAL_ID:
			return getArtifact_2020OutgoingLinks(view);
		case StopCallEditPart.VISUAL_ID:
			return getStopCall_2031OutgoingLinks(view);
		case ModelAliasEditPart.VISUAL_ID:
			return getModelAlias_4016OutgoingLinks(view);
		case MMAliasEditPart.VISUAL_ID:
			return getMMAlias_4017OutgoingLinks(view);
		case TransitionEditPart.VISUAL_ID:
			return getTransition_4029OutgoingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getCalls_1000ContainedLinks(View view) {
		Calls modelElement = (Calls) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getContainedTypeModelFacetLinks_MMAlias_4017(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getModel_2015ContainedLinks(View view) {
		Model modelElement = (Model) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Model_Mm_4018(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getAtlRes_2016ContainedLinks(View view) {
		AtlRes modelElement = (AtlRes) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_AtlRes_Superimpose_4019(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getCall_2017ContainedLinks(View view) {
		Call modelElement = (Call) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getContainedTypeModelFacetLinks_ModelAlias_4016(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Call_In_4020(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Call_Out_4021(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Call_Res_4022(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Call_Libarys_4023(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Call_Artifact_4024(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getPredicateSwitch_2028ContainedLinks(View view) {
		PredicateSwitch modelElement = (PredicateSwitch) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_PredicateSwitch_TrueCallable_4030(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_PredicateSwitch_FalseCallable_4031(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getExternalCallable_2029ContainedLinks(View view) {
		ExternalCallable modelElement = (ExternalCallable) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getMM_2018ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getAtlLibary_2019ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getArtifact_2020ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getPropertyValueSwitch_2030ContainedLinks(View view) {
		PropertyValueSwitch modelElement = (PropertyValueSwitch) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getContainedTypeModelFacetLinks_Transition_4029(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_NamedSwitch_DefaultCall_4032(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getComment_2024ContainedLinks(View view) {
		Comment modelElement = (Comment) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Comment_DocumentedElement_4025(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getStopCall_2031ContainedLinks(View view) {
		StopCall modelElement = (StopCall) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getGeneric_Generator_2027ContainedLinks(View view) {
		Generic_Generator modelElement = (Generic_Generator) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Generator_Uses_4026(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Generator_Produce_4027(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getModelAlias_4016ContainedLinks(View view) {
		ModelAlias modelElement = (ModelAlias) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Model_Mm_4018(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getMMAlias_4017ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getTransition_4029ContainedLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getModel_2015IncomingLinks(View view) {
		Model modelElement = (Model) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view
				.eResource().getResourceSet().getResources());
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_ModelAlias_4016(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_MMAlias_4017(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_In_4020(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Out_4021(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Artifact_4024(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Uses_4026(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Produce_4027(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getAtlRes_2016IncomingLinks(View view) {
		AtlRes modelElement = (AtlRes) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view
				.eResource().getResourceSet().getResources());
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getIncomingFeatureModelFacetLinks_AtlRes_Superimpose_4019(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Res_4022(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Artifact_4024(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Uses_4026(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Produce_4027(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getCall_2017IncomingLinks(View view) {
		Call modelElement = (Call) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view
				.eResource().getResourceSet().getResources());
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_Transition_4029(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_PredicateSwitch_TrueCallable_4030(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_PredicateSwitch_FalseCallable_4031(modelElement,
				crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Callable_Next_4028(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_NamedSwitch_DefaultCall_4032(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getPredicateSwitch_2028IncomingLinks(View view) {
		PredicateSwitch modelElement = (PredicateSwitch) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view
				.eResource().getResourceSet().getResources());
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_Transition_4029(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_PredicateSwitch_TrueCallable_4030(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_PredicateSwitch_FalseCallable_4031(modelElement,
				crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Callable_Next_4028(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_NamedSwitch_DefaultCall_4032(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getExternalCallable_2029IncomingLinks(View view) {
		ExternalCallable modelElement = (ExternalCallable) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view
				.eResource().getResourceSet().getResources());
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_Transition_4029(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_PredicateSwitch_TrueCallable_4030(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_PredicateSwitch_FalseCallable_4031(modelElement,
				crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Callable_Next_4028(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_NamedSwitch_DefaultCall_4032(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getMM_2018IncomingLinks(View view) {
		de.urszeidler.eclipse.callchain.MM modelElement = (de.urszeidler.eclipse.callchain.MM) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view
				.eResource().getResourceSet().getResources());
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getIncomingFeatureModelFacetLinks_Model_Mm_4018(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Artifact_4024(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Uses_4026(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Produce_4027(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getAtlLibary_2019IncomingLinks(View view) {
		AtlLibary modelElement = (AtlLibary) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view
				.eResource().getResourceSet().getResources());
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Libarys_4023(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Artifact_4024(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Uses_4026(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Produce_4027(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getArtifact_2020IncomingLinks(View view) {
		Artifact modelElement = (Artifact) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view
				.eResource().getResourceSet().getResources());
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Artifact_4024(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Uses_4026(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Produce_4027(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getPropertyValueSwitch_2030IncomingLinks(View view) {
		PropertyValueSwitch modelElement = (PropertyValueSwitch) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view
				.eResource().getResourceSet().getResources());
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_Transition_4029(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_PredicateSwitch_TrueCallable_4030(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_PredicateSwitch_FalseCallable_4031(modelElement,
				crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Callable_Next_4028(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_NamedSwitch_DefaultCall_4032(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getComment_2024IncomingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getStopCall_2031IncomingLinks(View view) {
		StopCall modelElement = (StopCall) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view
				.eResource().getResourceSet().getResources());
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_Transition_4029(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_PredicateSwitch_TrueCallable_4030(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_PredicateSwitch_FalseCallable_4031(modelElement,
				crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Callable_Next_4028(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_NamedSwitch_DefaultCall_4032(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getGeneric_Generator_2027IncomingLinks(View view) {
		Generic_Generator modelElement = (Generic_Generator) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view
				.eResource().getResourceSet().getResources());
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_Transition_4029(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_PredicateSwitch_TrueCallable_4030(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_PredicateSwitch_FalseCallable_4031(modelElement,
				crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Callable_Next_4028(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_NamedSwitch_DefaultCall_4032(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getModelAlias_4016IncomingLinks(View view) {
		ModelAlias modelElement = (ModelAlias) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view
				.eResource().getResourceSet().getResources());
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_ModelAlias_4016(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_MMAlias_4017(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_In_4020(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Out_4021(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Artifact_4024(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Uses_4026(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Produce_4027(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getMMAlias_4017IncomingLinks(View view) {
		MMAlias modelElement = (MMAlias) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view
				.eResource().getResourceSet().getResources());
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getIncomingFeatureModelFacetLinks_Model_Mm_4018(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Call_Artifact_4024(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Uses_4026(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_Generator_Produce_4027(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getTransition_4029IncomingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getModel_2015OutgoingLinks(View view) {
		Model modelElement = (Model) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Model_Mm_4018(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getAtlRes_2016OutgoingLinks(View view) {
		AtlRes modelElement = (AtlRes) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_AtlRes_Superimpose_4019(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getCall_2017OutgoingLinks(View view) {
		Call modelElement = (Call) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getContainedTypeModelFacetLinks_ModelAlias_4016(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Call_In_4020(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Call_Out_4021(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Call_Res_4022(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Call_Libarys_4023(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Call_Artifact_4024(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getPredicateSwitch_2028OutgoingLinks(View view) {
		PredicateSwitch modelElement = (PredicateSwitch) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_PredicateSwitch_TrueCallable_4030(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_PredicateSwitch_FalseCallable_4031(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getExternalCallable_2029OutgoingLinks(View view) {
		ExternalCallable modelElement = (ExternalCallable) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getMM_2018OutgoingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getAtlLibary_2019OutgoingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getArtifact_2020OutgoingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getPropertyValueSwitch_2030OutgoingLinks(View view) {
		PropertyValueSwitch modelElement = (PropertyValueSwitch) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getContainedTypeModelFacetLinks_Transition_4029(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_NamedSwitch_DefaultCall_4032(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getComment_2024OutgoingLinks(View view) {
		Comment modelElement = (Comment) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Comment_DocumentedElement_4025(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getStopCall_2031OutgoingLinks(View view) {
		StopCall modelElement = (StopCall) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getGeneric_Generator_2027OutgoingLinks(View view) {
		Generic_Generator modelElement = (Generic_Generator) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Generator_Uses_4026(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Generator_Produce_4027(modelElement));
		result.addAll(getOutgoingFeatureModelFacetLinks_Callable_Next_4028(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getModelAlias_4016OutgoingLinks(View view) {
		ModelAlias modelElement = (ModelAlias) view.getElement();
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_Model_Mm_4018(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getMMAlias_4017OutgoingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<CallchainLinkDescriptor> getTransition_4029OutgoingLinks(View view) {
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getContainedTypeModelFacetLinks_ModelAlias_4016(Call container) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		for (Iterator<?> links = container.getIn().iterator(); links.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof ModelAlias) {
				continue;
			}
			ModelAlias link = (ModelAlias) linkObject;
			if (ModelAliasEditPart.VISUAL_ID != CallchainVisualIDRegistry.getLinkWithClassVisualID(link)) {
				continue;
			}
			Model dst = link.getDecoratedmodel();
			result.add(new CallchainLinkDescriptor(container, dst, link, CallchainElementTypes.ModelAlias_4016,
					ModelAliasEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getContainedTypeModelFacetLinks_MMAlias_4017(Calls container) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		for (Iterator<?> links = container.getArtifacts().iterator(); links.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof MMAlias) {
				continue;
			}
			MMAlias link = (MMAlias) linkObject;
			if (MMAliasEditPart.VISUAL_ID != CallchainVisualIDRegistry.getLinkWithClassVisualID(link)) {
				continue;
			}
			Model dst = link.getDecoratedmodel();
			result.add(new CallchainLinkDescriptor(container, dst, link, CallchainElementTypes.MMAlias_4017,
					MMAliasEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getContainedTypeModelFacetLinks_Transition_4029(
			NamedSwitch container) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		for (Iterator<?> links = container.getTransitions().iterator(); links.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof Transition) {
				continue;
			}
			Transition link = (Transition) linkObject;
			if (TransitionEditPart.VISUAL_ID != CallchainVisualIDRegistry.getLinkWithClassVisualID(link)) {
				continue;
			}
			Callable dst = link.getCallable();
			result.add(new CallchainLinkDescriptor(container, dst, link, CallchainElementTypes.Transition_4029,
					TransitionEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getIncomingTypeModelFacetLinks_ModelAlias_4016(Model target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() != CallchainPackage.eINSTANCE.getModelAlias_Decoratedmodel()
					|| false == setting.getEObject() instanceof ModelAlias) {
				continue;
			}
			ModelAlias link = (ModelAlias) setting.getEObject();
			if (ModelAliasEditPart.VISUAL_ID != CallchainVisualIDRegistry.getLinkWithClassVisualID(link)) {
				continue;
			}
			if (false == link.eContainer() instanceof Call) {
				continue;
			}
			Call container = (Call) link.eContainer();
			result.add(new CallchainLinkDescriptor(container, target, link, CallchainElementTypes.ModelAlias_4016,
					ModelAliasEditPart.VISUAL_ID));

		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getIncomingTypeModelFacetLinks_MMAlias_4017(Model target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() != CallchainPackage.eINSTANCE.getMMAlias_Decoratedmodel()
					|| false == setting.getEObject() instanceof MMAlias) {
				continue;
			}
			MMAlias link = (MMAlias) setting.getEObject();
			if (MMAliasEditPart.VISUAL_ID != CallchainVisualIDRegistry.getLinkWithClassVisualID(link)) {
				continue;
			}
			if (false == link.eContainer() instanceof Calls) {
				continue;
			}
			Calls container = (Calls) link.eContainer();
			result.add(new CallchainLinkDescriptor(container, target, link, CallchainElementTypes.MMAlias_4017,
					MMAliasEditPart.VISUAL_ID));

		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getIncomingTypeModelFacetLinks_Transition_4029(Callable target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() != CallchainPackage.eINSTANCE.getTransition_Callable()
					|| false == setting.getEObject() instanceof Transition) {
				continue;
			}
			Transition link = (Transition) setting.getEObject();
			if (TransitionEditPart.VISUAL_ID != CallchainVisualIDRegistry.getLinkWithClassVisualID(link)) {
				continue;
			}
			if (false == link.eContainer() instanceof NamedSwitch) {
				continue;
			}
			NamedSwitch container = (NamedSwitch) link.eContainer();
			result.add(new CallchainLinkDescriptor(container, target, link, CallchainElementTypes.Transition_4029,
					TransitionEditPart.VISUAL_ID));

		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getIncomingFeatureModelFacetLinks_Model_Mm_4018(
			de.urszeidler.eclipse.callchain.MM target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE.getModel_Mm()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(), target,
						CallchainElementTypes.ModelMm_4018, ModelMmEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getIncomingFeatureModelFacetLinks_AtlRes_Superimpose_4019(
			AtlRes target, Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE.getAtlRes_Superimpose()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(), target,
						CallchainElementTypes.AtlResSuperimpose_4019, AtlResSuperimposeEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getIncomingFeatureModelFacetLinks_Call_In_4020(Model target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE.getCall_In()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(), target, CallchainElementTypes.CallIn_4020,
						CallInEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getIncomingFeatureModelFacetLinks_Call_Out_4021(Model target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE.getCall_Out()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(), target,
						CallchainElementTypes.CallOut_4021, CallOutEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getIncomingFeatureModelFacetLinks_Call_Res_4022(AtlRes target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE.getCall_Res()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(), target,
						CallchainElementTypes.CallRes_4022, CallResEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getIncomingFeatureModelFacetLinks_Call_Libarys_4023(
			AtlLibary target, Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE.getCall_Libarys()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(), target,
						CallchainElementTypes.CallLibarys_4023, CallLibarysEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getIncomingFeatureModelFacetLinks_Call_Artifact_4024(
			Artifact target, Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE.getCall_Artifact()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(), target,
						CallchainElementTypes.CallArtifact_4024, CallArtifactEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getIncomingFeatureModelFacetLinks_Comment_DocumentedElement_4025(
			Documentable target, Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE.getComment_DocumentedElement()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(), target,
						CallchainElementTypes.CommentDocumentedElement_4025, CommentDocumentedElementEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getIncomingFeatureModelFacetLinks_PredicateSwitch_TrueCallable_4030(
			Callable target, Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE.getPredicateSwitch_TrueCallable()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(), target,
						CallchainElementTypes.PredicateSwitchTrueCallable_4030,
						PredicateSwitchTrueCallableEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getIncomingFeatureModelFacetLinks_PredicateSwitch_FalseCallable_4031(
			Callable target, Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE.getPredicateSwitch_FalseCallable()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(), target,
						CallchainElementTypes.PredicateSwitchFalseCallable_4031,
						PredicateSwitchFalseCallableEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getIncomingFeatureModelFacetLinks_Generator_Uses_4026(
			Artifact target, Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE.getGenerator_Uses()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(), target,
						CallchainElementTypes.GeneratorUses_4026, GeneratorUsesEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getIncomingFeatureModelFacetLinks_Generator_Produce_4027(
			Artifact target, Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE.getGenerator_Produce()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(), target,
						CallchainElementTypes.GeneratorProduce_4027, GeneratorProduceEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getIncomingFeatureModelFacetLinks_Callable_Next_4028(
			Callable target, Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE.getCallable_Next()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(), target,
						CallchainElementTypes.CallableNext_4028, CallableNextEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getIncomingFeatureModelFacetLinks_NamedSwitch_DefaultCall_4032(
			Callable target, Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings) {
			if (setting.getEStructuralFeature() == CallchainPackage.eINSTANCE.getNamedSwitch_DefaultCall()) {
				result.add(new CallchainLinkDescriptor(setting.getEObject(), target,
						CallchainElementTypes.NamedSwitchDefaultCall_4032, NamedSwitchDefaultCallEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated not
	 */
	private static Collection getOutgoingFeatureModelFacetLinks_Model_Mm_4018(Model source) {
		Collection result = new LinkedList();
		de.urszeidler.eclipse.callchain.MM destination = source.getMm();
		if (destination == null) {
			return result;
		}
		if (!(source instanceof ModelAlias))
			result.add(new CallchainLinkDescriptor(source, destination, CallchainElementTypes.ModelMm_4018,
					ModelMmEditPart.VISUAL_ID));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getOutgoingFeatureModelFacetLinks_AtlRes_Superimpose_4019(
			AtlRes source) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		for (Iterator<?> destinations = source.getSuperimpose().iterator(); destinations.hasNext();) {
			AtlRes destination = (AtlRes) destinations.next();
			result.add(new CallchainLinkDescriptor(source, destination, CallchainElementTypes.AtlResSuperimpose_4019,
					AtlResSuperimposeEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated not
	 */
	private static Collection getOutgoingFeatureModelFacetLinks_Call_In_4020(Call source) {
		Collection result = new LinkedList();
		for (Iterator destinations = source.getIn().iterator(); destinations.hasNext();) {
			Model destination = (Model) destinations.next();
			if (!ModelAlias.class.isInstance(destination))
				result.add(new CallchainLinkDescriptor(source, destination, CallchainElementTypes.CallIn_4020,
						CallInEditPart.VISUAL_ID));

		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getOutgoingFeatureModelFacetLinks_Call_Out_4021(Call source) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		for (Iterator<?> destinations = source.getOut().iterator(); destinations.hasNext();) {
			Model destination = (Model) destinations.next();
			result.add(new CallchainLinkDescriptor(source, destination, CallchainElementTypes.CallOut_4021,
					CallOutEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getOutgoingFeatureModelFacetLinks_Call_Res_4022(Call source) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		AtlRes destination = source.getRes();
		if (destination == null) {
			return result;
		}
		result.add(new CallchainLinkDescriptor(source, destination, CallchainElementTypes.CallRes_4022,
				CallResEditPart.VISUAL_ID));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getOutgoingFeatureModelFacetLinks_Call_Libarys_4023(Call source) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		for (Iterator<?> destinations = source.getLibarys().iterator(); destinations.hasNext();) {
			AtlLibary destination = (AtlLibary) destinations.next();
			result.add(new CallchainLinkDescriptor(source, destination, CallchainElementTypes.CallLibarys_4023,
					CallLibarysEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getOutgoingFeatureModelFacetLinks_Call_Artifact_4024(Call source) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Artifact destination = source.getArtifact();
		if (destination == null) {
			return result;
		}
		result.add(new CallchainLinkDescriptor(source, destination, CallchainElementTypes.CallArtifact_4024,
				CallArtifactEditPart.VISUAL_ID));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getOutgoingFeatureModelFacetLinks_Comment_DocumentedElement_4025(
			Comment source) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		for (Iterator<?> destinations = source.getDocumentedElement().iterator(); destinations.hasNext();) {
			Documentable destination = (Documentable) destinations.next();
			result.add(new CallchainLinkDescriptor(source, destination,
					CallchainElementTypes.CommentDocumentedElement_4025, CommentDocumentedElementEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getOutgoingFeatureModelFacetLinks_PredicateSwitch_TrueCallable_4030(
			PredicateSwitch source) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Callable destination = source.getTrueCallable();
		if (destination == null) {
			return result;
		}
		result.add(new CallchainLinkDescriptor(source, destination,
				CallchainElementTypes.PredicateSwitchTrueCallable_4030, PredicateSwitchTrueCallableEditPart.VISUAL_ID));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getOutgoingFeatureModelFacetLinks_PredicateSwitch_FalseCallable_4031(
			PredicateSwitch source) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Callable destination = source.getFalseCallable();
		if (destination == null) {
			return result;
		}
		result.add(new CallchainLinkDescriptor(source, destination,
				CallchainElementTypes.PredicateSwitchFalseCallable_4031, PredicateSwitchFalseCallableEditPart.VISUAL_ID));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getOutgoingFeatureModelFacetLinks_Generator_Uses_4026(
			Generator source) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		for (Iterator<?> destinations = source.getUses().iterator(); destinations.hasNext();) {
			Artifact destination = (Artifact) destinations.next();
			result.add(new CallchainLinkDescriptor(source, destination, CallchainElementTypes.GeneratorUses_4026,
					GeneratorUsesEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getOutgoingFeatureModelFacetLinks_Generator_Produce_4027(
			Generator source) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		for (Iterator<?> destinations = source.getProduce().iterator(); destinations.hasNext();) {
			Artifact destination = (Artifact) destinations.next();
			result.add(new CallchainLinkDescriptor(source, destination, CallchainElementTypes.GeneratorProduce_4027,
					GeneratorProduceEditPart.VISUAL_ID));
		}
		return result;
	}

	// TODO : need to change the getNext for
	/**
	 * @generated not
	 */
	private static Collection<CallchainLinkDescriptor> getOutgoingFeatureModelFacetLinks_Callable_Next_4028(
			Callable source) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		if (source instanceof Switch) {
			return result;
		}
		//		else if (source instanceof ExternalCallable) {
		//			return result;
		//		}

		Callable destination = source.getNext();
		if (destination == null) {
			return result;
		}
		result.add(new CallchainLinkDescriptor(source, destination, CallchainElementTypes.CallableNext_4028,
				CallableNextEditPart.VISUAL_ID));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<CallchainLinkDescriptor> getOutgoingFeatureModelFacetLinks_NamedSwitch_DefaultCall_4032(
			NamedSwitch source) {
		LinkedList<CallchainLinkDescriptor> result = new LinkedList<CallchainLinkDescriptor>();
		Callable destination = source.getDefaultCall();
		if (destination == null) {
			return result;
		}
		result.add(new CallchainLinkDescriptor(source, destination, CallchainElementTypes.NamedSwitchDefaultCall_4032,
				NamedSwitchDefaultCallEditPart.VISUAL_ID));
		return result;
	}

}
