package de.urszeidler.eclipse.callchain.diagram.part;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.Map;

import org.eclipse.gef.Tool;
import org.eclipse.gef.palette.PaletteContainer;
import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.palette.PaletteStack;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeConnectionTool;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeCreationTool;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;

import de.urszeidler.eclipse.callchain.diagram.providers.CallchainElementTypes;
import de.urszeidler.eclipse.callchain.generatorservice.Category;
import de.urszeidler.eclipse.callchain.generatorservice.GeneratorDescriptor;

/**
 * @generated
 */
@SuppressWarnings("unchecked")
public class CallchainPaletteFactory {
	// public class CustomHintedType extends MetamodelType implements
	// IHintedType{
	//
	// public CustomHintedType(IMetamodelTypeDescriptor descriptor) {
	// super(descriptor);
	//			
	// }
	//
	// @Override
	// public String getSemanticHint() {
	// // TODO Auto-generated method stub
	// return null;
	// }
	//		
	// }
	/**
	 * @generated
	 */
	public void fillPalette(PaletteRoot paletteRoot) {
		paletteRoot.add(createComment1Group());
		paletteRoot.add(createArtifacts2Group());
		paletteRoot.add(createCall3Group());
		paletteRoot.add(createGenerators4Group());
		paletteRoot.add(createSwitches5Group());
	}

	/**
	 * Creates "comment" palette tool group
	 * 
	 * @generated
	 */
	private PaletteContainer createComment1Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(Messages.Comment1Group_title);
		paletteContainer.setId("createComment1Group"); //$NON-NLS-1$
		paletteContainer.add(createComment1CreationTool());
		paletteContainer.add(createCommentdocumentedElement2CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "artifacts" palette tool group
	 * 
	 * @generated
	 */
	private PaletteContainer createArtifacts2Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(Messages.Artifacts2Group_title);
		paletteContainer.setId("createArtifacts2Group"); //$NON-NLS-1$
		paletteContainer.add(createArtifact1CreationTool());
		paletteContainer.add(createModel2CreationTool());
		paletteContainer.add(createAtlRes3CreationTool());
		paletteContainer.add(createAtlLibary4CreationTool());
		paletteContainer.add(createModelAlias5CreationTool());
		paletteContainer.add(createMM6CreationTool());
		paletteContainer.add(createModelmm7CreationTool());
		paletteContainer.add(createMMAlias8CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "call" palette tool group
	 * 
	 * @generated
	 */
	private PaletteContainer createCall3Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(Messages.Call3Group_title);
		paletteContainer.setId("createCall3Group"); //$NON-NLS-1$
		paletteContainer.add(createCall1CreationTool());
		paletteContainer.add(createExternalCallable2CreationTool());
		paletteContainer.add(createStopCall3CreationTool());
		paletteContainer.add(createCallin4CreationTool());
		paletteContainer.add(createCallout5CreationTool());
		paletteContainer.add(createCallartifact6CreationTool());
		paletteContainer.add(createCalllibarys7CreationTool());
		paletteContainer.add(createCallres8CreationTool());
		paletteContainer.add(createAtlRessuperimpose9CreationTool());
		paletteContainer.add(createCallablenext10CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "generators" palette tool group
	 * 
	 * @generated not
	 */
	private PaletteContainer createGenerators4Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(Messages.Generators4Group_title);

		//paletteContainer.add(createGMF_Generator1CreationTool());
		// paletteContainer.add(createEMF_Generator2CreationTool());
		// paletteContainer.add(createUseit_Generator3CreationTool());
		// paletteContainer.add(createTopcasedGenerator4CreationTool());
		// paletteContainer.add(createAM3_Generator5CreationTool());
		createDynamicGenerators(paletteContainer);
		paletteContainer.add(createGeneratoruses6CreationTool());
		paletteContainer.add(createGeneratorproduce7CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates "switches" palette tool group
	 * @generated
	 */
	private PaletteContainer createSwitches5Group() {
		PaletteDrawer paletteContainer = new PaletteDrawer(Messages.Switches5Group_title);
		paletteContainer.setId("createSwitches5Group"); //$NON-NLS-1$
		paletteContainer.add(createPredicateSwitch1CreationTool());
		paletteContainer.add(createPropertyValueSwitch2CreationTool());
		paletteContainer.add(createTransition3CreationTool());
		paletteContainer.add(createPredicateSwitchtrueCallable4CreationTool());
		paletteContainer.add(createPredicateSwitchfalseCallable5CreationTool());
		paletteContainer.add(createNamedSwitchdefaultCall6CreationTool());
		return paletteContainer;
	}

	/**
	 * Creates the dynamic generator tool entrys.
	 * 
	 * @param paletteContainer
	 */

	private void createDynamicGenerators(PaletteDrawer paletteContainer) {
		// PaletteStack paletteStack = new PaletteStack("test", null, null);

		//Collection<GeneratorDescriptor> availableGenerators = de.urszeidler.eclipse.callchain.generatorservice.Generatorservice
		//		.getDefault().generatorDescriptors();
		Map<String, Category> categorys = de.urszeidler.eclipse.callchain.generatorservice.Generatorservice
				.getDefault().getCategorys();
		Collection<Category> values = categorys.values();
		for (Category category : values) {
			if (category.getDescriptors().size() == 0)
				continue;
			PaletteStack paletteStack = new PaletteStack(category.getName(), category.getDescription(), null);
			paletteContainer.add(paletteStack);
			List<GeneratorDescriptor> descriptors = category.getDescriptors();
			for (GeneratorDescriptor generatorDescriptor : descriptors) {
				List/* <IElementType> */types = new ArrayList/* <IElementType> */(1);
				IElementType elementTypes;
				types.add(CallchainElementTypes.Generic_Generator_2027);
				ElementTypeRegistry.getInstance().getType(generatorDescriptor.getId());
				GenericGeneratorToolEntry entry = new GenericGeneratorToolEntry(generatorDescriptor.getName(),
						generatorDescriptor.getDescription(), types, generatorDescriptor);
				entry.setSmallIcon(generatorDescriptor.getSmallIcon());
				entry.setLargeIcon(generatorDescriptor.getLargeIcon());
				paletteStack.add(entry);
			}

		}

	}

	/**
	 * @generated
	 */
	private ToolEntry createComment1CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(Messages.Comment1CreationTool_title,
				Messages.Comment1CreationTool_desc, Collections.singletonList(CallchainElementTypes.Comment_2024));
		entry.setId("createComment1CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.Comment_2024));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCommentdocumentedElement2CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(Messages.CommentdocumentedElement2CreationTool_title,
				Messages.CommentdocumentedElement2CreationTool_desc,
				Collections.singletonList(CallchainElementTypes.CommentDocumentedElement_4025));
		entry.setId("createCommentdocumentedElement2CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes
				.getImageDescriptor(CallchainElementTypes.CommentDocumentedElement_4025));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createArtifact1CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(Messages.Artifact1CreationTool_title,
				Messages.Artifact1CreationTool_desc, Collections.singletonList(CallchainElementTypes.Artifact_2020));
		entry.setId("createArtifact1CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.Artifact_2020));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createModel2CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(Messages.Model2CreationTool_title, Messages.Model2CreationTool_desc,
				Collections.singletonList(CallchainElementTypes.Model_2015));
		entry.setId("createModel2CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.Model_2015));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createAtlRes3CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(Messages.AtlRes3CreationTool_title, Messages.AtlRes3CreationTool_desc,
				Collections.singletonList(CallchainElementTypes.AtlRes_2016));
		entry.setId("createAtlRes3CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.AtlRes_2016));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createAtlLibary4CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(Messages.AtlLibary4CreationTool_title,
				Messages.AtlLibary4CreationTool_desc, Collections.singletonList(CallchainElementTypes.AtlLibary_2019));
		entry.setId("createAtlLibary4CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.AtlLibary_2019));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createModelAlias5CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(Messages.ModelAlias5CreationTool_title,
				Messages.ModelAlias5CreationTool_desc, Collections.singletonList(CallchainElementTypes.ModelAlias_4016));
		entry.setId("createModelAlias5CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.ModelAlias_4016));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createMM6CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(Messages.MM6CreationTool_title, Messages.MM6CreationTool_desc,
				Collections.singletonList(CallchainElementTypes.MM_2018));
		entry.setId("createMM6CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.MM_2018));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createModelmm7CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(Messages.Modelmm7CreationTool_title,
				Messages.Modelmm7CreationTool_desc, Collections.singletonList(CallchainElementTypes.ModelMm_4018));
		entry.setId("createModelmm7CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.ModelMm_4018));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createMMAlias8CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(Messages.MMAlias8CreationTool_title,
				Messages.MMAlias8CreationTool_desc, Collections.singletonList(CallchainElementTypes.MMAlias_4017));
		entry.setId("createMMAlias8CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.MMAlias_4017));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCall1CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(Messages.Call1CreationTool_title, Messages.Call1CreationTool_desc,
				Collections.singletonList(CallchainElementTypes.Call_2017));
		entry.setId("createCall1CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.Call_2017));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createExternalCallable2CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(Messages.ExternalCallable2CreationTool_title,
				Messages.ExternalCallable2CreationTool_desc,
				Collections.singletonList(CallchainElementTypes.ExternalCallable_2029));
		entry.setId("createExternalCallable2CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.ExternalCallable_2029));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createStopCall3CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(Messages.StopCall3CreationTool_title,
				Messages.StopCall3CreationTool_desc, Collections.singletonList(CallchainElementTypes.StopCall_2031));
		entry.setId("createStopCall3CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.StopCall_2031));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCallin4CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(Messages.Callin4CreationTool_title, Messages.Callin4CreationTool_desc,
				Collections.singletonList(CallchainElementTypes.CallIn_4020));
		entry.setId("createCallin4CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.CallIn_4020));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCallout5CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(Messages.Callout5CreationTool_title,
				Messages.Callout5CreationTool_desc, Collections.singletonList(CallchainElementTypes.CallOut_4021));
		entry.setId("createCallout5CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.CallOut_4021));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCallartifact6CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(Messages.Callartifact6CreationTool_title,
				Messages.Callartifact6CreationTool_desc,
				Collections.singletonList(CallchainElementTypes.CallArtifact_4024));
		entry.setId("createCallartifact6CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.CallArtifact_4024));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCalllibarys7CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(Messages.Calllibarys7CreationTool_title,
				Messages.Calllibarys7CreationTool_desc,
				Collections.singletonList(CallchainElementTypes.CallLibarys_4023));
		entry.setId("createCalllibarys7CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.CallLibarys_4023));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCallres8CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(Messages.Callres8CreationTool_title,
				Messages.Callres8CreationTool_desc, Collections.singletonList(CallchainElementTypes.CallRes_4022));
		entry.setId("createCallres8CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.CallRes_4022));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createAtlRessuperimpose9CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(Messages.AtlRessuperimpose9CreationTool_title,
				Messages.AtlRessuperimpose9CreationTool_desc,
				Collections.singletonList(CallchainElementTypes.AtlResSuperimpose_4019));
		entry.setId("createAtlRessuperimpose9CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.AtlResSuperimpose_4019));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCallablenext10CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(Messages.Callablenext10CreationTool_title,
				Messages.Callablenext10CreationTool_desc,
				Collections.singletonList(CallchainElementTypes.CallableNext_4028));
		entry.setId("createCallablenext10CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.CallableNext_4028));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createGMF_Generator1CreationTool() {
		ToolEntry entry = new ToolEntry(Messages.GMF_Generator1CreationTool_title,
				Messages.GMF_Generator1CreationTool_desc, null, null) {
		};
		entry.setId("createGMF_Generator1CreationTool"); //$NON-NLS-1$
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createEMF_Generator2CreationTool() {
		ToolEntry entry = new ToolEntry(Messages.EMF_Generator2CreationTool_title,
				Messages.EMF_Generator2CreationTool_desc, null, null) {
		};
		entry.setId("createEMF_Generator2CreationTool"); //$NON-NLS-1$
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createUseit_Generator3CreationTool() {
		ToolEntry entry = new ToolEntry(Messages.Useit_Generator3CreationTool_title,
				Messages.Useit_Generator3CreationTool_desc, null, null) {
		};
		entry.setId("createUseit_Generator3CreationTool"); //$NON-NLS-1$
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createTopcasedGenerator4CreationTool() {
		ToolEntry entry = new ToolEntry(Messages.TopcasedGenerator4CreationTool_title,
				Messages.TopcasedGenerator4CreationTool_desc, null, null) {
		};
		entry.setId("createTopcasedGenerator4CreationTool"); //$NON-NLS-1$
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createAM3_Generator5CreationTool() {
		ToolEntry entry = new ToolEntry(Messages.AM3_Generator5CreationTool_title,
				Messages.AM3_Generator5CreationTool_desc, null, null) {
		};
		entry.setId("createAM3_Generator5CreationTool"); //$NON-NLS-1$
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createGeneratoruses6CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(Messages.Generatoruses6CreationTool_title,
				Messages.Generatoruses6CreationTool_desc,
				Collections.singletonList(CallchainElementTypes.GeneratorUses_4026));
		entry.setId("createGeneratoruses6CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.GeneratorUses_4026));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createGeneratorproduce7CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(Messages.Generatorproduce7CreationTool_title,
				Messages.Generatorproduce7CreationTool_desc,
				Collections.singletonList(CallchainElementTypes.GeneratorProduce_4027));
		entry.setId("createGeneratorproduce7CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.GeneratorProduce_4027));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createPredicateSwitch1CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(Messages.PredicateSwitch1CreationTool_title,
				Messages.PredicateSwitch1CreationTool_desc,
				Collections.singletonList(CallchainElementTypes.PredicateSwitch_2028));
		entry.setId("createPredicateSwitch1CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.PredicateSwitch_2028));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createPropertyValueSwitch2CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(Messages.PropertyValueSwitch2CreationTool_title,
				Messages.PropertyValueSwitch2CreationTool_desc,
				Collections.singletonList(CallchainElementTypes.PropertyValueSwitch_2030));
		entry.setId("createPropertyValueSwitch2CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.PropertyValueSwitch_2030));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createTransition3CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(Messages.Transition3CreationTool_title,
				Messages.Transition3CreationTool_desc, Collections.singletonList(CallchainElementTypes.Transition_4029));
		entry.setId("createTransition3CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.Transition_4029));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createPredicateSwitchtrueCallable4CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(Messages.PredicateSwitchtrueCallable4CreationTool_title,
				Messages.PredicateSwitchtrueCallable4CreationTool_desc,
				Collections.singletonList(CallchainElementTypes.PredicateSwitchTrueCallable_4030));
		entry.setId("createPredicateSwitchtrueCallable4CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes
				.getImageDescriptor(CallchainElementTypes.PredicateSwitchTrueCallable_4030));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createPredicateSwitchfalseCallable5CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(Messages.PredicateSwitchfalseCallable5CreationTool_title,
				Messages.PredicateSwitchfalseCallable5CreationTool_desc,
				Collections.singletonList(CallchainElementTypes.PredicateSwitchFalseCallable_4031));
		entry.setId("createPredicateSwitchfalseCallable5CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes
				.getImageDescriptor(CallchainElementTypes.PredicateSwitchFalseCallable_4031));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createNamedSwitchdefaultCall6CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(Messages.NamedSwitchdefaultCall6CreationTool_title,
				Messages.NamedSwitchdefaultCall6CreationTool_desc,
				Collections.singletonList(CallchainElementTypes.NamedSwitchDefaultCall_4032));
		entry.setId("createNamedSwitchdefaultCall6CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(CallchainElementTypes.getImageDescriptor(CallchainElementTypes.NamedSwitchDefaultCall_4032));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	private static class GenericGeneratorToolEntry extends ToolEntry {
		//
		//		public GenericGeneratorToolEntry(String label, String description, ImageDescriptor iconSmall,
		//				ImageDescriptor iconLarge, Class tool) {
		//			super(label, description, iconSmall, iconLarge, tool);
		//			// TODO Auto-generated constructor stub
		//		}
		//
		//		public GenericGeneratorToolEntry(String label, String shortDesc, ImageDescriptor iconSmall,
		//				ImageDescriptor iconLarge) {
		//			super(label, shortDesc, iconSmall, iconLarge);
		//			// TODO Auto-generated constructor stub
		//		}
		//
		//		public GenericGeneratorToolEntry() {
		//			super(null, null, null, null);
		//			// TODO Auto-generated constructor stub
		//		}

		public GenericGeneratorToolEntry(String label, String shortDesc, List types,
				GeneratorDescriptor generatorDescriptor) {
			super(label, shortDesc, generatorDescriptor.getSmallIcon(), generatorDescriptor.getLargeIcon());
			this.descriptor = generatorDescriptor;
			this.elementTypes = types;
		}

		private GeneratorDescriptor descriptor;
		private final List elementTypes;

		public Tool createTool() {
			Tool tool = new GenericGeneratorCreationTool(elementTypes, descriptor);
			tool.setProperties(getToolProperties());
			return tool;
		}

	}

	/**
	 * @generated
	 */
	private static class NodeToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List<IElementType> elementTypes;

		/**
		 * @generated
		 */
		private NodeToolEntry(String title, String description, List<IElementType> elementTypes) {
			super(title, description, null, null);
			this.elementTypes = elementTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeCreationTool(elementTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}

	/**
	 * @generated
	 */
	private static class LinkToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List<IElementType> relationshipTypes;

		/**
		 * @generated
		 */
		private LinkToolEntry(String title, String description, List<IElementType> relationshipTypes) {
			super(title, description, null, null);
			this.relationshipTypes = relationshipTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeConnectionTool(relationshipTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}
}
