package de.urszeidler.eclipse.callchain.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

import de.urszeidler.eclipse.callchain.Artifact;
import de.urszeidler.eclipse.callchain.AtlLibary;
import de.urszeidler.eclipse.callchain.AtlRes;
import de.urszeidler.eclipse.callchain.Call;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.Calls;
import de.urszeidler.eclipse.callchain.Comment;
import de.urszeidler.eclipse.callchain.ExternalCallable;
import de.urszeidler.eclipse.callchain.Generic_Generator;
import de.urszeidler.eclipse.callchain.Model;
import de.urszeidler.eclipse.callchain.PredicateSwitch;
import de.urszeidler.eclipse.callchain.PropertyValueSwitch;
import de.urszeidler.eclipse.callchain.StopCall;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ArtifactEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ArtifactNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ArtifactUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlLibaryEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlLibaryNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlLibaryUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallsEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentDocEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ExternalCallableEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ExternalCallableNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Generic_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Generic_GeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMAliasAliasNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMAliasEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMHandlerEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelAliasAliasNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelAliasEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.NamedSwitchDefaultCallEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.PredicateSwitchEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.PredicateSwitchFalseCallableEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.PredicateSwitchNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.PredicateSwitchTrueCallableEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.PropertyValueSwitchEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.PropertyValueSwitchNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.StopCallEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.StopCallNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.TransitionEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.TransitionNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.WrappingLabel2EditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.WrappingLabel3EditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.WrappingLabelEditPart;
import de.urszeidler.eclipse.callchain.diagram.expressions.CallchainOCLFactory;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class CallchainVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "de.urszeidler.eclipse.callchain.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (CallsEditPart.MODEL_ID.equals(view.getType())) {
				return CallsEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry.getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(Platform.getDebugOption(DEBUG_KEY))) {
				CallchainDiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: " + type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return Integer.toString(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (CallchainPackage.eINSTANCE.getCalls().isSuperTypeOf(domainElement.eClass())
				&& isDiagram((Calls) domainElement)) {
			return CallsEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry
				.getModelID(containerView);
		if (!CallsEditPart.MODEL_ID.equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if (CallsEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = CallsEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case CallsEditPart.VISUAL_ID:
			if (CallchainPackage.eINSTANCE.getPredicateSwitch().isSuperTypeOf(domainElement.eClass())
					&& isPredicateSwitch_2028((PredicateSwitch) domainElement)) {
				return PredicateSwitchEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getMM().isSuperTypeOf(domainElement.eClass())
					&& isMM_2018((de.urszeidler.eclipse.callchain.MM) domainElement)) {
				return MMEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getModel().isSuperTypeOf(domainElement.eClass())
					&& isModel_2015((Model) domainElement)) {
				return ModelEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getAtlLibary().isSuperTypeOf(domainElement.eClass())
					&& isAtlLibary_2019((AtlLibary) domainElement)) {
				return AtlLibaryEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getComment().isSuperTypeOf(domainElement.eClass())
					&& isComment_2024((Comment) domainElement)) {
				return CommentEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getExternalCallable().isSuperTypeOf(domainElement.eClass())
					&& isExternalCallable_2029((ExternalCallable) domainElement)) {
				return ExternalCallableEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getCall().isSuperTypeOf(domainElement.eClass())
					&& isCall_2017((Call) domainElement)) {
				return CallEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getGeneric_Generator().isSuperTypeOf(domainElement.eClass())
					&& isGeneric_Generator_2027((Generic_Generator) domainElement)) {
				return Generic_GeneratorEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getPropertyValueSwitch().isSuperTypeOf(domainElement.eClass())
					&& isPropertyValueSwitch_2030((PropertyValueSwitch) domainElement)) {
				return PropertyValueSwitchEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getAtlRes().isSuperTypeOf(domainElement.eClass())
					&& isAtlRes_2016((AtlRes) domainElement)) {
				return AtlResEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getArtifact().isSuperTypeOf(domainElement.eClass())
					&& isArtifact_2020((Artifact) domainElement)) {
				return ArtifactEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getStopCall().isSuperTypeOf(domainElement.eClass())
					&& isStopCall_2031((StopCall) domainElement)) {
				return StopCallEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry
				.getModelID(containerView);
		if (!CallsEditPart.MODEL_ID.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (CallsEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = CallsEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case CallsEditPart.VISUAL_ID:
			if (PredicateSwitchEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (MMEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ModelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (AtlLibaryEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (CommentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ExternalCallableEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (CallEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Generic_GeneratorEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (PropertyValueSwitchEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (AtlResEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ArtifactEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (StopCallEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case PredicateSwitchEditPart.VISUAL_ID:
			if (PredicateSwitchNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MMEditPart.VISUAL_ID:
			if (MMNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (MMUriEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (MMHandlerEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ModelEditPart.VISUAL_ID:
			if (ModelNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ModelUriEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case AtlLibaryEditPart.VISUAL_ID:
			if (AtlLibaryNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (AtlLibaryUriEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case CommentEditPart.VISUAL_ID:
			if (CommentDocEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ExternalCallableEditPart.VISUAL_ID:
			if (ExternalCallableNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case CallEditPart.VISUAL_ID:
			if (CallNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Generic_GeneratorEditPart.VISUAL_ID:
			if (Generic_GeneratorNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case PropertyValueSwitchEditPart.VISUAL_ID:
			if (PropertyValueSwitchNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case AtlResEditPart.VISUAL_ID:
			if (AtlResNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (AtlResUriEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ArtifactEditPart.VISUAL_ID:
			if (ArtifactNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ArtifactUriEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case StopCallEditPart.VISUAL_ID:
			if (StopCallNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ModelAliasEditPart.VISUAL_ID:
			if (ModelAliasAliasNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MMAliasEditPart.VISUAL_ID:
			if (MMAliasAliasNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case TransitionEditPart.VISUAL_ID:
			if (TransitionNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case PredicateSwitchTrueCallableEditPart.VISUAL_ID:
			if (WrappingLabel2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case PredicateSwitchFalseCallableEditPart.VISUAL_ID:
			if (WrappingLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case NamedSwitchDefaultCallEditPart.VISUAL_ID:
			if (WrappingLabel3EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (CallchainPackage.eINSTANCE.getModelAlias().isSuperTypeOf(domainElement.eClass())) {
			return ModelAliasEditPart.VISUAL_ID;
		}
		if (CallchainPackage.eINSTANCE.getMMAlias().isSuperTypeOf(domainElement.eClass())) {
			return MMAliasEditPart.VISUAL_ID;
		}
		if (CallchainPackage.eINSTANCE.getTransition().isSuperTypeOf(domainElement.eClass())) {
			return TransitionEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(Calls element) {
		return true;
	}

	/**
	 * @generated
	 */
	private static boolean isModel_2015(Model domainElement) {
		Object result = CallchainOCLFactory.getExpression(2, CallchainPackage.eINSTANCE.getModel(), null).evaluate(
				domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isAtlRes_2016(AtlRes domainElement) {
		Object result = CallchainOCLFactory.getExpression(9, CallchainPackage.eINSTANCE.getAtlRes(), null).evaluate(
				domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isCall_2017(Call domainElement) {
		Object result = CallchainOCLFactory.getExpression(6, CallchainPackage.eINSTANCE.getCall(), null).evaluate(
				domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isPredicateSwitch_2028(PredicateSwitch domainElement) {
		Object result = CallchainOCLFactory.getExpression(0, CallchainPackage.eINSTANCE.getPredicateSwitch(), null)
				.evaluate(domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isExternalCallable_2029(ExternalCallable domainElement) {
		Object result = CallchainOCLFactory.getExpression(5, CallchainPackage.eINSTANCE.getExternalCallable(), null)
				.evaluate(domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isMM_2018(de.urszeidler.eclipse.callchain.MM domainElement) {
		Object result = CallchainOCLFactory.getExpression(1, CallchainPackage.eINSTANCE.getMM(), null).evaluate(
				domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isAtlLibary_2019(AtlLibary domainElement) {
		Object result = CallchainOCLFactory.getExpression(3, CallchainPackage.eINSTANCE.getAtlLibary(), null).evaluate(
				domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isArtifact_2020(Artifact domainElement) {
		Object result = CallchainOCLFactory.getExpression(10, CallchainPackage.eINSTANCE.getArtifact(), null).evaluate(
				domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isPropertyValueSwitch_2030(PropertyValueSwitch domainElement) {
		Object result = CallchainOCLFactory.getExpression(8, CallchainPackage.eINSTANCE.getPropertyValueSwitch(), null)
				.evaluate(domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isComment_2024(Comment domainElement) {
		Object result = CallchainOCLFactory.getExpression(4, CallchainPackage.eINSTANCE.getComment(), null).evaluate(
				domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isStopCall_2031(StopCall domainElement) {
		Object result = CallchainOCLFactory.getExpression(11, CallchainPackage.eINSTANCE.getStopCall(), null).evaluate(
				domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isGeneric_Generator_2027(Generic_Generator domainElement) {
		Object result = CallchainOCLFactory.getExpression(7, CallchainPackage.eINSTANCE.getGeneric_Generator(), null)
				.evaluate(domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

}
