package de.urszeidler.eclipse.callchain.diagram.providers;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.ui.services.modelingassistant.ModelingAssistantProvider;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.dialogs.ElementListSelectionDialog;

import de.urszeidler.eclipse.callchain.diagram.edit.parts.ArtifactEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlLibaryEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallsEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ExternalCallableEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Generic_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.PredicateSwitchEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.PropertyValueSwitchEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.StopCallEditPart;
import de.urszeidler.eclipse.callchain.diagram.part.CallchainDiagramEditorPlugin;
import de.urszeidler.eclipse.callchain.diagram.part.Messages;

/**
 * @generated
 */
@SuppressWarnings("unchecked")
public class CallchainModelingAssistantProvider extends ModelingAssistantProvider {

	/**
	 * @generated 
	 */
	public List getTypesForPopupBar(IAdaptable host) {
		IGraphicalEditPart editPart = (IGraphicalEditPart) host.getAdapter(IGraphicalEditPart.class);
		if (editPart instanceof CallsEditPart) {
			ArrayList<IElementType> types = new ArrayList<IElementType>(12);
			types.add(CallchainElementTypes.PredicateSwitch_2028);
			types.add(CallchainElementTypes.MM_2018);
			types.add(CallchainElementTypes.Model_2015);
			types.add(CallchainElementTypes.AtlLibary_2019);
			types.add(CallchainElementTypes.Comment_2024);
			types.add(CallchainElementTypes.ExternalCallable_2029);
			types.add(CallchainElementTypes.Call_2017);
			types.add(CallchainElementTypes.Generic_Generator_2027);
			types.add(CallchainElementTypes.PropertyValueSwitch_2030);
			types.add(CallchainElementTypes.AtlRes_2016);
			types.add(CallchainElementTypes.Artifact_2020);
			types.add(CallchainElementTypes.StopCall_2031);
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	public List<IElementType> getTypesForPopupBar_intern(IAdaptable host) {
		IGraphicalEditPart editPart = (IGraphicalEditPart) host.getAdapter(IGraphicalEditPart.class);
		if (editPart instanceof CallsEditPart) {
			List<IElementType> types = new ArrayList<IElementType>();
			types.add(CallchainElementTypes.Model_2015);
			types.add(CallchainElementTypes.AtlRes_2016);
			types.add(CallchainElementTypes.Call_2017);
			types.add(CallchainElementTypes.MM_2018);
			types.add(CallchainElementTypes.AtlLibary_2019);
			types.add(CallchainElementTypes.Artifact_2020);
			types.add(CallchainElementTypes.PredicateSwitch_2028);
			types.add(CallchainElementTypes.PropertyValueSwitch_2030);
			types.add(CallchainElementTypes.ExternalCallable_2029);
			//			types.add(CallchainElementTypes.Useit_Generator_2022);
			//			types.add(CallchainElementTypes.TopcasedGenerator_2023);
			types.add(CallchainElementTypes.Comment_2024);
			//			types.add(CallchainElementTypes.AM3_Generator_2025);
			//			types.add(CallchainElementTypes.GMF_Generator_2026);
			//			types.add(CallchainElementTypes.Generic_Generator_2027);
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated 
	 */
	public List getRelTypesOnSource(IAdaptable source) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source.getAdapter(IGraphicalEditPart.class);
		if (sourceEditPart instanceof PredicateSwitchEditPart) {
			return ((PredicateSwitchEditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof ModelEditPart) {
			return ((ModelEditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof CommentEditPart) {
			return ((CommentEditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof ExternalCallableEditPart) {
			return ((ExternalCallableEditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof CallEditPart) {
			return ((CallEditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof Generic_GeneratorEditPart) {
			return ((Generic_GeneratorEditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof PropertyValueSwitchEditPart) {
			return ((PropertyValueSwitchEditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof AtlResEditPart) {
			return ((AtlResEditPart) sourceEditPart).getMARelTypesOnSource();
		}
		if (sourceEditPart instanceof StopCallEditPart) {
			return ((StopCallEditPart) sourceEditPart).getMARelTypesOnSource();
		}
		return Collections.EMPTY_LIST;
	}

	private List<IElementType> getRelTypesOnSource_intern(IAdaptable source) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source.getAdapter(IGraphicalEditPart.class);
		if (sourceEditPart instanceof ModelEditPart) {
			List<IElementType> types = new ArrayList<IElementType>();
			types.add(CallchainElementTypes.ModelMm_4018);
			return types;
		}
		if (sourceEditPart instanceof AtlResEditPart) {
			List<IElementType> types = new ArrayList<IElementType>();
			types.add(CallchainElementTypes.AtlResSuperimpose_4019);
			return types;
		}
		if (sourceEditPart instanceof CallEditPart) {
			List<IElementType> types = new ArrayList<IElementType>();
			types.add(CallchainElementTypes.ModelAlias_4016);
			types.add(CallchainElementTypes.CallIn_4020);
			types.add(CallchainElementTypes.CallOut_4021);
			types.add(CallchainElementTypes.CallRes_4022);
			types.add(CallchainElementTypes.CallLibarys_4023);
			types.add(CallchainElementTypes.CallArtifact_4024);
			return types;
		}
		if (sourceEditPart instanceof Generic_GeneratorEditPart) {
			List<IElementType> types = new ArrayList<IElementType>();
			types.add(CallchainElementTypes.GeneratorProduce_4027);
			types.add(CallchainElementTypes.GeneratorUses_4026);//TODO : All artifacts
			return types;
		}
		if (sourceEditPart instanceof PredicateSwitchEditPart) {
			List<IElementType> types = new ArrayList<IElementType>();
			types.add(CallchainElementTypes.PredicateSwitchFalseCallable_4031);
			types.add(CallchainElementTypes.PredicateSwitchTrueCallable_4030);//TODO : All artifacts
			return types;
		}
		if (sourceEditPart instanceof PropertyValueSwitchEditPart) {
			List<IElementType> types = new ArrayList<IElementType>();
			types.add(CallchainElementTypes.NamedSwitchDefaultCall_4032);
			types.add(CallchainElementTypes.Transition_4029);//TODO : All artifacts
			return types;
		}

		if (sourceEditPart instanceof CommentEditPart) {
			List<IElementType> types = new ArrayList<IElementType>();
			types.add(CallchainElementTypes.CommentDocumentedElement_4025);
			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getRelTypesOnTarget(IAdaptable target) {
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target.getAdapter(IGraphicalEditPart.class);
		if (targetEditPart instanceof PredicateSwitchEditPart) {
			return ((PredicateSwitchEditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof MMEditPart) {
			return ((MMEditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof ModelEditPart) {
			return ((ModelEditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof AtlLibaryEditPart) {
			return ((AtlLibaryEditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof ExternalCallableEditPart) {
			return ((ExternalCallableEditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof CallEditPart) {
			return ((CallEditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof Generic_GeneratorEditPart) {
			return ((Generic_GeneratorEditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof PropertyValueSwitchEditPart) {
			return ((PropertyValueSwitchEditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof AtlResEditPart) {
			return ((AtlResEditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof ArtifactEditPart) {
			return ((ArtifactEditPart) targetEditPart).getMARelTypesOnTarget();
		}
		if (targetEditPart instanceof StopCallEditPart) {
			return ((StopCallEditPart) targetEditPart).getMARelTypesOnTarget();
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated 
	 */
	public List getRelTypesOnSourceAndTarget(IAdaptable source, IAdaptable target) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source.getAdapter(IGraphicalEditPart.class);
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target.getAdapter(IGraphicalEditPart.class);
		if (sourceEditPart instanceof PredicateSwitchEditPart) {
			return ((PredicateSwitchEditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof ModelEditPart) {
			return ((ModelEditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof CommentEditPart) {
			return ((CommentEditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof ExternalCallableEditPart) {
			return ((ExternalCallableEditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof CallEditPart) {
			return ((CallEditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof Generic_GeneratorEditPart) {
			return ((Generic_GeneratorEditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof PropertyValueSwitchEditPart) {
			return ((PropertyValueSwitchEditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof AtlResEditPart) {
			return ((AtlResEditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		if (sourceEditPart instanceof StopCallEditPart) {
			return ((StopCallEditPart) sourceEditPart).getMARelTypesOnSourceAndTarget(targetEditPart);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated 
	 */
	public List getTypesForSource(IAdaptable target, IElementType relationshipType) {
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target.getAdapter(IGraphicalEditPart.class);
		if (targetEditPart instanceof PredicateSwitchEditPart) {
			return ((PredicateSwitchEditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof MMEditPart) {
			return ((MMEditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof ModelEditPart) {
			return ((ModelEditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof AtlLibaryEditPart) {
			return ((AtlLibaryEditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof ExternalCallableEditPart) {
			return ((ExternalCallableEditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof CallEditPart) {
			return ((CallEditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof Generic_GeneratorEditPart) {
			return ((Generic_GeneratorEditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof PropertyValueSwitchEditPart) {
			return ((PropertyValueSwitchEditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof AtlResEditPart) {
			return ((AtlResEditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof ArtifactEditPart) {
			return ((ArtifactEditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		if (targetEditPart instanceof StopCallEditPart) {
			return ((StopCallEditPart) targetEditPart).getMATypesForSource(relationshipType);
		}
		return Collections.EMPTY_LIST;
	}

	private List<IElementType> getTypesForSource_intern(IAdaptable target, IElementType relationshipType) {
		IGraphicalEditPart targetEditPart = (IGraphicalEditPart) target.getAdapter(IGraphicalEditPart.class);
		if (targetEditPart instanceof ModelEditPart) {
			List<IElementType> types = new ArrayList<IElementType>();
			if (relationshipType == CallchainElementTypes.ModelAlias_4016) {
				types.add(CallchainElementTypes.Call_2017);
			}
			if (relationshipType == CallchainElementTypes.CallIn_4020) {
				types.add(CallchainElementTypes.Call_2017);
			}
			if (relationshipType == CallchainElementTypes.CallOut_4021) {
				types.add(CallchainElementTypes.Call_2017);
			}
			return types;
		}
		if (targetEditPart instanceof AtlResEditPart) {
			List<IElementType> types = new ArrayList<IElementType>();
			if (relationshipType == CallchainElementTypes.AtlResSuperimpose_4019) {
				types.add(CallchainElementTypes.AtlRes_2016);
			}
			if (relationshipType == CallchainElementTypes.CallRes_4022) {
				types.add(CallchainElementTypes.Call_2017);
			}
			return types;
		}
		if (targetEditPart instanceof MMEditPart) {
			List<IElementType> types = new ArrayList<IElementType>();
			if (relationshipType == CallchainElementTypes.ModelMm_4018) {
				types.add(CallchainElementTypes.Model_2015);
			}
			return types;
		}
		if (targetEditPart instanceof AtlLibaryEditPart) {
			List<IElementType> types = new ArrayList<IElementType>();
			if (relationshipType == CallchainElementTypes.CallLibarys_4023) {
				types.add(CallchainElementTypes.Call_2017);
			}
			return types;
		}
		if (targetEditPart instanceof ArtifactEditPart) {
			List<IElementType> types = new ArrayList<IElementType>();
			if (relationshipType == CallchainElementTypes.CallArtifact_4024) {
				types.add(CallchainElementTypes.Call_2017);
			}
			return types;
		}
		if (targetEditPart instanceof Generic_GeneratorEditPart) {
			List<IElementType> types = new ArrayList<IElementType>();
			if (relationshipType == CallchainElementTypes.GeneratorProduce_4027) {
				types.add(CallchainElementTypes.Artifact_2020);
				types.add(CallchainElementTypes.Model_2015);
			}
			if (relationshipType == CallchainElementTypes.GeneratorUses_4026) {
				types.add(CallchainElementTypes.Artifact_2020);
				types.add(CallchainElementTypes.Model_2015);
			}
			return types;
		}
		if (targetEditPart instanceof PredicateSwitchEditPart) {
			List<IElementType> types = new ArrayList<IElementType>();
			if (relationshipType == CallchainElementTypes.PredicateSwitchTrueCallable_4030) {
				types.add(CallchainElementTypes.Call_2017);
				types.add(CallchainElementTypes.Generic_Generator_2027);
				types.add(CallchainElementTypes.PredicateSwitch_2028);
				types.add(CallchainElementTypes.PropertyValueSwitch_2030);
				types.add(CallchainElementTypes.ExternalCallable_2029);
			}
			if (relationshipType == CallchainElementTypes.PredicateSwitchFalseCallable_4031) {
				types.add(CallchainElementTypes.Call_2017);
				types.add(CallchainElementTypes.Generic_Generator_2027);
				types.add(CallchainElementTypes.PredicateSwitch_2028);
				types.add(CallchainElementTypes.PropertyValueSwitch_2030);
				types.add(CallchainElementTypes.ExternalCallable_2029);
			}
			return types;
		}
		if (targetEditPart instanceof PropertyValueSwitchEditPart) {
			List<IElementType> types = new ArrayList<IElementType>();
			if (relationshipType == CallchainElementTypes.NamedSwitchDefaultCall_4032) {
				types.add(CallchainElementTypes.Call_2017);
				types.add(CallchainElementTypes.Generic_Generator_2027);
				types.add(CallchainElementTypes.PredicateSwitch_2028);
				types.add(CallchainElementTypes.PropertyValueSwitch_2030);
				types.add(CallchainElementTypes.ExternalCallable_2029);
			}
			if (relationshipType == CallchainElementTypes.Transition_4029) {
				types.add(CallchainElementTypes.Call_2017);
				types.add(CallchainElementTypes.Generic_Generator_2027);
				types.add(CallchainElementTypes.PredicateSwitch_2028);
				types.add(CallchainElementTypes.PropertyValueSwitch_2030);
				types.add(CallchainElementTypes.ExternalCallable_2029);
			}
			return types;
		}

		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public List getTypesForTarget(IAdaptable source, IElementType relationshipType) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source.getAdapter(IGraphicalEditPart.class);
		if (sourceEditPart instanceof PredicateSwitchEditPart) {
			return ((PredicateSwitchEditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof ModelEditPart) {
			return ((ModelEditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof CommentEditPart) {
			return ((CommentEditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof ExternalCallableEditPart) {
			return ((ExternalCallableEditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof CallEditPart) {
			return ((CallEditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof Generic_GeneratorEditPart) {
			return ((Generic_GeneratorEditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof PropertyValueSwitchEditPart) {
			return ((PropertyValueSwitchEditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof AtlResEditPart) {
			return ((AtlResEditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		if (sourceEditPart instanceof StopCallEditPart) {
			return ((StopCallEditPart) sourceEditPart).getMATypesForTarget(relationshipType);
		}
		return Collections.EMPTY_LIST;
	}

	private List getTypesForTarget_intern(IAdaptable source, IElementType relationshipType) {
		IGraphicalEditPart sourceEditPart = (IGraphicalEditPart) source.getAdapter(IGraphicalEditPart.class);
		if (sourceEditPart instanceof ModelEditPart) {
			List types = new ArrayList();
			if (relationshipType == CallchainElementTypes.ModelMm_4018) {
				types.add(CallchainElementTypes.MM_2018);
			}
			return types;
		}
		if (sourceEditPart instanceof AtlResEditPart) {
			List types = new ArrayList();
			if (relationshipType == CallchainElementTypes.AtlResSuperimpose_4019) {
				types.add(CallchainElementTypes.AtlRes_2016);
			}
			return types;
		}
		if (sourceEditPart instanceof CallEditPart) {
			List types = new ArrayList();
			if (relationshipType == CallchainElementTypes.ModelAlias_4016) {
				types.add(CallchainElementTypes.Model_2015);
			}
			if (relationshipType == CallchainElementTypes.CallIn_4020) {
				types.add(CallchainElementTypes.Model_2015);
			}
			if (relationshipType == CallchainElementTypes.CallOut_4021) {
				types.add(CallchainElementTypes.Model_2015);
			}
			if (relationshipType == CallchainElementTypes.CallRes_4022) {
				types.add(CallchainElementTypes.AtlRes_2016);
			}
			if (relationshipType == CallchainElementTypes.CallLibarys_4023) {
				types.add(CallchainElementTypes.AtlLibary_2019);
			}
			if (relationshipType == CallchainElementTypes.CallArtifact_4024) {
				types.add(CallchainElementTypes.MM_2018);
				types.add(CallchainElementTypes.Model_2015);
				types.add(CallchainElementTypes.Artifact_2020);
			}
			return types;
		}
		//		if (sourceEditPart instanceof AM3_GeneratorEditPart) {
		//			List types = new ArrayList();
		//			if (relationshipType == CallchainElementTypes.GeneratorUses_4026) {
		//				types.add(CallchainElementTypes.Artifact_2020);
		//				types.add(CallchainElementTypes.Model_2015);
		//			}
		//			if (relationshipType == CallchainElementTypes.GeneratorProduce_4027) {
		//				types.add(CallchainElementTypes.Artifact_2020);
		//				types.add(CallchainElementTypes.Model_2015);
		//			}
		//			return types;
		//		}
		//		if (sourceEditPart instanceof GMF_GeneratorEditPart) {
		//			List types = new ArrayList();
		//			if (relationshipType == CallchainElementTypes.GeneratorUses_4026) {
		//				types.add(CallchainElementTypes.Artifact_2020);
		//				types.add(CallchainElementTypes.Model_2015);
		//			}
		//			if (relationshipType == CallchainElementTypes.GeneratorProduce_4027) {
		//				types.add(CallchainElementTypes.Artifact_2020);
		//				types.add(CallchainElementTypes.Model_2015);
		//			}
		//			return types;
		//		}
		//		if (sourceEditPart instanceof EMF_GeneratorEditPart) {
		//			List types = new ArrayList();
		//			if (relationshipType == CallchainElementTypes.GeneratorUses_4026) {
		//				types.add(CallchainElementTypes.Artifact_2020);
		//				types.add(CallchainElementTypes.Model_2015);
		//			}
		//			if (relationshipType == CallchainElementTypes.GeneratorProduce_4027) {
		//				types.add(CallchainElementTypes.Artifact_2020);
		//				types.add(CallchainElementTypes.Model_2015);
		//			}
		//			return types;
		//		}
		//		if (sourceEditPart instanceof Useit_GeneratorEditPart) {
		//			List types = new ArrayList();
		//			if (relationshipType == CallchainElementTypes.GeneratorUses_4026) {
		//				types.add(CallchainElementTypes.Artifact_2020);
		//				types.add(CallchainElementTypes.Model_2015);
		//			}
		//			if (relationshipType == CallchainElementTypes.GeneratorProduce_4027) {
		//				types.add(CallchainElementTypes.Artifact_2020);
		//				types.add(CallchainElementTypes.Model_2015);
		//			}
		//			return types;
		//		}
		//		if (sourceEditPart instanceof TopcasedGeneratorEditPart) {
		//			List types = new ArrayList();
		//			if (relationshipType == CallchainElementTypes.GeneratorUses_4026) {
		//				types.add(CallchainElementTypes.Artifact_2020);
		//				types.add(CallchainElementTypes.Model_2015);
		//			}
		//			if (relationshipType == CallchainElementTypes.GeneratorProduce_4027) {
		//				types.add(CallchainElementTypes.Artifact_2020);
		//				types.add(CallchainElementTypes.Model_2015);
		//			}
		//			return types;
		//		}
		if (sourceEditPart instanceof Generic_GeneratorEditPart) {
			List types = new ArrayList();
			if (relationshipType == CallchainElementTypes.GeneratorUses_4026) {
				types.add(CallchainElementTypes.Artifact_2020);
				types.add(CallchainElementTypes.Model_2015);
			}
			if (relationshipType == CallchainElementTypes.GeneratorProduce_4027) {
				types.add(CallchainElementTypes.Artifact_2020);
				types.add(CallchainElementTypes.Model_2015);
			}
			return types;
		}

		if (sourceEditPart instanceof CommentEditPart) {
			List types = new ArrayList();
			types.add(CallchainElementTypes.MM_2018);
			types.add(CallchainElementTypes.Model_2015);
			types.add(CallchainElementTypes.AtlLibary_2019);
			types.add(CallchainElementTypes.AtlRes_2016);
			types.add(CallchainElementTypes.Artifact_2020);

			return types;
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public EObject selectExistingElementForSource(IAdaptable target, IElementType relationshipType) {
		return selectExistingElement(target, getTypesForSource(target, relationshipType));
	}

	/**
	 * @generated
	 */
	public EObject selectExistingElementForTarget(IAdaptable source, IElementType relationshipType) {
		return selectExistingElement(source, getTypesForTarget(source, relationshipType));
	}

	/**
	 * @generated
	 */
	protected EObject selectExistingElement(IAdaptable host, Collection types) {
		if (types.isEmpty()) {
			return null;
		}
		IGraphicalEditPart editPart = (IGraphicalEditPart) host.getAdapter(IGraphicalEditPart.class);
		if (editPart == null) {
			return null;
		}
		Diagram diagram = (Diagram) editPart.getRoot().getContents().getModel();
		HashSet<EObject> elements = new HashSet<EObject>();
		for (Iterator<EObject> it = diagram.getElement().eAllContents(); it.hasNext();) {
			EObject element = it.next();
			if (isApplicableElement(element, types)) {
				elements.add(element);
			}
		}
		if (elements.isEmpty()) {
			return null;
		}
		return selectElement((EObject[]) elements.toArray(new EObject[elements.size()]));
	}

	/**
	 * @generated
	 */
	protected boolean isApplicableElement(EObject element, Collection types) {
		IElementType type = ElementTypeRegistry.getInstance().getElementType(element);
		return types.contains(type);
	}

	/**
	 * @generated
	 */
	protected EObject selectElement(EObject[] elements) {
		Shell shell = Display.getCurrent().getActiveShell();
		ILabelProvider labelProvider = new AdapterFactoryLabelProvider(CallchainDiagramEditorPlugin.getInstance()
				.getItemProvidersAdapterFactory());
		ElementListSelectionDialog dialog = new ElementListSelectionDialog(shell, labelProvider);
		dialog.setMessage(Messages.CallchainModelingAssistantProviderMessage);
		dialog.setTitle(Messages.CallchainModelingAssistantProviderTitle);
		dialog.setMultipleSelection(false);
		dialog.setElements(elements);
		EObject selected = null;
		if (dialog.open() == Window.OK) {
			selected = (EObject) dialog.getFirstResult();
		}
		return selected;
	}
}
