package de.urszeidler.eclipse.callchain.editor.preferences;

import java.io.File;

import org.eclipse.emf.ecore.presentation.EcoreActionBarContributor.ExtendedLoadResourceAction.ExtendedLoadResourceDialog;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.jface.dialogs.InputDialog;
import org.eclipse.jface.preference.PathEditor;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.PlatformUI;

public class UriFieldEditor extends PathEditor {
	public static final String LIST_SPILTT = File.pathSeparator + "\\n\\r";

	public UriFieldEditor(String name, String labelText, String dirChooserLabelText, Composite parent) {
		super(name, labelText, dirChooserLabelText, parent);
	}

	/*
	 * (non-Javadoc) Method declared on ListEditor. Creates a single string from
	 * the given array by separating each string with the appropriate
	 * OS-specific path separator.
	 */
	protected String createList(String[] items) {
		StringBuffer path = new StringBuffer("");//$NON-NLS-1$

		for (int i = 0; i < items.length; i++) {
			path.append(items[i]);
			path.append(File.pathSeparator);
			path.append("\n\r");
		}
		return path.toString();
	}

	/*
	 * (non-Javadoc) Method declared on ListEditor.
	 */
	protected String[] parseString(String stringList) {
		return stringList.split(LIST_SPILTT);
	}

	@Override
	protected String getNewInputObject() {
		// InputDialog inputDialog = new InputDialog(getShell(), "", null, null,
		// null);

		ExtendedLoadResourceDialog loadResourceDialog = new ExtendedLoadResourceDialog(PlatformUI.getWorkbench()
				.getActiveWorkbenchWindow().getShell(), (EditingDomain) null);

		int open = loadResourceDialog.open();// inputDialog.open();
		if (open == InputDialog.OK) {
			return loadResourceDialog.getURIText();// inputDialog.getValue().toLowerCase().trim();
		}
		return super.getNewInputObject();
	}
}