/**
 * 
 */
package de.urszeidler.eclipse.callchain.eefgenerator;

import java.util.List;

import org.eclipse.core.resources.IContainer;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.eef.codegen.core.initializer.AbstractPropertiesInitializer;
import org.eclipse.emf.eef.codegen.core.services.PropertiesInitializerStrategyServices;

import de.urszeidler.eclipse.callchain.Artifact;
import de.urszeidler.eclipse.callchain.Generic_Generator;
import de.urszeidler.eclipse.callchain.Model;
import de.urszeidler.eclipse.callchain.generatorservice.GeneratorExecutable;
import de.urszeidler.eclipse.callchain.generatorservice.executables.AbstractExecuteable;

/**
 * @author urs
 *
 */
public class PropertiesInitalizer extends AbstractExecuteable  implements GeneratorExecutable {

	private static final String NAME = "Basic Properties initializer";
	private static final String EMF_GENMODEL = "http://www.eclipse.org/emf/2002/GenModel";
	private AbstractPropertiesInitializer propertiesInitializer;
	private URI modelURI;
	private IContainer targetFolder;
	/**
	 * 
	 */
	public PropertiesInitalizer() {
	}

	/* (non-Javadoc)
	 * @see de.urszeidler.eclipse.callchain.generatorservice.GeneratorExecutable#configure(de.urszeidler.eclipse.callchain.Generic_Generator)
	 */
	//@Override
	public void configure(Object generator) {
		super.configure(generator);
		String validate = validate(generator);
		if(!"".equals(validate))
			return;
		
		List<AbstractPropertiesInitializer> strategies = PropertiesInitializerStrategyServices.getInstance().getStrategies();
		for (AbstractPropertiesInitializer abstractPropertiesInitializer : strategies) {
			if(NAME.equals(abstractPropertiesInitializer.getName()))
				propertiesInitializer = abstractPropertiesInitializer;
		}
		
		//propertiesInitializer = strategies.get(0);
		
	}
	
	@Override
	protected String validateGG(Generic_Generator generator) {
		Model model = findModelByMetaModel(generator.getUses(), EMF_GENMODEL);
		if(model==null)
			return "no input model conformfs to http://www.eclipse.org/emf/2002/GenModel";
		
		modelURI = artifactToUri(model);
		if(modelURI==null)
			return "the model don't have a correct uri";
		
		EList<Artifact> produce = generator.getProduce();
		if(produce.size()==0)
			return "no output folder specified";
			
		Artifact artifact = produce.get(0);
		targetFolder = artifactToIContainter(artifact);
		if(targetFolder==null)
			return "target folder could not be found";
		
		return "";
	}
	/* (non-Javadoc)
	 * @see de.urszeidler.eclipse.callchain.generatorservice.GeneratorExecutable#execute(org.eclipse.core.runtime.IProgressMonitor)
	 */
	//@Override
	public void execute(IProgressMonitor monitor) {
		if(propertiesInitializer==null)
			return;
		
		try {
			propertiesInitializer.initialize(modelURI, targetFolder);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}


}
