/**
 * <copyright>
 * </copyright>
 *
 * $Id: CallImpl.java,v 1.1 2008/04/09 22:40:57 urs Exp $
 */
package de.urszeidler.eclipse.callchain.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import de.urszeidler.eclipse.callchain.Artifact;
import de.urszeidler.eclipse.callchain.AtlLibary;
import de.urszeidler.eclipse.callchain.AtlRes;
import de.urszeidler.eclipse.callchain.Call;
import de.urszeidler.eclipse.callchain.Callable;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.Calls;
import de.urszeidler.eclipse.callchain.Comment;
import de.urszeidler.eclipse.callchain.Eavaluateable;
import de.urszeidler.eclipse.callchain.Model;
import de.urszeidler.eclipse.callchain.Predicate;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Call</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallImpl#getComments <em>Comments</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallImpl#getNext <em>Next</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallImpl#isRefreshWorkspace <em>Refresh Workspace</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallImpl#getPredicate <em>Predicate</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallImpl#getIn <em>In</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallImpl#getOut <em>Out</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallImpl#getRes <em>Res</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallImpl#getLibarys <em>Libarys</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallImpl#isAllowInterModelReferences <em>Allow Inter Model References</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallImpl#isContinueAfterErrors <em>Continue After Errors</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallImpl#getArtifact <em>Artifact</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallImpl#getEnviorment <em>Enviorment</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallImpl#isShowSummary <em>Show Summary</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallImpl#isPrintExecutionTime <em>Print Execution Time</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallImpl#isDisableAttributeHelperCache <em>Disable Attribute Helper Cache</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.CallImpl#isProfile <em>Profile</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class CallImpl extends EObjectImpl implements Call {
	/**
	 * The cached value of the '{@link #getComments() <em>Comments</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getComments()
	 * @generated
	 * @ordered
	 */
	protected EList<Comment> comments;

	/**
	 * The cached value of the '{@link #getNext() <em>Next</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNext()
	 * @generated
	 * @ordered
	 */
	protected Callable next;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #isRefreshWorkspace() <em>Refresh Workspace</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isRefreshWorkspace()
	 * @generated
	 * @ordered
	 */
	protected static final boolean REFRESH_WORKSPACE_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isRefreshWorkspace() <em>Refresh Workspace</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isRefreshWorkspace()
	 * @generated
	 * @ordered
	 */
	protected boolean refreshWorkspace = REFRESH_WORKSPACE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getPredicate() <em>Predicate</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPredicate()
	 * @generated
	 * @ordered
	 */
	protected Predicate predicate;

	/**
	 * The cached value of the '{@link #getIn() <em>In</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIn()
	 * @generated
	 * @ordered
	 */
	protected EList<Model> in;

	/**
	 * The cached value of the '{@link #getOut() <em>Out</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOut()
	 * @generated
	 * @ordered
	 */
	protected EList<Model> out;

	/**
	 * The cached value of the '{@link #getRes() <em>Res</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRes()
	 * @generated
	 * @ordered
	 */
	protected AtlRes res;

	/**
	 * The cached value of the '{@link #getLibarys() <em>Libarys</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLibarys()
	 * @generated
	 * @ordered
	 */
	protected EList<AtlLibary> libarys;

	/**
	 * The default value of the '{@link #isAllowInterModelReferences() <em>Allow Inter Model References</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isAllowInterModelReferences()
	 * @generated
	 * @ordered
	 */
	protected static final boolean ALLOW_INTER_MODEL_REFERENCES_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isAllowInterModelReferences() <em>Allow Inter Model References</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isAllowInterModelReferences()
	 * @generated
	 * @ordered
	 */
	protected boolean allowInterModelReferences = ALLOW_INTER_MODEL_REFERENCES_EDEFAULT;

	/**
	 * The default value of the '{@link #isContinueAfterErrors() <em>Continue After Errors</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isContinueAfterErrors()
	 * @generated
	 * @ordered
	 */
	protected static final boolean CONTINUE_AFTER_ERRORS_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isContinueAfterErrors() <em>Continue After Errors</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isContinueAfterErrors()
	 * @generated
	 * @ordered
	 */
	protected boolean continueAfterErrors = CONTINUE_AFTER_ERRORS_EDEFAULT;

	/**
	 * The cached value of the '{@link #getArtifact() <em>Artifact</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getArtifact()
	 * @generated
	 * @ordered
	 */
	protected Artifact artifact;

	/**
	 * The default value of the '{@link #isShowSummary() <em>Show Summary</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isShowSummary()
	 * @generated
	 * @ordered
	 */
	protected static final boolean SHOW_SUMMARY_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isShowSummary() <em>Show Summary</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isShowSummary()
	 * @generated
	 * @ordered
	 */
	protected boolean showSummary = SHOW_SUMMARY_EDEFAULT;

	/**
	 * The default value of the '{@link #isPrintExecutionTime() <em>Print Execution Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPrintExecutionTime()
	 * @generated
	 * @ordered
	 */
	protected static final boolean PRINT_EXECUTION_TIME_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isPrintExecutionTime() <em>Print Execution Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPrintExecutionTime()
	 * @generated
	 * @ordered
	 */
	protected boolean printExecutionTime = PRINT_EXECUTION_TIME_EDEFAULT;

	/**
	 * The default value of the '{@link #isDisableAttributeHelperCache() <em>Disable Attribute Helper Cache</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isDisableAttributeHelperCache()
	 * @generated
	 * @ordered
	 */
	protected static final boolean DISABLE_ATTRIBUTE_HELPER_CACHE_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isDisableAttributeHelperCache() <em>Disable Attribute Helper Cache</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isDisableAttributeHelperCache()
	 * @generated
	 * @ordered
	 */
	protected boolean disableAttributeHelperCache = DISABLE_ATTRIBUTE_HELPER_CACHE_EDEFAULT;

	/**
	 * The default value of the '{@link #isProfile() <em>Profile</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isProfile()
	 * @generated
	 * @ordered
	 */
	protected static final boolean PROFILE_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isProfile() <em>Profile</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isProfile()
	 * @generated
	 * @ordered
	 */
	protected boolean profile = PROFILE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CallImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return CallchainPackage.Literals.CALL;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Comment> getComments() {
		if (comments == null) {
			comments = new EObjectContainmentWithInverseEList<Comment>(Comment.class, this, CallchainPackage.CALL__COMMENTS, CallchainPackage.COMMENT__OWNER);
		}
		return comments;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Callable getNext() {
		if (next != null && next.eIsProxy()) {
			InternalEObject oldNext = (InternalEObject)next;
			next = (Callable)eResolveProxy(oldNext);
			if (next != oldNext) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CallchainPackage.CALL__NEXT, oldNext, next));
			}
		}
		return next;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Callable basicGetNext() {
		return next;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNext(Callable newNext) {
		Callable oldNext = next;
		next = newNext;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.CALL__NEXT, oldNext, next));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.CALL__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isRefreshWorkspace() {
		return refreshWorkspace;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRefreshWorkspace(boolean newRefreshWorkspace) {
		boolean oldRefreshWorkspace = refreshWorkspace;
		refreshWorkspace = newRefreshWorkspace;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.CALL__REFRESH_WORKSPACE, oldRefreshWorkspace, refreshWorkspace));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Predicate getPredicate() {
		return predicate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPredicate(Predicate newPredicate, NotificationChain msgs) {
		Predicate oldPredicate = predicate;
		predicate = newPredicate;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CallchainPackage.CALL__PREDICATE, oldPredicate, newPredicate);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPredicate(Predicate newPredicate) {
		if (newPredicate != predicate) {
			NotificationChain msgs = null;
			if (predicate != null)
				msgs = ((InternalEObject)predicate).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CallchainPackage.CALL__PREDICATE, null, msgs);
			if (newPredicate != null)
				msgs = ((InternalEObject)newPredicate).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CallchainPackage.CALL__PREDICATE, null, msgs);
			msgs = basicSetPredicate(newPredicate, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.CALL__PREDICATE, newPredicate, newPredicate));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Model> getIn() {
		if (in == null) {
			in = new EObjectResolvingEList<Model>(Model.class, this, CallchainPackage.CALL__IN);
		}
		return in;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Model> getOut() {
		if (out == null) {
			out = new EObjectResolvingEList<Model>(Model.class, this, CallchainPackage.CALL__OUT);
		}
		return out;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AtlRes getRes() {
		if (res != null && res.eIsProxy()) {
			InternalEObject oldRes = (InternalEObject)res;
			res = (AtlRes)eResolveProxy(oldRes);
			if (res != oldRes) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CallchainPackage.CALL__RES, oldRes, res));
			}
		}
		return res;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AtlRes basicGetRes() {
		return res;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRes(AtlRes newRes) {
		AtlRes oldRes = res;
		res = newRes;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.CALL__RES, oldRes, res));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<AtlLibary> getLibarys() {
		if (libarys == null) {
			libarys = new EObjectResolvingEList<AtlLibary>(AtlLibary.class, this, CallchainPackage.CALL__LIBARYS);
		}
		return libarys;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isAllowInterModelReferences() {
		return allowInterModelReferences;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAllowInterModelReferences(boolean newAllowInterModelReferences) {
		boolean oldAllowInterModelReferences = allowInterModelReferences;
		allowInterModelReferences = newAllowInterModelReferences;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.CALL__ALLOW_INTER_MODEL_REFERENCES, oldAllowInterModelReferences, allowInterModelReferences));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isContinueAfterErrors() {
		return continueAfterErrors;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setContinueAfterErrors(boolean newContinueAfterErrors) {
		boolean oldContinueAfterErrors = continueAfterErrors;
		continueAfterErrors = newContinueAfterErrors;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.CALL__CONTINUE_AFTER_ERRORS, oldContinueAfterErrors, continueAfterErrors));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Artifact getArtifact() {
		if (artifact != null && artifact.eIsProxy()) {
			InternalEObject oldArtifact = (InternalEObject)artifact;
			artifact = (Artifact)eResolveProxy(oldArtifact);
			if (artifact != oldArtifact) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CallchainPackage.CALL__ARTIFACT, oldArtifact, artifact));
			}
		}
		return artifact;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Artifact basicGetArtifact() {
		return artifact;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setArtifact(Artifact newArtifact) {
		Artifact oldArtifact = artifact;
		artifact = newArtifact;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.CALL__ARTIFACT, oldArtifact, artifact));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Calls getEnviorment() {
		if (eContainerFeatureID() != CallchainPackage.CALL__ENVIORMENT) return null;
		return (Calls)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetEnviorment(Calls newEnviorment, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newEnviorment, CallchainPackage.CALL__ENVIORMENT, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEnviorment(Calls newEnviorment) {
		if (newEnviorment != eInternalContainer() || (eContainerFeatureID() != CallchainPackage.CALL__ENVIORMENT && newEnviorment != null)) {
			if (EcoreUtil.isAncestor(this, newEnviorment))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newEnviorment != null)
				msgs = ((InternalEObject)newEnviorment).eInverseAdd(this, CallchainPackage.CALLS__CALL, Calls.class, msgs);
			msgs = basicSetEnviorment(newEnviorment, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.CALL__ENVIORMENT, newEnviorment, newEnviorment));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isShowSummary() {
		return showSummary;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setShowSummary(boolean newShowSummary) {
		boolean oldShowSummary = showSummary;
		showSummary = newShowSummary;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.CALL__SHOW_SUMMARY, oldShowSummary, showSummary));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isPrintExecutionTime() {
		return printExecutionTime;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPrintExecutionTime(boolean newPrintExecutionTime) {
		boolean oldPrintExecutionTime = printExecutionTime;
		printExecutionTime = newPrintExecutionTime;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.CALL__PRINT_EXECUTION_TIME, oldPrintExecutionTime, printExecutionTime));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isDisableAttributeHelperCache() {
		return disableAttributeHelperCache;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDisableAttributeHelperCache(boolean newDisableAttributeHelperCache) {
		boolean oldDisableAttributeHelperCache = disableAttributeHelperCache;
		disableAttributeHelperCache = newDisableAttributeHelperCache;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.CALL__DISABLE_ATTRIBUTE_HELPER_CACHE, oldDisableAttributeHelperCache, disableAttributeHelperCache));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isProfile() {
		return profile;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setProfile(boolean newProfile) {
		boolean oldProfile = profile;
		profile = newProfile;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.CALL__PROFILE, oldProfile, profile));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated not
	 */
	public boolean evaluate() {
		if(predicate==null)
			return true;
		
		return predicate.evaluate();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CallchainPackage.CALL__COMMENTS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getComments()).basicAdd(otherEnd, msgs);
			case CallchainPackage.CALL__ENVIORMENT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetEnviorment((Calls)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CallchainPackage.CALL__COMMENTS:
				return ((InternalEList<?>)getComments()).basicRemove(otherEnd, msgs);
			case CallchainPackage.CALL__PREDICATE:
				return basicSetPredicate(null, msgs);
			case CallchainPackage.CALL__ENVIORMENT:
				return basicSetEnviorment(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case CallchainPackage.CALL__ENVIORMENT:
				return eInternalContainer().eInverseRemove(this, CallchainPackage.CALLS__CALL, Calls.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CallchainPackage.CALL__COMMENTS:
				return getComments();
			case CallchainPackage.CALL__NEXT:
				if (resolve) return getNext();
				return basicGetNext();
			case CallchainPackage.CALL__NAME:
				return getName();
			case CallchainPackage.CALL__REFRESH_WORKSPACE:
				return isRefreshWorkspace();
			case CallchainPackage.CALL__PREDICATE:
				return getPredicate();
			case CallchainPackage.CALL__IN:
				return getIn();
			case CallchainPackage.CALL__OUT:
				return getOut();
			case CallchainPackage.CALL__RES:
				if (resolve) return getRes();
				return basicGetRes();
			case CallchainPackage.CALL__LIBARYS:
				return getLibarys();
			case CallchainPackage.CALL__ALLOW_INTER_MODEL_REFERENCES:
				return isAllowInterModelReferences();
			case CallchainPackage.CALL__CONTINUE_AFTER_ERRORS:
				return isContinueAfterErrors();
			case CallchainPackage.CALL__ARTIFACT:
				if (resolve) return getArtifact();
				return basicGetArtifact();
			case CallchainPackage.CALL__ENVIORMENT:
				return getEnviorment();
			case CallchainPackage.CALL__SHOW_SUMMARY:
				return isShowSummary();
			case CallchainPackage.CALL__PRINT_EXECUTION_TIME:
				return isPrintExecutionTime();
			case CallchainPackage.CALL__DISABLE_ATTRIBUTE_HELPER_CACHE:
				return isDisableAttributeHelperCache();
			case CallchainPackage.CALL__PROFILE:
				return isProfile();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CallchainPackage.CALL__COMMENTS:
				getComments().clear();
				getComments().addAll((Collection<? extends Comment>)newValue);
				return;
			case CallchainPackage.CALL__NEXT:
				setNext((Callable)newValue);
				return;
			case CallchainPackage.CALL__NAME:
				setName((String)newValue);
				return;
			case CallchainPackage.CALL__REFRESH_WORKSPACE:
				setRefreshWorkspace((Boolean)newValue);
				return;
			case CallchainPackage.CALL__PREDICATE:
				setPredicate((Predicate)newValue);
				return;
			case CallchainPackage.CALL__IN:
				getIn().clear();
				getIn().addAll((Collection<? extends Model>)newValue);
				return;
			case CallchainPackage.CALL__OUT:
				getOut().clear();
				getOut().addAll((Collection<? extends Model>)newValue);
				return;
			case CallchainPackage.CALL__RES:
				setRes((AtlRes)newValue);
				return;
			case CallchainPackage.CALL__LIBARYS:
				getLibarys().clear();
				getLibarys().addAll((Collection<? extends AtlLibary>)newValue);
				return;
			case CallchainPackage.CALL__ALLOW_INTER_MODEL_REFERENCES:
				setAllowInterModelReferences((Boolean)newValue);
				return;
			case CallchainPackage.CALL__CONTINUE_AFTER_ERRORS:
				setContinueAfterErrors((Boolean)newValue);
				return;
			case CallchainPackage.CALL__ARTIFACT:
				setArtifact((Artifact)newValue);
				return;
			case CallchainPackage.CALL__ENVIORMENT:
				setEnviorment((Calls)newValue);
				return;
			case CallchainPackage.CALL__SHOW_SUMMARY:
				setShowSummary((Boolean)newValue);
				return;
			case CallchainPackage.CALL__PRINT_EXECUTION_TIME:
				setPrintExecutionTime((Boolean)newValue);
				return;
			case CallchainPackage.CALL__DISABLE_ATTRIBUTE_HELPER_CACHE:
				setDisableAttributeHelperCache((Boolean)newValue);
				return;
			case CallchainPackage.CALL__PROFILE:
				setProfile((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case CallchainPackage.CALL__COMMENTS:
				getComments().clear();
				return;
			case CallchainPackage.CALL__NEXT:
				setNext((Callable)null);
				return;
			case CallchainPackage.CALL__NAME:
				setName(NAME_EDEFAULT);
				return;
			case CallchainPackage.CALL__REFRESH_WORKSPACE:
				setRefreshWorkspace(REFRESH_WORKSPACE_EDEFAULT);
				return;
			case CallchainPackage.CALL__PREDICATE:
				setPredicate((Predicate)null);
				return;
			case CallchainPackage.CALL__IN:
				getIn().clear();
				return;
			case CallchainPackage.CALL__OUT:
				getOut().clear();
				return;
			case CallchainPackage.CALL__RES:
				setRes((AtlRes)null);
				return;
			case CallchainPackage.CALL__LIBARYS:
				getLibarys().clear();
				return;
			case CallchainPackage.CALL__ALLOW_INTER_MODEL_REFERENCES:
				setAllowInterModelReferences(ALLOW_INTER_MODEL_REFERENCES_EDEFAULT);
				return;
			case CallchainPackage.CALL__CONTINUE_AFTER_ERRORS:
				setContinueAfterErrors(CONTINUE_AFTER_ERRORS_EDEFAULT);
				return;
			case CallchainPackage.CALL__ARTIFACT:
				setArtifact((Artifact)null);
				return;
			case CallchainPackage.CALL__ENVIORMENT:
				setEnviorment((Calls)null);
				return;
			case CallchainPackage.CALL__SHOW_SUMMARY:
				setShowSummary(SHOW_SUMMARY_EDEFAULT);
				return;
			case CallchainPackage.CALL__PRINT_EXECUTION_TIME:
				setPrintExecutionTime(PRINT_EXECUTION_TIME_EDEFAULT);
				return;
			case CallchainPackage.CALL__DISABLE_ATTRIBUTE_HELPER_CACHE:
				setDisableAttributeHelperCache(DISABLE_ATTRIBUTE_HELPER_CACHE_EDEFAULT);
				return;
			case CallchainPackage.CALL__PROFILE:
				setProfile(PROFILE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CallchainPackage.CALL__COMMENTS:
				return comments != null && !comments.isEmpty();
			case CallchainPackage.CALL__NEXT:
				return next != null;
			case CallchainPackage.CALL__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case CallchainPackage.CALL__REFRESH_WORKSPACE:
				return refreshWorkspace != REFRESH_WORKSPACE_EDEFAULT;
			case CallchainPackage.CALL__PREDICATE:
				return predicate != null;
			case CallchainPackage.CALL__IN:
				return in != null && !in.isEmpty();
			case CallchainPackage.CALL__OUT:
				return out != null && !out.isEmpty();
			case CallchainPackage.CALL__RES:
				return res != null;
			case CallchainPackage.CALL__LIBARYS:
				return libarys != null && !libarys.isEmpty();
			case CallchainPackage.CALL__ALLOW_INTER_MODEL_REFERENCES:
				return allowInterModelReferences != ALLOW_INTER_MODEL_REFERENCES_EDEFAULT;
			case CallchainPackage.CALL__CONTINUE_AFTER_ERRORS:
				return continueAfterErrors != CONTINUE_AFTER_ERRORS_EDEFAULT;
			case CallchainPackage.CALL__ARTIFACT:
				return artifact != null;
			case CallchainPackage.CALL__ENVIORMENT:
				return getEnviorment() != null;
			case CallchainPackage.CALL__SHOW_SUMMARY:
				return showSummary != SHOW_SUMMARY_EDEFAULT;
			case CallchainPackage.CALL__PRINT_EXECUTION_TIME:
				return printExecutionTime != PRINT_EXECUTION_TIME_EDEFAULT;
			case CallchainPackage.CALL__DISABLE_ATTRIBUTE_HELPER_CACHE:
				return disableAttributeHelperCache != DISABLE_ATTRIBUTE_HELPER_CACHE_EDEFAULT;
			case CallchainPackage.CALL__PROFILE:
				return profile != PROFILE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == Callable.class) {
			switch (derivedFeatureID) {
				case CallchainPackage.CALL__NEXT: return CallchainPackage.CALLABLE__NEXT;
				case CallchainPackage.CALL__NAME: return CallchainPackage.CALLABLE__NAME;
				case CallchainPackage.CALL__REFRESH_WORKSPACE: return CallchainPackage.CALLABLE__REFRESH_WORKSPACE;
				default: return -1;
			}
		}
		if (baseClass == Eavaluateable.class) {
			switch (derivedFeatureID) {
				case CallchainPackage.CALL__PREDICATE: return CallchainPackage.EAVALUATEABLE__PREDICATE;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == Callable.class) {
			switch (baseFeatureID) {
				case CallchainPackage.CALLABLE__NEXT: return CallchainPackage.CALL__NEXT;
				case CallchainPackage.CALLABLE__NAME: return CallchainPackage.CALL__NAME;
				case CallchainPackage.CALLABLE__REFRESH_WORKSPACE: return CallchainPackage.CALL__REFRESH_WORKSPACE;
				default: return -1;
			}
		}
		if (baseClass == Eavaluateable.class) {
			switch (baseFeatureID) {
				case CallchainPackage.EAVALUATEABLE__PREDICATE: return CallchainPackage.CALL__PREDICATE;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", refreshWorkspace: ");
		result.append(refreshWorkspace);
		result.append(", allowInterModelReferences: ");
		result.append(allowInterModelReferences);
		result.append(", continueAfterErrors: ");
		result.append(continueAfterErrors);
		result.append(", showSummary: ");
		result.append(showSummary);
		result.append(", printExecutionTime: ");
		result.append(printExecutionTime);
		result.append(", disableAttributeHelperCache: ");
		result.append(disableAttributeHelperCache);
		result.append(", profile: ");
		result.append(profile);
		result.append(')');
		return result.toString();
	}

} //CallImpl
