/**
 * <copyright>
 * </copyright>
 *
 * $Id: CallchainFactoryImpl.java,v 1.3 2008/04/13 20:29:19 urs Exp $
 */
package de.urszeidler.eclipse.callchain.impl;

import de.urszeidler.eclipse.callchain.*;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.emf.ecore.plugin.EcorePlugin;

import de.urszeidler.eclipse.callchain.AndPredicate;
import de.urszeidler.eclipse.callchain.Artifact;
import de.urszeidler.eclipse.callchain.AtlLibary;
import de.urszeidler.eclipse.callchain.AtlRes;
import de.urszeidler.eclipse.callchain.Call;
import de.urszeidler.eclipse.callchain.CallchainFactory;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.Calls;
import de.urszeidler.eclipse.callchain.Comment;
import de.urszeidler.eclipse.callchain.ExternalCallable;
import de.urszeidler.eclipse.callchain.Generic_Generator;
import de.urszeidler.eclipse.callchain.MM;
import de.urszeidler.eclipse.callchain.MMAlias;
import de.urszeidler.eclipse.callchain.MMhandler;
import de.urszeidler.eclipse.callchain.Model;
import de.urszeidler.eclipse.callchain.ModelAlias;
import de.urszeidler.eclipse.callchain.NotPredicate;
import de.urszeidler.eclipse.callchain.OrPredicate;
import de.urszeidler.eclipse.callchain.PredicateSwitch;
import de.urszeidler.eclipse.callchain.Property;
import de.urszeidler.eclipse.callchain.PropertyExist;
import de.urszeidler.eclipse.callchain.PropertyHasValue;
import de.urszeidler.eclipse.callchain.PropertyValueSwitch;
import de.urszeidler.eclipse.callchain.ResourceExistPredicate;
import de.urszeidler.eclipse.callchain.Transition;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class CallchainFactoryImpl extends EFactoryImpl implements CallchainFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static CallchainFactory init() {
		try {
			CallchainFactory theCallchainFactory = (CallchainFactory)EPackage.Registry.INSTANCE.getEFactory("http://urszeidler.de/callchain/2010/flowmodel"); 
			if (theCallchainFactory != null) {
				return theCallchainFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new CallchainFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallchainFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case CallchainPackage.MODEL: return createModel();
			case CallchainPackage.ATL_RES: return createAtlRes();
			case CallchainPackage.CALL: return createCall();
			case CallchainPackage.MM: return createMM();
			case CallchainPackage.CALLS: return createCalls();
			case CallchainPackage.ATL_LIBARY: return createAtlLibary();
			case CallchainPackage.MODEL_ALIAS: return createModelAlias();
			case CallchainPackage.ARTIFACT: return createArtifact();
			case CallchainPackage.MM_ALIAS: return createMMAlias();
			case CallchainPackage.COMMENT: return createComment();
			case CallchainPackage.GENERIC_GENERATOR: return createGeneric_Generator();
			case CallchainPackage.PROPERTY: return createProperty();
			case CallchainPackage.PREDICATE_SWITCH: return createPredicateSwitch();
			case CallchainPackage.TRANSITION: return createTransition();
			case CallchainPackage.PROPERTY_HAS_VALUE: return createPropertyHasValue();
			case CallchainPackage.PROPERTY_EXIST: return createPropertyExist();
			case CallchainPackage.RESOURCE_EXIST_PREDICATE: return createResourceExistPredicate();
			case CallchainPackage.AND_PREDICATE: return createAndPredicate();
			case CallchainPackage.OR_PREDICATE: return createOrPredicate();
			case CallchainPackage.NOT_PREDICATE: return createNotPredicate();
			case CallchainPackage.PROPERTY_VALUE_SWITCH: return createPropertyValueSwitch();
			case CallchainPackage.EXTERNAL_CALLABLE: return createExternalCallable();
			case CallchainPackage.STOP_CALL: return createStopCall();
			case CallchainPackage.BOOLEAN_PREDICATE: return createBooleanPredicate();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case CallchainPackage.MMHANDLER:
				return createMMhandlerFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case CallchainPackage.MMHANDLER:
				return convertMMhandlerToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Model createModel() {
		ModelImpl model = new ModelImpl();
		return model;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AtlRes createAtlRes() {
		AtlResImpl atlRes = new AtlResImpl();
		return atlRes;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Call createCall() {
		CallImpl call = new CallImpl();
		return call;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MM createMM() {
		MMImpl mm = new MMImpl();
		return mm;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Calls createCalls() {
		CallsImpl calls = new CallsImpl();
		return calls;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AtlLibary createAtlLibary() {
		AtlLibaryImpl atlLibary = new AtlLibaryImpl();
		return atlLibary;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ModelAlias createModelAlias() {
		ModelAliasImpl modelAlias = new ModelAliasImpl();
		return modelAlias;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Artifact createArtifact() {
		ArtifactImpl artifact = new ArtifactImpl();
		return artifact;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MMAlias createMMAlias() {
		MMAliasImpl mmAlias = new MMAliasImpl();
		return mmAlias;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Comment createComment() {
		CommentImpl comment = new CommentImpl();
		return comment;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Generic_Generator createGeneric_Generator() {
		Generic_GeneratorImpl generic_Generator = new Generic_GeneratorImpl();
		return generic_Generator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Property createProperty() {
		PropertyImpl property = new PropertyImpl();
		return property;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PredicateSwitch createPredicateSwitch() {
		PredicateSwitchImpl predicateSwitch = new PredicateSwitchImpl();
		return predicateSwitch;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Transition createTransition() {
		TransitionImpl transition = new TransitionImpl();
		return transition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyHasValue createPropertyHasValue() {
		PropertyHasValueImpl propertyHasValue = new PropertyHasValueImpl();
		return propertyHasValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyExist createPropertyExist() {
		PropertyExistImpl propertyExist = new PropertyExistImpl();
		return propertyExist;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResourceExistPredicate createResourceExistPredicate() {
		ResourceExistPredicateImpl resourceExistPredicate = new ResourceExistPredicateImpl();
		return resourceExistPredicate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AndPredicate createAndPredicate() {
		AndPredicateImpl andPredicate = new AndPredicateImpl();
		return andPredicate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OrPredicate createOrPredicate() {
		OrPredicateImpl orPredicate = new OrPredicateImpl();
		return orPredicate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotPredicate createNotPredicate() {
		NotPredicateImpl notPredicate = new NotPredicateImpl();
		return notPredicate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyValueSwitch createPropertyValueSwitch() {
		PropertyValueSwitchImpl propertyValueSwitch = new PropertyValueSwitchImpl();
		return propertyValueSwitch;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExternalCallable createExternalCallable() {
		ExternalCallableImpl externalCallable = new ExternalCallableImpl();
		return externalCallable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StopCall createStopCall() {
		StopCallImpl stopCall = new StopCallImpl();
		return stopCall;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BooleanPredicate createBooleanPredicate() {
		BooleanPredicateImpl booleanPredicate = new BooleanPredicateImpl();
		return booleanPredicate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MMhandler createMMhandlerFromString(EDataType eDataType, String initialValue) {
		MMhandler result = MMhandler.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertMMhandlerToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallchainPackage getCallchainPackage() {
		return (CallchainPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static CallchainPackage getPackage() {
		return CallchainPackage.eINSTANCE;
	}

} //CallchainFactoryImpl
