/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package de.urszeidler.eclipse.callchain.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;

import org.eclipse.emf.ecore.util.InternalEList;
import de.urszeidler.eclipse.callchain.Callable;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.Calls;
import de.urszeidler.eclipse.callchain.Comment;
import de.urszeidler.eclipse.callchain.Documentable;
import de.urszeidler.eclipse.callchain.Eavaluateable;
import de.urszeidler.eclipse.callchain.ExternalCallable;
import de.urszeidler.eclipse.callchain.Predicate;
import java.util.Collection;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>External Callable</b></em>'.
 * it calls an ectarnel callable.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.ExternalCallableImpl#getNext <em>Next</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.ExternalCallableImpl#getName <em>Name</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.ExternalCallableImpl#isRefreshWorkspace <em>Refresh Workspace</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.ExternalCallableImpl#getComments <em>Comments</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.ExternalCallableImpl#getPredicate <em>Predicate</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.ExternalCallableImpl#getDelegatedCallable <em>Delegated Callable</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.ExternalCallableImpl#getEnviorment <em>Enviorment</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ExternalCallableImpl extends EObjectImpl implements ExternalCallable {
	/**
	 * The cached value of the '{@link #getNext() <em>Next</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNext()
	 * @generated
	 * @ordered
	 */
	protected Callable next;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #isRefreshWorkspace() <em>Refresh Workspace</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isRefreshWorkspace()
	 * @generated
	 * @ordered
	 */
	protected static final boolean REFRESH_WORKSPACE_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isRefreshWorkspace() <em>Refresh Workspace</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isRefreshWorkspace()
	 * @generated
	 * @ordered
	 */
	protected boolean refreshWorkspace = REFRESH_WORKSPACE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getComments() <em>Comments</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getComments()
	 * @generated
	 * @ordered
	 */
	protected EList<Comment> comments;

	/**
	 * The cached value of the '{@link #getPredicate() <em>Predicate</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPredicate()
	 * @generated
	 * @ordered
	 */
	protected Predicate predicate;

	/**
	 * The cached value of the '{@link #getDelegatedCallable() <em>Delegated Callable</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDelegatedCallable()
	 * @generated
	 * @ordered
	 */
	protected Callable delegatedCallable;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExternalCallableImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return CallchainPackage.Literals.EXTERNAL_CALLABLE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Callable getNext() {
		if (next != null && next.eIsProxy()) {
			InternalEObject oldNext = (InternalEObject)next;
			next = (Callable)eResolveProxy(oldNext);
			if (next != oldNext) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CallchainPackage.EXTERNAL_CALLABLE__NEXT, oldNext, next));
			}
		}
		return next;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Callable basicGetNext() {
		return next;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNext(Callable newNext) {
		Callable oldNext = next;
		next = newNext;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.EXTERNAL_CALLABLE__NEXT, oldNext, next));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.EXTERNAL_CALLABLE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isRefreshWorkspace() {
		return refreshWorkspace;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRefreshWorkspace(boolean newRefreshWorkspace) {
		boolean oldRefreshWorkspace = refreshWorkspace;
		refreshWorkspace = newRefreshWorkspace;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.EXTERNAL_CALLABLE__REFRESH_WORKSPACE, oldRefreshWorkspace, refreshWorkspace));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Comment> getComments() {
		if (comments == null) {
			comments = new EObjectContainmentWithInverseEList<Comment>(Comment.class, this, CallchainPackage.EXTERNAL_CALLABLE__COMMENTS, CallchainPackage.COMMENT__OWNER);
		}
		return comments;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Predicate getPredicate() {
		return predicate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPredicate(Predicate newPredicate, NotificationChain msgs) {
		Predicate oldPredicate = predicate;
		predicate = newPredicate;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CallchainPackage.EXTERNAL_CALLABLE__PREDICATE, oldPredicate, newPredicate);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPredicate(Predicate newPredicate) {
		if (newPredicate != predicate) {
			NotificationChain msgs = null;
			if (predicate != null)
				msgs = ((InternalEObject)predicate).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CallchainPackage.EXTERNAL_CALLABLE__PREDICATE, null, msgs);
			if (newPredicate != null)
				msgs = ((InternalEObject)newPredicate).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CallchainPackage.EXTERNAL_CALLABLE__PREDICATE, null, msgs);
			msgs = basicSetPredicate(newPredicate, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.EXTERNAL_CALLABLE__PREDICATE, newPredicate, newPredicate));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Callable getDelegatedCallable() {
		if (delegatedCallable != null && delegatedCallable.eIsProxy()) {
			InternalEObject oldDelegatedCallable = (InternalEObject)delegatedCallable;
			delegatedCallable = (Callable)eResolveProxy(oldDelegatedCallable);
			if (delegatedCallable != oldDelegatedCallable) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CallchainPackage.EXTERNAL_CALLABLE__DELEGATED_CALLABLE, oldDelegatedCallable, delegatedCallable));
			}
		}
		return delegatedCallable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Callable basicGetDelegatedCallable() {
		return delegatedCallable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDelegatedCallable(Callable newDelegatedCallable) {
		Callable oldDelegatedCallable = delegatedCallable;
		delegatedCallable = newDelegatedCallable;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.EXTERNAL_CALLABLE__DELEGATED_CALLABLE, oldDelegatedCallable, delegatedCallable));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Calls getEnviorment() {
		if (eContainerFeatureID() != CallchainPackage.EXTERNAL_CALLABLE__ENVIORMENT) return null;
		return (Calls)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetEnviorment(Calls newEnviorment, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newEnviorment, CallchainPackage.EXTERNAL_CALLABLE__ENVIORMENT, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEnviorment(Calls newEnviorment) {
		if (newEnviorment != eInternalContainer() || (eContainerFeatureID() != CallchainPackage.EXTERNAL_CALLABLE__ENVIORMENT && newEnviorment != null)) {
			if (EcoreUtil.isAncestor(this, newEnviorment))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newEnviorment != null)
				msgs = ((InternalEObject)newEnviorment).eInverseAdd(this, CallchainPackage.CALLS__EXTERN_CALLABLES, Calls.class, msgs);
			msgs = basicSetEnviorment(newEnviorment, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.EXTERNAL_CALLABLE__ENVIORMENT, newEnviorment, newEnviorment));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated not
	 */
	public boolean evaluate() {
		if(predicate==null)
			return true;
		
		return predicate.evaluate();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CallchainPackage.EXTERNAL_CALLABLE__COMMENTS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getComments()).basicAdd(otherEnd, msgs);
			case CallchainPackage.EXTERNAL_CALLABLE__ENVIORMENT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetEnviorment((Calls)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CallchainPackage.EXTERNAL_CALLABLE__COMMENTS:
				return ((InternalEList<?>)getComments()).basicRemove(otherEnd, msgs);
			case CallchainPackage.EXTERNAL_CALLABLE__PREDICATE:
				return basicSetPredicate(null, msgs);
			case CallchainPackage.EXTERNAL_CALLABLE__ENVIORMENT:
				return basicSetEnviorment(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case CallchainPackage.EXTERNAL_CALLABLE__ENVIORMENT:
				return eInternalContainer().eInverseRemove(this, CallchainPackage.CALLS__EXTERN_CALLABLES, Calls.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CallchainPackage.EXTERNAL_CALLABLE__NEXT:
				if (resolve) return getNext();
				return basicGetNext();
			case CallchainPackage.EXTERNAL_CALLABLE__NAME:
				return getName();
			case CallchainPackage.EXTERNAL_CALLABLE__REFRESH_WORKSPACE:
				return isRefreshWorkspace();
			case CallchainPackage.EXTERNAL_CALLABLE__COMMENTS:
				return getComments();
			case CallchainPackage.EXTERNAL_CALLABLE__PREDICATE:
				return getPredicate();
			case CallchainPackage.EXTERNAL_CALLABLE__DELEGATED_CALLABLE:
				if (resolve) return getDelegatedCallable();
				return basicGetDelegatedCallable();
			case CallchainPackage.EXTERNAL_CALLABLE__ENVIORMENT:
				return getEnviorment();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CallchainPackage.EXTERNAL_CALLABLE__NEXT:
				setNext((Callable)newValue);
				return;
			case CallchainPackage.EXTERNAL_CALLABLE__NAME:
				setName((String)newValue);
				return;
			case CallchainPackage.EXTERNAL_CALLABLE__REFRESH_WORKSPACE:
				setRefreshWorkspace((Boolean)newValue);
				return;
			case CallchainPackage.EXTERNAL_CALLABLE__COMMENTS:
				getComments().clear();
				getComments().addAll((Collection<? extends Comment>)newValue);
				return;
			case CallchainPackage.EXTERNAL_CALLABLE__PREDICATE:
				setPredicate((Predicate)newValue);
				return;
			case CallchainPackage.EXTERNAL_CALLABLE__DELEGATED_CALLABLE:
				setDelegatedCallable((Callable)newValue);
				return;
			case CallchainPackage.EXTERNAL_CALLABLE__ENVIORMENT:
				setEnviorment((Calls)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case CallchainPackage.EXTERNAL_CALLABLE__NEXT:
				setNext((Callable)null);
				return;
			case CallchainPackage.EXTERNAL_CALLABLE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case CallchainPackage.EXTERNAL_CALLABLE__REFRESH_WORKSPACE:
				setRefreshWorkspace(REFRESH_WORKSPACE_EDEFAULT);
				return;
			case CallchainPackage.EXTERNAL_CALLABLE__COMMENTS:
				getComments().clear();
				return;
			case CallchainPackage.EXTERNAL_CALLABLE__PREDICATE:
				setPredicate((Predicate)null);
				return;
			case CallchainPackage.EXTERNAL_CALLABLE__DELEGATED_CALLABLE:
				setDelegatedCallable((Callable)null);
				return;
			case CallchainPackage.EXTERNAL_CALLABLE__ENVIORMENT:
				setEnviorment((Calls)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CallchainPackage.EXTERNAL_CALLABLE__NEXT:
				return next != null;
			case CallchainPackage.EXTERNAL_CALLABLE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case CallchainPackage.EXTERNAL_CALLABLE__REFRESH_WORKSPACE:
				return refreshWorkspace != REFRESH_WORKSPACE_EDEFAULT;
			case CallchainPackage.EXTERNAL_CALLABLE__COMMENTS:
				return comments != null && !comments.isEmpty();
			case CallchainPackage.EXTERNAL_CALLABLE__PREDICATE:
				return predicate != null;
			case CallchainPackage.EXTERNAL_CALLABLE__DELEGATED_CALLABLE:
				return delegatedCallable != null;
			case CallchainPackage.EXTERNAL_CALLABLE__ENVIORMENT:
				return getEnviorment() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == Documentable.class) {
			switch (derivedFeatureID) {
				case CallchainPackage.EXTERNAL_CALLABLE__COMMENTS: return CallchainPackage.DOCUMENTABLE__COMMENTS;
				default: return -1;
			}
		}
		if (baseClass == Eavaluateable.class) {
			switch (derivedFeatureID) {
				case CallchainPackage.EXTERNAL_CALLABLE__PREDICATE: return CallchainPackage.EAVALUATEABLE__PREDICATE;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == Documentable.class) {
			switch (baseFeatureID) {
				case CallchainPackage.DOCUMENTABLE__COMMENTS: return CallchainPackage.EXTERNAL_CALLABLE__COMMENTS;
				default: return -1;
			}
		}
		if (baseClass == Eavaluateable.class) {
			switch (baseFeatureID) {
				case CallchainPackage.EAVALUATEABLE__PREDICATE: return CallchainPackage.EXTERNAL_CALLABLE__PREDICATE;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", refreshWorkspace: ");
		result.append(refreshWorkspace);
		result.append(')');
		return result.toString();
	}

} //ExternalCallableImpl
