/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package de.urszeidler.eclipse.callchain.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import de.urszeidler.eclipse.callchain.Callable;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.Predicate;
import de.urszeidler.eclipse.callchain.PredicateSwitch;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Predicate Switch</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.PredicateSwitchImpl#getTrueCallable <em>True Callable</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.PredicateSwitchImpl#getFalseCallable <em>False Callable</em>}</li>
 *   <li>{@link de.urszeidler.eclipse.callchain.impl.PredicateSwitchImpl#getPredicate <em>Predicate</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class PredicateSwitchImpl extends SwitchImpl implements PredicateSwitch {
	/**
	 * The cached value of the '{@link #getTrueCallable() <em>True Callable</em>}' reference.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getTrueCallable()
	 * @generated
	 * @ordered
	 */
	protected Callable trueCallable;

	/**
	 * The cached value of the '{@link #getFalseCallable() <em>False Callable</em>}' reference.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @see #getFalseCallable()
	 * @generated
	 * @ordered
	 */
	protected Callable falseCallable;

	/**
	 * The cached value of the '{@link #getPredicate() <em>Predicate</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getPredicate()
	 * @generated
	 * @ordered
	 */
	protected Predicate predicate;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected PredicateSwitchImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return CallchainPackage.Literals.PREDICATE_SWITCH;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Callable getTrueCallable() {
		if (trueCallable != null && trueCallable.eIsProxy()) {
			InternalEObject oldTrueCallable = (InternalEObject)trueCallable;
			trueCallable = (Callable)eResolveProxy(oldTrueCallable);
			if (trueCallable != oldTrueCallable) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CallchainPackage.PREDICATE_SWITCH__TRUE_CALLABLE, oldTrueCallable, trueCallable));
			}
		}
		return trueCallable;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Callable basicGetTrueCallable() {
		return trueCallable;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setTrueCallable(Callable newTrueCallable) {
		Callable oldTrueCallable = trueCallable;
		trueCallable = newTrueCallable;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.PREDICATE_SWITCH__TRUE_CALLABLE, oldTrueCallable, trueCallable));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Callable getFalseCallable() {
		if (falseCallable != null && falseCallable.eIsProxy()) {
			InternalEObject oldFalseCallable = (InternalEObject)falseCallable;
			falseCallable = (Callable)eResolveProxy(oldFalseCallable);
			if (falseCallable != oldFalseCallable) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CallchainPackage.PREDICATE_SWITCH__FALSE_CALLABLE, oldFalseCallable, falseCallable));
			}
		}
		return falseCallable;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Callable basicGetFalseCallable() {
		return falseCallable;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setFalseCallable(Callable newFalseCallable) {
		Callable oldFalseCallable = falseCallable;
		falseCallable = newFalseCallable;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.PREDICATE_SWITCH__FALSE_CALLABLE, oldFalseCallable, falseCallable));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Predicate getPredicate() {
		return predicate;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPredicate(Predicate newPredicate,
			NotificationChain msgs) {
		Predicate oldPredicate = predicate;
		predicate = newPredicate;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CallchainPackage.PREDICATE_SWITCH__PREDICATE, oldPredicate, newPredicate);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setPredicate(Predicate newPredicate) {
		if (newPredicate != predicate) {
			NotificationChain msgs = null;
			if (predicate != null)
				msgs = ((InternalEObject)predicate).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CallchainPackage.PREDICATE_SWITCH__PREDICATE, null, msgs);
			if (newPredicate != null)
				msgs = ((InternalEObject)newPredicate).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CallchainPackage.PREDICATE_SWITCH__PREDICATE, null, msgs);
			msgs = basicSetPredicate(newPredicate, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CallchainPackage.PREDICATE_SWITCH__PREDICATE, newPredicate, newPredicate));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CallchainPackage.PREDICATE_SWITCH__PREDICATE:
				return basicSetPredicate(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CallchainPackage.PREDICATE_SWITCH__TRUE_CALLABLE:
				if (resolve) return getTrueCallable();
				return basicGetTrueCallable();
			case CallchainPackage.PREDICATE_SWITCH__FALSE_CALLABLE:
				if (resolve) return getFalseCallable();
				return basicGetFalseCallable();
			case CallchainPackage.PREDICATE_SWITCH__PREDICATE:
				return getPredicate();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CallchainPackage.PREDICATE_SWITCH__TRUE_CALLABLE:
				setTrueCallable((Callable)newValue);
				return;
			case CallchainPackage.PREDICATE_SWITCH__FALSE_CALLABLE:
				setFalseCallable((Callable)newValue);
				return;
			case CallchainPackage.PREDICATE_SWITCH__PREDICATE:
				setPredicate((Predicate)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case CallchainPackage.PREDICATE_SWITCH__TRUE_CALLABLE:
				setTrueCallable((Callable)null);
				return;
			case CallchainPackage.PREDICATE_SWITCH__FALSE_CALLABLE:
				setFalseCallable((Callable)null);
				return;
			case CallchainPackage.PREDICATE_SWITCH__PREDICATE:
				setPredicate((Predicate)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CallchainPackage.PREDICATE_SWITCH__TRUE_CALLABLE:
				return trueCallable != null;
			case CallchainPackage.PREDICATE_SWITCH__FALSE_CALLABLE:
				return falseCallable != null;
			case CallchainPackage.PREDICATE_SWITCH__PREDICATE:
				return predicate != null;
		}
		return super.eIsSet(featureID);
	}

	@Override
	public Callable doSwitch() {
		if(predicate==null)
			return falseCallable;
		
		if (predicate.evaluate())
			return trueCallable;

		return falseCallable;
	}

	@Override
	public EList<Callable> getAllCallables() {
		BasicEList<Callable> basicEList = new BasicEList<Callable>(2);
		if (trueCallable != null)
			basicEList.add(trueCallable);
		if (falseCallable != null)
			basicEList.add(falseCallable);

		return basicEList;
	}
} // PredicateSwitchImpl
