/*
 * (c) urs zeidler
 */
package de.urszeidler.eclipse.callchain.lauching.ui;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.eclipse.core.resources.IContainer;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.debug.core.ILaunchConfiguration;
import org.eclipse.debug.core.ILaunchConfigurationWorkingCopy;
import org.eclipse.debug.ui.AbstractLaunchConfigurationTab;
import org.eclipse.debug.ui.ILaunchConfigurationTab;
import org.eclipse.emf.common.util.EList;
import org.eclipse.jface.databinding.swt.ISWTObservableValue;
import org.eclipse.jface.databinding.swt.SWTObservables;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.viewers.CheckStateChangedEvent;
import org.eclipse.jface.viewers.CheckboxTableViewer;
import org.eclipse.jface.viewers.ICheckStateListener;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.dialogs.ElementTreeSelectionDialog;
import org.eclipse.ui.model.BaseWorkbenchContentProvider;
import org.eclipse.ui.model.WorkbenchLabelProvider;

import de.urszeidler.eclipse.callchain.Call;
import de.urszeidler.eclipse.callchain.Callable;
import de.urszeidler.eclipse.callchain.Calls;
import de.urszeidler.eclipse.callchain.ExternalCallable;
import de.urszeidler.eclipse.callchain.Generator;
import de.urszeidler.eclipse.callchain.Switch;
import de.urszeidler.eclipse.callchain.lauching.core.CallchainConfiguration;
import de.urszeidler.eclipse.callchain.lauching.core.CallchainLaunchConfigurationDelegate;
import de.urszeidler.eclipse.swt.SWTWidgetFactory;

/**
 * <p>
 * CallchainTab
 * </p>
 * Created : 03.06.2008
 * 
 * @author urs
 * @version $Revision$, $Id$
 */
public class CallchainTab extends AbstractLaunchConfigurationTab implements ILaunchConfigurationTab {
	private Text resourceUri;
	// private Text name;
	private Button btnWorkspaceBrowse;
	private Button btnFileBrowse;
	private Combo callableCombobox;
	// private ModifyListener modifyListener;
	private Button checkBox_chaincall;
	// private org.eclipse.swt.widgets.List skippList;
	// protected Calls calls;
	// private ListViewer skippList1;
	private CheckboxTableViewer viewer;
	private List<Callable> skipList_list;
	private List<String> callablesToSkipp = new ArrayList<String>();
	private Button checkBox_clearConsole;
	private CallchainLaunchConfigurationTabGroup tabGroup;
	protected String selectedCallable;

	public CallchainTab(CallchainLaunchConfigurationTabGroup callchainLaunchConfigurationTabGroup) {
		super();
		tabGroup = callchainLaunchConfigurationTabGroup;

	}

	public void createControl(Composite parent) {
		Composite comp = new Composite(parent, SWT.NONE);
		setControl(comp);
		comp.setLayout(new GridLayout(1, true));
		comp.setLayoutData(new GridData(1, 1, true, true));
		comp.setFont(parent.getFont());

		createBasicConfigGui(comp);
		createScipCallableConfigGui(comp);
	}

	private void createScipCallableConfigGui(Composite parent) {
		Group group = SWTWidgetFactory.createGroup(parent, "skip callable", 5, 8, GridData.FILL_BOTH);
		Composite comp = SWTWidgetFactory.createComposite(group, 5, 8, GridData.FILL_BOTH);
		GridLayout ld = (GridLayout) comp.getLayout();
		ld.marginWidth = 1;
		ld.marginHeight = 1;

		GridData gd = null;

		// CallchainAdapterFactory callchainAdapterFactory = new
		// CallchainAdapterFactory();

		// skippList = new org.eclipse.swt.widgets.List(parent, SWT.MULTI);
		viewer = CheckboxTableViewer.newCheckList(comp, SWT.MULTI);

		gd = new GridData(GridData.FILL_BOTH);
		gd.horizontalSpan = 5;
		gd.verticalSpan = 7;
		gd.verticalAlignment = SWT.FILL;
		gd.grabExcessHorizontalSpace = true;
		gd.grabExcessVerticalSpace = true;

		viewer.getTable().setLayoutData(gd);
		viewer.setContentProvider(new IStructuredContentProvider() {

			public void dispose() {
			}

			public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
			}

			public Object[] getElements(Object inputElement) {
				if (inputElement instanceof List<?>) {
					List<?> list = (List<?>) inputElement;
					return list.toArray();
				}// end of if (inputElement instanceof List)
				return null;
			}

		});

		viewer.setLabelProvider(tabGroup.getItemProvider());

		viewer.addCheckStateListener(new ICheckStateListener() {

			public void checkStateChanged(CheckStateChangedEvent event) {
				buildCallablesToSkipp();
				updateLaunchConfigurationDialog();

			}
		});

	}

	protected void buildCallablesToSkipp() {
		Object[] checkedElements = viewer.getCheckedElements();
		callablesToSkipp.clear();
		for (Object object : checkedElements) {
			callablesToSkipp.add(callableToName((Callable) object));
		}

	}

	private void createBasicConfigGui(Composite parent) {
		Group group = SWTWidgetFactory.createGroup(parent, "basic config", 5, 2, GridData.FILL_HORIZONTAL);
		Composite comp = SWTWidgetFactory.createComposite(group, 5, 5, GridData.FILL_BOTH);
		GridLayout ld = (GridLayout) comp.getLayout();
		ld.marginWidth = 1;
		ld.marginHeight = 1;

		GridData gd = new GridData(SWT.BEGINNING, SWT.NORMAL, true, false);
		gd.horizontalSpan = 15;
		SWTWidgetFactory.createLabel(comp, "callchain model", 1);
		resourceUri = SWTWidgetFactory.createSingleText(comp, 2);
		resourceUri.setData(CallchainConfiguration.CALLCHAINURI);
		// binding
		ISWTObservableValue observeText = SWTObservables.observeText(resourceUri, SWT.Modify);
		tabGroup.getDbc().bindValue(observeText, tabGroup.getResourceUri());

		// resourceUri.addModifyListener(modifyListener);

		btnWorkspaceBrowse = createPushButton(comp, "workspace", null); //$NON-NLS-1$
		btnWorkspaceBrowse.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				showWorkspaceDialog(resourceUri);
			}
		});

		btnFileBrowse = createPushButton(comp, "file", null);
		btnFileBrowse.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				showFileDialog(resourceUri);
			}
		});

		SWTWidgetFactory.createLabel(comp, "transformation to start", 1);
		callableCombobox = new Combo(comp, SWT.DROP_DOWN);
		callableCombobox.setData(CallchainConfiguration.CALLABLENAME);
		callableCombobox.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent e) {
				fillSkipables(callableCombobox.getText());
				selectedCallable = callableCombobox.getText();
				updateLaunchConfigurationDialog();
			}

			@Override
			public void widgetDefaultSelected(SelectionEvent e) {
				// TODO Auto-generated method stub

			}
		});

		callableCombobox.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				selectedCallable = callableCombobox.getText();
				fillSkipables(callableCombobox.getText());//
				updateLaunchConfigurationDialog();
			}
		});
		gd = new GridData(GridData.FILL_HORIZONTAL);
		gd.horizontalSpan = 4;
		callableCombobox.setLayoutData(gd);

		SWTWidgetFactory.createLabel(comp, "", 1);
		checkBox_chaincall = new Button(comp, SWT.CHECK);
		checkBox_chaincall.setText("execute in chain");
		gd = new GridData(GridData.FILL_HORIZONTAL);
		gd.horizontalSpan = 4;
		checkBox_chaincall.setLayoutData(gd);
		checkBox_chaincall.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				viewer.getTable().setEnabled(checkBox_chaincall.getSelection());
				updateLaunchConfigurationDialog();
			}
		});

		SWTWidgetFactory.createLabel(comp, "", 1);
		checkBox_clearConsole = new Button(comp, SWT.CHECK);
		checkBox_clearConsole.setText("clear console");
		gd = new GridData(GridData.FILL_HORIZONTAL);
		gd.horizontalSpan = 4;
		checkBox_clearConsole.setLayoutData(gd);
		checkBox_clearConsole.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				updateLaunchConfigurationDialog();
			}
		});

	}

	protected void fillSkipables(String text) {
		if (tabGroup.getCalls() == null)
			return;

		Callable c = getCallable(text);
		if (c == null){
			viewer.setInput(Collections.EMPTY_LIST);			
			return;
		}
		skipList_list = new ArrayList<Callable>();
		while (c != null) {
			skipList_list.add(c);
			c = c.getNext();

		}
		viewer.setInput(skipList_list);
	}

	private String callableToName(Callable c) {
		if (c instanceof Call) {
			Call call = (Call) c;
			return call.getName();
		}// end of if (c instanceof Call)
		if (c instanceof Generator) {
			Generator generator = (Generator) c;
			return generator.getName();
		}// end of if (c instanceof Generator)
		return null;
	}

	private Callable getCallable(String text) {
		EList<Call> list = tabGroup.getCalls().getCall();
		for (Call call : list) {
			if (call.getName() != null) {
				if (text.endsWith(call.getName()))
					return call;
			}
		}
		EList<Generator> generators = tabGroup.getCalls().getGenerators();
		for (Generator generator : generators) {
			if (generator.getName() != null) {
				if (text.endsWith(generator.getName()))
					return generator;
			}
		}

		return null;
	}

	protected void fillCallableCombobox(Calls calls) {
		if (calls == null || callableCombobox == null)
			return;

		List<String> itemlist = new ArrayList<String>();
		EList<Call> list = calls.getCall();
		for (Call call : list) {
			if (call.getName() != null) {
				if (calls.getDefaultStartPoint() == call)
					itemlist.add("[default] " + call.getName());
				else if (calls.getStartPoints().contains(call))
					itemlist.add("[startpoint] " + call.getName());
				else
					itemlist.add(call.getName());
			}
		}
		EList<Generator> generators = calls.getGenerators();
		for (Generator generator : generators) {
			if (generator.getName() != null) {
				itemlist.add(generator.getName());
			}
		}

		EList<Switch> switches = calls.getSwitches();
		for (Switch generator : switches) {
			if (generator.getName() != null) {
				itemlist.add(generator.getName());
			}
		}
		
		EList<ExternalCallable> externalCallables = calls.getExternCallables();
		for (ExternalCallable generator : externalCallables) {
			if (generator.getName() != null) {
				itemlist.add(generator.getName());
			}
		}

		
		String[] items = itemlist.toArray(new String[] {});
		callableCombobox.setItems(items);

	}

	public String getName() {
		return "start callchain";
	}

	public void initializeFrom(ILaunchConfiguration configuration) {
		try {
			if (tabGroup.getCalls() == null || tabGroup.getResourceUri_asString() == null)
				return;

			selectedCallable = configuration.getAttribute(CallchainConfiguration.CALLABLENAME, "");

			if (configuration.getAttributes().containsKey(CallchainConfiguration.CHAINCALLS)) {
				try {
					checkBox_chaincall.setSelection(configuration
							.getAttribute(CallchainConfiguration.CHAINCALLS, false));
					viewer.getTable().setEnabled(checkBox_chaincall.getSelection());

				} catch (Exception e) {
				}
			}
			if (configuration.getAttributes().containsKey(CallchainConfiguration.CLEARCONSOLE)) {
				try {
					checkBox_clearConsole.setSelection(configuration.getAttribute(CallchainConfiguration.CLEARCONSOLE,
							true));

				} catch (Exception e) {
				}
			}
			if (configuration.getAttributes().containsKey(CallchainConfiguration.CALLABLENAME)) {
				selectedCallable = (String) configuration.getAttributes().get(CallchainConfiguration.CALLABLENAME);
				callableCombobox.setText(selectedCallable);
			}

			if (configuration.getAttributes().containsKey(CallchainConfiguration.SKIPPLIST)) {
				List<?> list = configuration.getAttribute(CallchainConfiguration.SKIPPLIST, new ArrayList<String>());
				if (skipList_list != null)
					for (Callable c : skipList_list) {
						if (list.contains(callableToName(c))) {
							viewer.setChecked(c, true);
							callablesToSkipp.add(callableToName(c));
						}
					}

			}

		} catch (CoreException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public void performApply(ILaunchConfigurationWorkingCopy configuration) {
		configuration.setAttribute(CallchainConfiguration.CALLCHAINURI, tabGroup.getResourceUri_asString());

		configuration.setAttribute(CallchainConfiguration.CALLABLENAME, selectedCallable);

		configuration.setAttribute(CallchainConfiguration.CHAINCALLS, checkBox_chaincall.getSelection());
		configuration.setAttribute(CallchainConfiguration.CLEARCONSOLE, checkBox_clearConsole.getSelection());

		configuration.setAttribute(CallchainConfiguration.SKIPPLIST, callablesToSkipp);

	}

	public void setDefaults(ILaunchConfigurationWorkingCopy configuration) {

	}

	@Override
	public boolean isValid(ILaunchConfiguration launchConfig) {

		if (tabGroup != null)
			if (tabGroup.getCalls() == null) {
				setErrorMessage("No valid callchain model selected.");
				return false;
			}

		String sc = callableCombobox.getText();
		if (sc == null || sc.equals("")) {
			setErrorMessage("no call selected");
			return false;
		}
		if (tabGroup != null)
			if (tabGroup.getCalls() != null)
				if (CallchainLaunchConfigurationDelegate.findCallable(sc, tabGroup.getCalls()) == null) {
					setErrorMessage("no call selected");
					return false;

				}

		setErrorMessage(null);
		return super.isValid(launchConfig);
	}

	/**
	 * Displays a workspace dialog.
	 * 
	 * @param text
	 */
	private void showWorkspaceDialog(Text text) {
		ElementTreeSelectionDialog dialog = new ElementTreeSelectionDialog(getShell(), new WorkbenchLabelProvider(),
				new BaseWorkbenchContentProvider());
		dialog.setTitle("Select file.");
		dialog.setMessage("Select a callchain model.");
		dialog.addFilter(new ViewerFilter() {
			public boolean select(Viewer viewer, Object parentElement, Object element) {
				boolean ret = false;

				if (element instanceof IContainer) {
					ret = true;
				} else if (element instanceof IFile) {
					IFile currentFile = (IFile) element;
					if (currentFile.getFileExtension() == null)
						return false;
					ret = (currentFile.getFileExtension().toUpperCase()).equals("CALLCHAIN");
				}
				return ret;
			}
		});

		dialog.setInput(ResourcesPlugin.getWorkspace().getRoot());

		if (dialog.open() == IDialogConstants.OK_ID) {
			IResource resource = (IResource) dialog.getFirstResult();
			String arg = resource.getFullPath().toOSString().toString();
			if (text != null)
				text.setText(arg);
		}
	}

	private void showFileDialog(Text txt) {
		String filePath = txt.getText();
		FileDialog dialog = new FileDialog(getShell(), SWT.SAVE);
		dialog.setText("Select a callchain model.");
		filePath = dialog.open();
		if (filePath != null) {
			txt.setText(filePath);
		}
	}
}
