/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.parts;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.eef.runtime.ui.widgets.referencestable.ReferencesTableSettings;
import org.eclipse.jface.viewers.ViewerFilter;



/**
 * @author Urs Zeidler
 * @generated
 */
public interface AndPredicatePropertiesEditionPart {



	/**
	 * Init the predicates
	 * @param current the current value
	 * @param containgFeature the feature where to navigate if necessary
	 * @param feature the feature to manage
	 */
	public void initPredicates(ReferencesTableSettings settings);

	/**
	 * Update the predicates
	 * @param newValue the predicates to update
	 * @generated
	 */
	public void updatePredicates();

	/**
	 * Adds the given filter to the predicates edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addFilterToPredicates(ViewerFilter filter);

	/**
	 * Adds the given filter to the predicates edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addBusinessFilterToPredicates(ViewerFilter filter);

	/**
	 * @return true if the given element is contained inside the predicates table
	 * @generated
	 */
	public boolean isContainedInPredicatesTable(EObject element);





	/**
	 * Returns the internationalized title text.
	 * 
	 * @return the internationalized title text.
	 * @generated
	 */
	public String getTitle();


}
