/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.parts;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;
import org.eclipse.jface.viewers.ViewerFilter;



/**
 * @author Urs Zeidler
 * @generated
 */
public interface ExternalCallablePropertiesEditionPart {

	/**
	 * @return the name
	 * @generated
	 */
	public String getName();

	/**
	 * Defines a new name
	 * @param newValue the new name to set
	 * @generated
	 */
	public void setName(String newValue);


	/**
	 * @return the delegatedCallable
	 * @generated
	 */
	public EObject getDelegatedCallable();

	/**
	 * Init the delegatedCallable
	 * @param settings the combo setting
	 */
	public void initDelegatedCallable(EObjectFlatComboSettings settings);

	/**
	 * Defines a new delegatedCallable
	 * @param newValue the new delegatedCallable to set
	 * @generated
	 */
	public void setDelegatedCallable(EObject newValue);

	/**
	 * Defines the button mode
	 * @param newValue the new mode to set
	 * @generated
	 */
	public void setDelegatedCallableButtonMode(ButtonsModeEnum newValue);

	/**
	 * Adds the given filter to the delegatedCallable edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addFilterToDelegatedCallable(ViewerFilter filter);

	/**
	 * Adds the given filter to the delegatedCallable edition editor.
	 * 
	 * @param filter
	 *            a viewer filter
	 * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
	 * @generated
	 */
	public void addBusinessFilterToDelegatedCallable(ViewerFilter filter);





	/**
   * @return the predicate
   * @generated
   */
  public EObject getPredicate();

  /**
   * Init the predicate
   * @param settings the combo setting
   */
  public void initPredicate(EObjectFlatComboSettings settings);

  /**
   * Defines a new predicate
   * @param newValue the new predicate to set
   * @generated
   */
  public void setPredicate(EObject newValue);

  /**
   * Defines the button mode
   * @param newValue the new mode to set
   * @generated
   */
  public void setPredicateButtonMode(ButtonsModeEnum newValue);

  /**
   * Adds the given filter to the predicate edition editor.
   * 
   * @param filter
   *            a viewer filter
   * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
   * @generated
   */
  public void addFilterToPredicate(ViewerFilter filter);

  /**
   * Adds the given filter to the predicate edition editor.
   * 
   * @param filter
   *            a viewer filter
   * @see org.eclipse.jface.viewers.StructuredViewer#addFilter(ViewerFilter)
   * @generated
   */
  public void addBusinessFilterToPredicate(ViewerFilter filter);

  /**
   * @return the refreshWorkspace
   * @generated
   */
  public Boolean getRefreshWorkspace();

  /**
   * Defines a new refreshWorkspace
   * @param newValue the new refreshWorkspace to set
   * @generated
   */
  public void setRefreshWorkspace(Boolean newValue);

  /**
	 * Returns the internationalized title text.
	 * 
	 * @return the internationalized title text.
	 * @generated
	 */
	public String getTitle();


}
