/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.parts.forms;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.parts.CompositePropertiesEditionPart;
import org.eclipse.emf.eef.runtime.ui.parts.PartComposer;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.BindingCompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionStep;
import org.eclipse.emf.eef.runtime.ui.utils.EditingUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.AdvancedEObjectFlatComboViewer;
import org.eclipse.emf.eef.runtime.ui.widgets.AdvancedEObjectFlatComboViewer.EObjectFlatComboViewerListener;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.FormUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.ViewerFilter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.forms.widgets.Form;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.ScrolledForm;
import org.eclipse.ui.forms.widgets.Section;

import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.Generic_GeneratorPropertiesEditionPart;
import de.urszeidler.eclipse.callchain.providers.CallchainMessages;


/**
 * @author Urs Zeidler
 * @generated
 */
public class Generic_GeneratorPropertiesEditionPartForm extends CompositePropertiesEditionPart implements IFormPropertiesEditionPart, Generic_GeneratorPropertiesEditionPart {

	protected Text name;
	protected Text generatorType;
	protected AdvancedEObjectFlatComboViewer predicate;
  protected ViewerFilter predicateFilter;
  protected Button refreshWorkspace;
  protected Text id;



	/**
	 * Default constructor
	 * @param editionComponent the {@link IPropertiesEditionComponent} that manage this part
	 * @generated
	 */
	public Generic_GeneratorPropertiesEditionPartForm(IPropertiesEditionComponent editionComponent) {
    super(editionComponent);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart#
	 *  createFigure(org.eclipse.swt.widgets.Composite, org.eclipse.ui.forms.widgets.FormToolkit)
	 * @generated
	 */
	public Composite createFigure(final Composite parent, final FormToolkit widgetFactory) {
    ScrolledForm scrolledForm = widgetFactory.createScrolledForm(parent);
    Form form = scrolledForm.getForm();
    view = form.getBody();
    GridLayout layout = new GridLayout();
    layout.numColumns = 3;
    view.setLayout(layout);
    createControls(widgetFactory, view);
    return scrolledForm;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart#
	 *  createControls(org.eclipse.ui.forms.widgets.FormToolkit, org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public void createControls(final FormToolkit widgetFactory, Composite view) {
    CompositionSequence generic_GeneratorStep = new BindingCompositionSequence(propertiesEditionComponent);
    CompositionStep propertiesStep = generic_GeneratorStep.addStep(CallchainViewsRepository.Generic_Generator.Properties.class);
    propertiesStep.addStep(CallchainViewsRepository.Generic_Generator.Properties.name);
    propertiesStep.addStep(CallchainViewsRepository.Generic_Generator.Properties.generatorType);
    propertiesStep.addStep(CallchainViewsRepository.Generic_Generator.Properties.predicate);
    propertiesStep.addStep(CallchainViewsRepository.Generic_Generator.Properties.refreshWorkspace);
    propertiesStep.addStep(CallchainViewsRepository.Generic_Generator.Properties.id);
    
    
    composer = new PartComposer(generic_GeneratorStep) {

      @Override
      public Composite addToPart(Composite parent, Object key) {
        if (key == CallchainViewsRepository.Generic_Generator.Properties.class) {
          return createPropertiesGroup(widgetFactory, parent);
        }
        if (key == CallchainViewsRepository.Generic_Generator.Properties.name) {
          return 		createNameText(widgetFactory, parent);
        }
        if (key == CallchainViewsRepository.Generic_Generator.Properties.generatorType) {
          return 		createGeneratorTypeText(widgetFactory, parent);
        }
        if (key == CallchainViewsRepository.Generic_Generator.Properties.predicate) {
          return createPredicateFlatComboViewer(parent, widgetFactory);
        }
        if (key == CallchainViewsRepository.Generic_Generator.Properties.refreshWorkspace) {
          return createRefreshWorkspaceCheckbox(widgetFactory, parent);
        }
        if (key == CallchainViewsRepository.Generic_Generator.Properties.id) {
          return 		createIdText(widgetFactory, parent);
        }
        return parent;
      }
    };
    composer.compose(view);
  }
	/**
	 * @generated
	 */
	protected Composite createPropertiesGroup(FormToolkit widgetFactory, final Composite parent) {
    Section propertiesSection = widgetFactory.createSection(parent, Section.TITLE_BAR | Section.TWISTIE | Section.EXPANDED);
    propertiesSection.setText(CallchainMessages.Generic_GeneratorPropertiesEditionPart_PropertiesGroupLabel);
    GridData propertiesSectionData = new GridData(GridData.FILL_HORIZONTAL);
    propertiesSectionData.horizontalSpan = 3;
    propertiesSection.setLayoutData(propertiesSectionData);
    Composite propertiesGroup = widgetFactory.createComposite(propertiesSection);
    GridLayout propertiesGroupLayout = new GridLayout();
    propertiesGroupLayout.numColumns = 3;
    propertiesGroup.setLayout(propertiesGroupLayout);
    propertiesSection.setClient(propertiesGroup);
    return propertiesGroup;
  }

	/**
	 * @generated
	 */
	
	protected Composite createNameText(FormToolkit widgetFactory, Composite parent) {
    FormUtils.createPartLabel(widgetFactory, parent, CallchainMessages.Generic_GeneratorPropertiesEditionPart_NameLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.Generic_Generator.Properties.name, CallchainViewsRepository.FORM_KIND));
    name = widgetFactory.createText(parent, ""); //$NON-NLS-1$
    name.setData(FormToolkit.KEY_DRAW_BORDER, FormToolkit.TEXT_BORDER);
    widgetFactory.paintBordersFor(parent);
    GridData nameData = new GridData(GridData.FILL_HORIZONTAL);
    name.setLayoutData(nameData);
    name.addFocusListener(new FocusAdapter() {
      /**
       * @see org.eclipse.swt.events.FocusAdapter#focusLost(org.eclipse.swt.events.FocusEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void focusLost(FocusEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(Generic_GeneratorPropertiesEditionPartForm.this, CallchainViewsRepository.Generic_Generator.Properties.name, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, name.getText()));
      }
    });
    name.addKeyListener(new KeyAdapter() {
      /**
       * @see org.eclipse.swt.events.KeyAdapter#keyPressed(org.eclipse.swt.events.KeyEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void keyPressed(KeyEvent e) {
        if (e.character == SWT.CR) {
          if (propertiesEditionComponent != null)
            propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(Generic_GeneratorPropertiesEditionPartForm.this, CallchainViewsRepository.Generic_Generator.Properties.name, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, name.getText()));
        }
      }
    });
    EditingUtils.setID(name, CallchainViewsRepository.Generic_Generator.Properties.name);
    EditingUtils.setEEFtype(name, "eef::Text"); //$NON-NLS-1$
    FormUtils.createHelpButton(widgetFactory, parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Generic_Generator.Properties.name, CallchainViewsRepository.FORM_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @generated
	 */
	
	protected Composite createGeneratorTypeText(FormToolkit widgetFactory, Composite parent) {
    FormUtils.createPartLabel(widgetFactory, parent, CallchainMessages.Generic_GeneratorPropertiesEditionPart_GeneratorTypeLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.Generic_Generator.Properties.generatorType, CallchainViewsRepository.FORM_KIND));
    generatorType = widgetFactory.createText(parent, ""); //$NON-NLS-1$
    generatorType.setData(FormToolkit.KEY_DRAW_BORDER, FormToolkit.TEXT_BORDER);
    widgetFactory.paintBordersFor(parent);
    GridData generatorTypeData = new GridData(GridData.FILL_HORIZONTAL);
    generatorType.setLayoutData(generatorTypeData);
    generatorType.addFocusListener(new FocusAdapter() {
      /**
       * @see org.eclipse.swt.events.FocusAdapter#focusLost(org.eclipse.swt.events.FocusEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void focusLost(FocusEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(Generic_GeneratorPropertiesEditionPartForm.this, CallchainViewsRepository.Generic_Generator.Properties.generatorType, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, generatorType.getText()));
      }
    });
    generatorType.addKeyListener(new KeyAdapter() {
      /**
       * @see org.eclipse.swt.events.KeyAdapter#keyPressed(org.eclipse.swt.events.KeyEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void keyPressed(KeyEvent e) {
        if (e.character == SWT.CR) {
          if (propertiesEditionComponent != null)
            propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(Generic_GeneratorPropertiesEditionPartForm.this, CallchainViewsRepository.Generic_Generator.Properties.generatorType, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, generatorType.getText()));
        }
      }
    });
    EditingUtils.setID(generatorType, CallchainViewsRepository.Generic_Generator.Properties.generatorType);
    EditingUtils.setEEFtype(generatorType, "eef::Text"); //$NON-NLS-1$
    FormUtils.createHelpButton(widgetFactory, parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Generic_Generator.Properties.generatorType, CallchainViewsRepository.FORM_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
   * @param parent the parent composite
   * @param widgetFactory factory to use to instanciante widget of the form
   * @generated
   */
  protected Composite createPredicateFlatComboViewer(Composite parent, FormToolkit widgetFactory) {
    FormUtils.createPartLabel(widgetFactory, parent, CallchainMessages.Generic_GeneratorPropertiesEditionPart_PredicateLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.Generic_Generator.Properties.predicate, CallchainViewsRepository.FORM_KIND));
    // create callback listener
    EObjectFlatComboViewerListener listener = new EObjectFlatComboViewerListener(){
      public void handleSet(EObject element){
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(Generic_GeneratorPropertiesEditionPartForm.this, CallchainViewsRepository.Generic_Generator.Properties.predicate, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, element)); 
      }
      public void navigateTo(EObject element){ }

      public EObject handleCreate() {
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(Generic_GeneratorPropertiesEditionPartForm.this, CallchainViewsRepository.Generic_Generator.Properties.predicate, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.ADD, null, null)); 
        return null;
      }

    };
    //create widget
    predicate = new AdvancedEObjectFlatComboViewer(CallchainMessages.Generic_GeneratorPropertiesEditionPart_PredicateLabel, resourceSet, predicateFilter, propertiesEditionComponent.getEditingContext().getAdapterFactory(), listener);
    predicate.createControls(parent, widgetFactory);
    GridData predicateData = new GridData(GridData.FILL_HORIZONTAL);
    predicate.setLayoutData(predicateData);
    predicate.setID(CallchainViewsRepository.Generic_Generator.Properties.predicate);
    FormUtils.createHelpButton(widgetFactory, parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Generic_Generator.Properties.predicate, CallchainViewsRepository.FORM_KIND), null); //$NON-NLS-1$
    return parent;
  }

  /**
   * @generated
   */
  
  protected Composite createRefreshWorkspaceCheckbox(FormToolkit widgetFactory, Composite parent) {
    refreshWorkspace = widgetFactory.createButton(parent, CallchainMessages.Generic_GeneratorPropertiesEditionPart_RefreshWorkspaceLabel, SWT.CHECK);
    refreshWorkspace.addSelectionListener(new SelectionAdapter() {

      /**
       * {@inheritDoc}
       *
       * @see org.eclipse.swt.events.SelectionAdapter#widgetSelected(org.eclipse.swt.events.SelectionEvent)
       * 	@generated
       */
      public void widgetSelected(SelectionEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(Generic_GeneratorPropertiesEditionPartForm.this, CallchainViewsRepository.Generic_Generator.Properties.refreshWorkspace, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, new Boolean(refreshWorkspace.getSelection())));
      }

    });
    GridData refreshWorkspaceData = new GridData(GridData.FILL_HORIZONTAL);
    refreshWorkspaceData.horizontalSpan = 2;
    refreshWorkspace.setLayoutData(refreshWorkspaceData);
    EditingUtils.setID(refreshWorkspace, CallchainViewsRepository.Generic_Generator.Properties.refreshWorkspace);
    EditingUtils.setEEFtype(refreshWorkspace, "eef::Checkbox"); //$NON-NLS-1$
    FormUtils.createHelpButton(widgetFactory, parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Generic_Generator.Properties.refreshWorkspace, CallchainViewsRepository.FORM_KIND), null); //$NON-NLS-1$
    return parent;
  }

  /**
	 * @generated
	 */
	
	protected Composite createIdText(FormToolkit widgetFactory, Composite parent) {
    FormUtils.createPartLabel(widgetFactory, parent, CallchainMessages.Generic_GeneratorPropertiesEditionPart_IdLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.Generic_Generator.Properties.id, CallchainViewsRepository.FORM_KIND));
    id = widgetFactory.createText(parent, ""); //$NON-NLS-1$
    id.setData(FormToolkit.KEY_DRAW_BORDER, FormToolkit.TEXT_BORDER);
    widgetFactory.paintBordersFor(parent);
    GridData idData = new GridData(GridData.FILL_HORIZONTAL);
    id.setLayoutData(idData);
    id.addFocusListener(new FocusAdapter() {
      /**
       * @see org.eclipse.swt.events.FocusAdapter#focusLost(org.eclipse.swt.events.FocusEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void focusLost(FocusEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(Generic_GeneratorPropertiesEditionPartForm.this, CallchainViewsRepository.Generic_Generator.Properties.id, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, id.getText()));
      }
    });
    id.addKeyListener(new KeyAdapter() {
      /**
       * @see org.eclipse.swt.events.KeyAdapter#keyPressed(org.eclipse.swt.events.KeyEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void keyPressed(KeyEvent e) {
        if (e.character == SWT.CR) {
          if (propertiesEditionComponent != null)
            propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(Generic_GeneratorPropertiesEditionPartForm.this, CallchainViewsRepository.Generic_Generator.Properties.id, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, id.getText()));
        }
      }
    });
    EditingUtils.setID(id, CallchainViewsRepository.Generic_Generator.Properties.id);
    EditingUtils.setEEFtype(id, "eef::Text"); //$NON-NLS-1$
    FormUtils.createHelpButton(widgetFactory, parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.Generic_Generator.Properties.id, CallchainViewsRepository.FORM_KIND), null); //$NON-NLS-1$
    return parent;
  }



	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionListener#firePropertiesChanged(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void firePropertiesChanged(IPropertiesEditionEvent event) {
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.Generic_GeneratorPropertiesEditionPart#getName()
	 * @generated
	 */
	public String getName() {
    return name.getText();
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.Generic_GeneratorPropertiesEditionPart#setName(String newValue)
	 * @generated
	 */
	public void setName(String newValue) {
    if (newValue != null) {
      name.setText(newValue);
    } else {
      name.setText(""); //$NON-NLS-1$
    }
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.Generic_GeneratorPropertiesEditionPart#getGeneratorType()
	 * @generated
	 */
	public String getGeneratorType() {
    return generatorType.getText();
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.Generic_GeneratorPropertiesEditionPart#setGeneratorType(String newValue)
	 * @generated
	 */
	public void setGeneratorType(String newValue) {
    if (newValue != null) {
      generatorType.setText(newValue);
    } else {
      generatorType.setText(""); //$NON-NLS-1$
    }
  }


	/**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.Generic_GeneratorPropertiesEditionPart#getPredicate()
   * @generated
   */
  public EObject getPredicate() {
    return predicate.getSelection();
  }

  /**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.Generic_GeneratorPropertiesEditionPart#initPredicate(EObjectFlatComboSettings)
   */
  public void initPredicate(EObjectFlatComboSettings settings) {
    predicate.setInput(settings);
    if (current != null) {
      predicate.setSelection(new StructuredSelection(settings.getValue()));
    }
  }

  /**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.Generic_GeneratorPropertiesEditionPart#setPredicate(EObject newValue)
   * @generated
   */
  public void setPredicate(EObject newValue) {
    if (newValue != null) {
      predicate.setSelection(new StructuredSelection(newValue));
    } else {
      predicate.setSelection(new StructuredSelection()); //$NON-NLS-1$
    }
  }

  /**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.Generic_GeneratorPropertiesEditionPart#setPredicateButtonMode(ButtonsModeEnum newValue)
   */
  public void setPredicateButtonMode(ButtonsModeEnum newValue) {
    predicate.setButtonMode(newValue);
  }

  /**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.Generic_GeneratorPropertiesEditionPart#addFilterPredicate(ViewerFilter filter)
   * @generated
   */
  public void addFilterToPredicate(ViewerFilter filter) {
    predicate.addFilter(filter);
  }

  /**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.Generic_GeneratorPropertiesEditionPart#addBusinessFilterPredicate(ViewerFilter filter)
   * @generated
   */
  public void addBusinessFilterToPredicate(ViewerFilter filter) {
    predicate.addBusinessRuleFilter(filter);
  }

  /**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.Generic_GeneratorPropertiesEditionPart#getRefreshWorkspace()
   * @generated
   */
  public Boolean getRefreshWorkspace() {
    return Boolean.valueOf(refreshWorkspace.getSelection());
  }

  /**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.Generic_GeneratorPropertiesEditionPart#setRefreshWorkspace(Boolean newValue)
   * @generated
   */
  public void setRefreshWorkspace(Boolean newValue) {
    if (newValue != null) {
      refreshWorkspace.setSelection(newValue.booleanValue());
    } else {
      refreshWorkspace.setSelection(false);
    }
  }

  /**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.Generic_GeneratorPropertiesEditionPart#getId()
	 * @generated
	 */
	public String getId() {
    return id.getText();
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.Generic_GeneratorPropertiesEditionPart#setId(String newValue)
	 * @generated
	 */
	public void setId(String newValue) {
    if (newValue != null) {
      id.setText(newValue);
    } else {
      id.setText(""); //$NON-NLS-1$
    }
  }




	/**
	 * {@inheritDoc}
	 *
	 * @see org.eclipse.emf.eef.runtime.api.parts.IPropertiesEditionPart#getTitle()
	 * @generated
	 */
	public String getTitle() {
    return CallchainMessages.Generic_Generator_Part_Title;
  }



}
