/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.parts.forms;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.parts.CompositePropertiesEditionPart;
import org.eclipse.emf.eef.runtime.ui.parts.PartComposer;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.BindingCompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionStep;
import org.eclipse.emf.eef.runtime.ui.utils.EditingUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.EObjectFlatComboViewer;
import org.eclipse.emf.eef.runtime.ui.widgets.FormUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.ViewerFilter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.forms.widgets.Form;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.ScrolledForm;
import org.eclipse.ui.forms.widgets.Section;

import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.PropertyValueSwitchPropertiesEditionPart;
import de.urszeidler.eclipse.callchain.providers.CallchainMessages;


/**
 * @author Urs Zeidler
 * @generated
 */
public class PropertyValueSwitchPropertiesEditionPartForm extends CompositePropertiesEditionPart implements IFormPropertiesEditionPart, PropertyValueSwitchPropertiesEditionPart {

	protected Text name;
	protected EObjectFlatComboViewer property;



	/**
	 * Default constructor
	 * @param editionComponent the {@link IPropertiesEditionComponent} that manage this part
	 * @generated
	 */
	public PropertyValueSwitchPropertiesEditionPartForm(IPropertiesEditionComponent editionComponent) {
    super(editionComponent);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart#
	 *  createFigure(org.eclipse.swt.widgets.Composite, org.eclipse.ui.forms.widgets.FormToolkit)
	 * @generated
	 */
	public Composite createFigure(final Composite parent, final FormToolkit widgetFactory) {
    ScrolledForm scrolledForm = widgetFactory.createScrolledForm(parent);
    Form form = scrolledForm.getForm();
    view = form.getBody();
    GridLayout layout = new GridLayout();
    layout.numColumns = 3;
    view.setLayout(layout);
    createControls(widgetFactory, view);
    return scrolledForm;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.IFormPropertiesEditionPart#
	 *  createControls(org.eclipse.ui.forms.widgets.FormToolkit, org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public void createControls(final FormToolkit widgetFactory, Composite view) {
    CompositionSequence propertyValueSwitchStep = new BindingCompositionSequence(propertiesEditionComponent);
    CompositionStep propertiesStep = propertyValueSwitchStep.addStep(CallchainViewsRepository.PropertyValueSwitch.Properties.class);
    propertiesStep.addStep(CallchainViewsRepository.PropertyValueSwitch.Properties.name);
    propertiesStep.addStep(CallchainViewsRepository.PropertyValueSwitch.Properties.property);
    
    
    composer = new PartComposer(propertyValueSwitchStep) {

      @Override
      public Composite addToPart(Composite parent, Object key) {
        if (key == CallchainViewsRepository.PropertyValueSwitch.Properties.class) {
          return createPropertiesGroup(widgetFactory, parent);
        }
        if (key == CallchainViewsRepository.PropertyValueSwitch.Properties.name) {
          return 		createNameText(widgetFactory, parent);
        }
        if (key == CallchainViewsRepository.PropertyValueSwitch.Properties.property) {
          return createPropertyFlatComboViewer(parent, widgetFactory);
        }
        return parent;
      }
    };
    composer.compose(view);
  }
	/**
	 * @generated
	 */
	protected Composite createPropertiesGroup(FormToolkit widgetFactory, final Composite parent) {
    Section propertiesSection = widgetFactory.createSection(parent, Section.TITLE_BAR | Section.TWISTIE | Section.EXPANDED);
    propertiesSection.setText(CallchainMessages.PropertyValueSwitchPropertiesEditionPart_PropertiesGroupLabel);
    GridData propertiesSectionData = new GridData(GridData.FILL_HORIZONTAL);
    propertiesSectionData.horizontalSpan = 3;
    propertiesSection.setLayoutData(propertiesSectionData);
    Composite propertiesGroup = widgetFactory.createComposite(propertiesSection);
    GridLayout propertiesGroupLayout = new GridLayout();
    propertiesGroupLayout.numColumns = 3;
    propertiesGroup.setLayout(propertiesGroupLayout);
    propertiesSection.setClient(propertiesGroup);
    return propertiesGroup;
  }

	/**
	 * @generated
	 */
	
	protected Composite createNameText(FormToolkit widgetFactory, Composite parent) {
    FormUtils.createPartLabel(widgetFactory, parent, CallchainMessages.PropertyValueSwitchPropertiesEditionPart_NameLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.PropertyValueSwitch.Properties.name, CallchainViewsRepository.FORM_KIND));
    name = widgetFactory.createText(parent, ""); //$NON-NLS-1$
    name.setData(FormToolkit.KEY_DRAW_BORDER, FormToolkit.TEXT_BORDER);
    widgetFactory.paintBordersFor(parent);
    GridData nameData = new GridData(GridData.FILL_HORIZONTAL);
    name.setLayoutData(nameData);
    name.addFocusListener(new FocusAdapter() {
      /**
       * @see org.eclipse.swt.events.FocusAdapter#focusLost(org.eclipse.swt.events.FocusEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void focusLost(FocusEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(PropertyValueSwitchPropertiesEditionPartForm.this, CallchainViewsRepository.PropertyValueSwitch.Properties.name, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, name.getText()));
      }
    });
    name.addKeyListener(new KeyAdapter() {
      /**
       * @see org.eclipse.swt.events.KeyAdapter#keyPressed(org.eclipse.swt.events.KeyEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void keyPressed(KeyEvent e) {
        if (e.character == SWT.CR) {
          if (propertiesEditionComponent != null)
            propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(PropertyValueSwitchPropertiesEditionPartForm.this, CallchainViewsRepository.PropertyValueSwitch.Properties.name, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, name.getText()));
        }
      }
    });
    EditingUtils.setID(name, CallchainViewsRepository.PropertyValueSwitch.Properties.name);
    EditingUtils.setEEFtype(name, "eef::Text"); //$NON-NLS-1$
    FormUtils.createHelpButton(widgetFactory, parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.PropertyValueSwitch.Properties.name, CallchainViewsRepository.FORM_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @param parent the parent composite
	 * @param widgetFactory factory to use to instanciante widget of the form
	 * @generated
	 */
	protected Composite createPropertyFlatComboViewer(Composite parent, FormToolkit widgetFactory) {
    FormUtils.createPartLabel(widgetFactory, parent, CallchainMessages.PropertyValueSwitchPropertiesEditionPart_PropertyLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.PropertyValueSwitch.Properties.property, CallchainViewsRepository.FORM_KIND));
    property = new EObjectFlatComboViewer(parent, !propertiesEditionComponent.isRequired(CallchainViewsRepository.PropertyValueSwitch.Properties.property, CallchainViewsRepository.FORM_KIND));
    widgetFactory.adapt(property);
    property.setLabelProvider(new AdapterFactoryLabelProvider(adapterFactory));
    GridData propertyData = new GridData(GridData.FILL_HORIZONTAL);
    property.setLayoutData(propertyData);
    property.addSelectionChangedListener(new ISelectionChangedListener() {

      /**
       * {@inheritDoc}
       * 
       * @see org.eclipse.jface.viewers.ISelectionChangedListener#selectionChanged(org.eclipse.jface.viewers.SelectionChangedEvent)
       */
      public void selectionChanged(SelectionChangedEvent event) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(PropertyValueSwitchPropertiesEditionPartForm.this, CallchainViewsRepository.PropertyValueSwitch.Properties.property, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, getProperty()));
      }

    });
    property.setID(CallchainViewsRepository.PropertyValueSwitch.Properties.property);
    FormUtils.createHelpButton(widgetFactory, parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.PropertyValueSwitch.Properties.property, CallchainViewsRepository.FORM_KIND), null); //$NON-NLS-1$
    return parent;
  }



	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionListener#firePropertiesChanged(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void firePropertiesChanged(IPropertiesEditionEvent event) {
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyValueSwitchPropertiesEditionPart#getName()
	 * @generated
	 */
	public String getName() {
    return name.getText();
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyValueSwitchPropertiesEditionPart#setName(String newValue)
	 * @generated
	 */
	public void setName(String newValue) {
    if (newValue != null) {
      name.setText(newValue);
    } else {
      name.setText(""); //$NON-NLS-1$
    }
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyValueSwitchPropertiesEditionPart#getProperty()
	 * @generated
	 */
	public EObject getProperty() {
    if (property.getSelection() instanceof StructuredSelection) {
      Object firstElement = ((StructuredSelection) property.getSelection()).getFirstElement();
      if (firstElement instanceof EObject)
        return (EObject) firstElement;
    }
    return null;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyValueSwitchPropertiesEditionPart#initProperty(EObjectFlatComboSettings)
	 */
	public void initProperty(EObjectFlatComboSettings settings) {
		property.setInput(settings);
		if (current != null) {
			property.setSelection(new StructuredSelection(settings.getValue()));
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyValueSwitchPropertiesEditionPart#setProperty(EObject newValue)
	 * @generated
	 */
	public void setProperty(EObject newValue) {
    if (newValue != null) {
      property.setSelection(new StructuredSelection(newValue));
    } else {
      property.setSelection(new StructuredSelection()); //$NON-NLS-1$
    }
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyValueSwitchPropertiesEditionPart#setPropertyButtonMode(ButtonsModeEnum newValue)
	 */
	public void setPropertyButtonMode(ButtonsModeEnum newValue) {
		property.setButtonMode(newValue);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyValueSwitchPropertiesEditionPart#addFilterProperty(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToProperty(ViewerFilter filter) {
    property.addFilter(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.PropertyValueSwitchPropertiesEditionPart#addBusinessFilterProperty(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToProperty(ViewerFilter filter) {
    property.addBusinessRuleFilter(filter);
  }




	/**
	 * {@inheritDoc}
	 *
	 * @see org.eclipse.emf.eef.runtime.api.parts.IPropertiesEditionPart#getTitle()
	 * @generated
	 */
	public String getTitle() {
    return CallchainMessages.PropertyValueSwitch_Part_Title;
  }



}
