/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.parts.impl;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.parts.CompositePropertiesEditionPart;
import org.eclipse.emf.eef.runtime.ui.parts.PartComposer;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.BindingCompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionStep;
import org.eclipse.emf.eef.runtime.ui.utils.EditingUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.AdvancedEObjectFlatComboViewer;
import org.eclipse.emf.eef.runtime.ui.widgets.AdvancedEObjectFlatComboViewer.EObjectFlatComboViewerListener;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.EObjectFlatComboViewer;
import org.eclipse.emf.eef.runtime.ui.widgets.SWTUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.ViewerFilter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Text;

import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.ExternalCallablePropertiesEditionPart;
import de.urszeidler.eclipse.callchain.providers.CallchainMessages;


/**
 * @author Urs Zeidler
 * @generated
 */
public class ExternalCallablePropertiesEditionPartImpl extends CompositePropertiesEditionPart implements ISWTPropertiesEditionPart, ExternalCallablePropertiesEditionPart {

	protected Text name;
	protected EObjectFlatComboViewer delegatedCallable;



	private AdvancedEObjectFlatComboViewer predicate;
  protected ViewerFilter predicateFilter;
  protected Button refreshWorkspace;



  /**
	 * Default constructor
	 * @param editionComponent the {@link IPropertiesEditionComponent} that manage this part
	 * @generated
	 */
	public ExternalCallablePropertiesEditionPartImpl(IPropertiesEditionComponent editionComponent) {
    super(editionComponent);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart#
	 * 			createFigure(org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public Composite createFigure(final Composite parent) {
    view = new Composite(parent, SWT.NONE);
    GridLayout layout = new GridLayout();
    layout.numColumns = 3;
    view.setLayout(layout);
    createControls(view);
    return view;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart#
	 * 			createControls(org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public void createControls(Composite view) { 
    CompositionSequence externalCallableStep = new BindingCompositionSequence(propertiesEditionComponent);
    CompositionStep propertiesStep = externalCallableStep.addStep(CallchainViewsRepository.ExternalCallable.Properties.class);
    propertiesStep.addStep(CallchainViewsRepository.ExternalCallable.Properties.name);
    propertiesStep.addStep(CallchainViewsRepository.ExternalCallable.Properties.delegatedCallable);
    propertiesStep.addStep(CallchainViewsRepository.ExternalCallable.Properties.predicate);
    propertiesStep.addStep(CallchainViewsRepository.ExternalCallable.Properties.refreshWorkspace);
    
    
    composer = new PartComposer(externalCallableStep) {

      @Override
      public Composite addToPart(Composite parent, Object key) {
        if (key == CallchainViewsRepository.ExternalCallable.Properties.class) {
          return createPropertiesGroup(parent);
        }
        if (key == CallchainViewsRepository.ExternalCallable.Properties.name) {
          return createNameText(parent);
        }
        if (key == CallchainViewsRepository.ExternalCallable.Properties.delegatedCallable) {
          return createDelegatedCallableFlatComboViewer(parent);
        }
        if (key == CallchainViewsRepository.ExternalCallable.Properties.predicate) {
          return createPredicateAdvancedFlatComboViewer(parent);
        }
        if (key == CallchainViewsRepository.ExternalCallable.Properties.refreshWorkspace) {
          return createRefreshWorkspaceCheckbox(parent);
        }
        return parent;
      }
    };
    composer.compose(view);
  }

	/**
	 * @generated
	 */
	protected Composite createPropertiesGroup(Composite parent) {
    Group propertiesGroup = new Group(parent, SWT.NONE);
    propertiesGroup.setText(CallchainMessages.ExternalCallablePropertiesEditionPart_PropertiesGroupLabel);
    GridData propertiesGroupData = new GridData(GridData.FILL_HORIZONTAL);
    propertiesGroupData.horizontalSpan = 3;
    propertiesGroup.setLayoutData(propertiesGroupData);
    GridLayout propertiesGroupLayout = new GridLayout();
    propertiesGroupLayout.numColumns = 3;
    propertiesGroup.setLayout(propertiesGroupLayout);
    return propertiesGroup;
  }

	/**
	 * @generated
	 */
	
	protected Composite createNameText(Composite parent) {
    SWTUtils.createPartLabel(parent, CallchainMessages.ExternalCallablePropertiesEditionPart_NameLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.ExternalCallable.Properties.name, CallchainViewsRepository.SWT_KIND));
    name = new Text(parent, SWT.BORDER);
    GridData nameData = new GridData(GridData.FILL_HORIZONTAL);
    name.setLayoutData(nameData);
    name.addFocusListener(new FocusAdapter() {

      /**
       * {@inheritDoc}
       * 
       * @see org.eclipse.swt.events.FocusAdapter#focusLost(org.eclipse.swt.events.FocusEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void focusLost(FocusEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(ExternalCallablePropertiesEditionPartImpl.this, CallchainViewsRepository.ExternalCallable.Properties.name, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, name.getText()));
      }

    });
    name.addKeyListener(new KeyAdapter() {

      /**
       * {@inheritDoc}
       * 
       * @see org.eclipse.swt.events.KeyAdapter#keyPressed(org.eclipse.swt.events.KeyEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void keyPressed(KeyEvent e) {
        if (e.character == SWT.CR) {
          if (propertiesEditionComponent != null)
            propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(ExternalCallablePropertiesEditionPartImpl.this, CallchainViewsRepository.ExternalCallable.Properties.name, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, name.getText()));
        }
      }

    });
    EditingUtils.setID(name, CallchainViewsRepository.ExternalCallable.Properties.name);
    EditingUtils.setEEFtype(name, "eef::Text"); //$NON-NLS-1$
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.ExternalCallable.Properties.name, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @param parent the parent composite
	 * @generated
	 */
	protected Composite createDelegatedCallableFlatComboViewer(Composite parent) {
    SWTUtils.createPartLabel(parent, CallchainMessages.ExternalCallablePropertiesEditionPart_DelegatedCallableLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.ExternalCallable.Properties.delegatedCallable, CallchainViewsRepository.SWT_KIND));
    delegatedCallable = new EObjectFlatComboViewer(parent, !propertiesEditionComponent.isRequired(CallchainViewsRepository.ExternalCallable.Properties.delegatedCallable, CallchainViewsRepository.SWT_KIND));
    delegatedCallable.setLabelProvider(new AdapterFactoryLabelProvider(adapterFactory));

    delegatedCallable.addSelectionChangedListener(new ISelectionChangedListener() {

      public void selectionChanged(SelectionChangedEvent event) {
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(ExternalCallablePropertiesEditionPartImpl.this, CallchainViewsRepository.ExternalCallable.Properties.delegatedCallable, PropertiesEditionEvent.CHANGE, PropertiesEditionEvent.SET, null, getDelegatedCallable()));
      }

    });
    GridData delegatedCallableData = new GridData(GridData.FILL_HORIZONTAL);
    delegatedCallable.setLayoutData(delegatedCallableData);
    delegatedCallable.setID(CallchainViewsRepository.ExternalCallable.Properties.delegatedCallable);
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.ExternalCallable.Properties.delegatedCallable, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }



	/**
   * @param parent the parent composite
   * @generated
   */
  protected Composite createPredicateAdvancedFlatComboViewer(Composite parent) {
    SWTUtils.createPartLabel(parent, CallchainMessages.ExternalCallablePropertiesEditionPart_PredicateLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.ExternalCallable.Properties.predicate, CallchainViewsRepository.SWT_KIND));
    // create callback listener
    EObjectFlatComboViewerListener listener = new EObjectFlatComboViewerListener(){
      public void handleSet(EObject element){
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(ExternalCallablePropertiesEditionPartImpl.this, CallchainViewsRepository.ExternalCallable.Properties.predicate, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, element)); 
      }
      public void navigateTo(EObject element){ }

      public EObject handleCreate() {
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(ExternalCallablePropertiesEditionPartImpl.this, CallchainViewsRepository.ExternalCallable.Properties.predicate, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.ADD, null, null)); 
        return null;
      }
    };
    //create widget
    predicate = new AdvancedEObjectFlatComboViewer(CallchainMessages.ExternalCallablePropertiesEditionPart_PredicateLabel, resourceSet, predicateFilter, propertiesEditionComponent.getEditingContext().getAdapterFactory(), listener);
    predicate.createControls(parent);
    GridData predicateData = new GridData(GridData.FILL_HORIZONTAL);
    predicate.setLayoutData(predicateData);
    predicate.setID(CallchainViewsRepository.ExternalCallable.Properties.predicate);
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.ExternalCallable.Properties.predicate, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }

  /**
   * @generated
   */
  
  protected Composite createRefreshWorkspaceCheckbox(Composite parent) {
    refreshWorkspace = new Button(parent, SWT.CHECK);
    refreshWorkspace.setText(CallchainMessages.ExternalCallablePropertiesEditionPart_RefreshWorkspaceLabel);
    refreshWorkspace.addSelectionListener(new SelectionAdapter() {

      /**
       * {@inheritDoc}
       *
       * @see org.eclipse.swt.events.SelectionAdapter#widgetSelected(org.eclipse.swt.events.SelectionEvent)
       * 	@generated
       */
      public void widgetSelected(SelectionEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(ExternalCallablePropertiesEditionPartImpl.this, CallchainViewsRepository.ExternalCallable.Properties.refreshWorkspace, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, new Boolean(refreshWorkspace.getSelection())));
      }

    });
    GridData refreshWorkspaceData = new GridData(GridData.FILL_HORIZONTAL);
    refreshWorkspaceData.horizontalSpan = 2;
    refreshWorkspace.setLayoutData(refreshWorkspaceData);
    EditingUtils.setID(refreshWorkspace, CallchainViewsRepository.ExternalCallable.Properties.refreshWorkspace);
    EditingUtils.setEEFtype(refreshWorkspace, "eef::Checkbox"); //$NON-NLS-1$
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.ExternalCallable.Properties.refreshWorkspace, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }

  /**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionListener#firePropertiesChanged(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void firePropertiesChanged(IPropertiesEditionEvent event) {
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ExternalCallablePropertiesEditionPart#getName()
	 * @generated
	 */
	public String getName() {
    return name.getText();
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ExternalCallablePropertiesEditionPart#setName(String newValue)
	 * @generated
	 */
	public void setName(String newValue) {
    if (newValue != null) {
      name.setText(newValue);
    } else {
      name.setText(""); //$NON-NLS-1$
    }
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ExternalCallablePropertiesEditionPart#getDelegatedCallable()
	 * @generated
	 */
	public EObject getDelegatedCallable() {
    if (delegatedCallable.getSelection() instanceof StructuredSelection) {
      Object firstElement = ((StructuredSelection) delegatedCallable.getSelection()).getFirstElement();
      if (firstElement instanceof EObject)
        return (EObject) firstElement;
    }
    return null;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ExternalCallablePropertiesEditionPart#initDelegatedCallable(EObjectFlatComboSettings)
	 */
	public void initDelegatedCallable(EObjectFlatComboSettings settings) {
		delegatedCallable.setInput(settings);
		if (current != null) {
			delegatedCallable.setSelection(new StructuredSelection(settings.getValue()));
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ExternalCallablePropertiesEditionPart#setDelegatedCallable(EObject newValue)
	 * @generated
	 */
	public void setDelegatedCallable(EObject newValue) {
    if (newValue != null) {
      delegatedCallable.setSelection(new StructuredSelection(newValue));
    } else {
      delegatedCallable.setSelection(new StructuredSelection()); //$NON-NLS-1$
    }
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ExternalCallablePropertiesEditionPart#setDelegatedCallableButtonMode(ButtonsModeEnum newValue)
	 */
	public void setDelegatedCallableButtonMode(ButtonsModeEnum newValue) {
		delegatedCallable.setButtonMode(newValue);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ExternalCallablePropertiesEditionPart#addFilterDelegatedCallable(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToDelegatedCallable(ViewerFilter filter) {
    delegatedCallable.addFilter(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ExternalCallablePropertiesEditionPart#addBusinessFilterDelegatedCallable(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToDelegatedCallable(ViewerFilter filter) {
    delegatedCallable.addBusinessRuleFilter(filter);
  }







	/**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.ExternalCallablePropertiesEditionPart#getPredicate()
   * @generated
   */
  public EObject getPredicate() {
    return predicate.getSelection();
  }

  /**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.ExternalCallablePropertiesEditionPart#initPredicate(EObjectFlatComboSettings)
   */
  public void initPredicate(EObjectFlatComboSettings settings) {
    predicate.setInput(settings);
    if (current != null) {
      predicate.setSelection(new StructuredSelection(settings.getValue()));
    }
  }

  /**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.ExternalCallablePropertiesEditionPart#setPredicate(EObject newValue)
   * @generated
   */
  public void setPredicate(EObject newValue) {
    if (newValue != null) {
      predicate.setSelection(new StructuredSelection(newValue));
    } else {
      predicate.setSelection(new StructuredSelection()); //$NON-NLS-1$
    }
  }

  /**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.ExternalCallablePropertiesEditionPart#setPredicateButtonMode(ButtonsModeEnum newValue)
   */
  public void setPredicateButtonMode(ButtonsModeEnum newValue) {
    predicate.setButtonMode(newValue);
  }

  /**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.ExternalCallablePropertiesEditionPart#addFilterPredicate(ViewerFilter filter)
   * @generated
   */
  public void addFilterToPredicate(ViewerFilter filter) {
    predicate.addFilter(filter);
  }

  /**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.ExternalCallablePropertiesEditionPart#addBusinessFilterPredicate(ViewerFilter filter)
   * @generated
   */
  public void addBusinessFilterToPredicate(ViewerFilter filter) {
    predicate.addBusinessRuleFilter(filter);
  }

  /**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.ExternalCallablePropertiesEditionPart#getRefreshWorkspace()
   * @generated
   */
  public Boolean getRefreshWorkspace() {
    return Boolean.valueOf(refreshWorkspace.getSelection());
  }

  /**
   * {@inheritDoc}
   * 
   * @see de.urszeidler.eclipse.callchain.parts.ExternalCallablePropertiesEditionPart#setRefreshWorkspace(Boolean newValue)
   * @generated
   */
  public void setRefreshWorkspace(Boolean newValue) {
    if (newValue != null) {
      refreshWorkspace.setSelection(newValue.booleanValue());
    } else {
      refreshWorkspace.setSelection(false);
    }
  }

  /**
	 * {@inheritDoc}
	 *
	 * @see org.eclipse.emf.eef.runtime.api.parts.IPropertiesEditionPart#getTitle()
	 * @generated
	 */
	public String getTitle() {
    return CallchainMessages.ExternalCallable_Part_Title;
  }



}
