/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.parts.impl;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent;
import org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart;
import org.eclipse.emf.eef.runtime.impl.notify.PropertiesEditionEvent;
import org.eclipse.emf.eef.runtime.impl.parts.CompositePropertiesEditionPart;
import org.eclipse.emf.eef.runtime.ui.parts.PartComposer;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.BindingCompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionSequence;
import org.eclipse.emf.eef.runtime.ui.parts.sequence.CompositionStep;
import org.eclipse.emf.eef.runtime.ui.utils.EditingUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.ButtonsModeEnum;
import org.eclipse.emf.eef.runtime.ui.widgets.EObjectFlatComboViewer;
import org.eclipse.emf.eef.runtime.ui.widgets.SWTUtils;
import org.eclipse.emf.eef.runtime.ui.widgets.eobjflatcombo.EObjectFlatComboSettings;
import org.eclipse.jface.viewers.ISelectionChangedListener;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.ViewerFilter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Text;

import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.ModelAliasPropertiesEditionPart;
import de.urszeidler.eclipse.callchain.providers.CallchainMessages;


/**
 * @author Urs Zeidler
 * @generated
 */
public class ModelAliasPropertiesEditionPartImpl extends CompositePropertiesEditionPart implements ISWTPropertiesEditionPart, ModelAliasPropertiesEditionPart {

	protected Text aliasName;
	protected EObjectFlatComboViewer decoratedmodel;



	/**
	 * Default constructor
	 * @param editionComponent the {@link IPropertiesEditionComponent} that manage this part
	 * @generated
	 */
	public ModelAliasPropertiesEditionPartImpl(IPropertiesEditionComponent editionComponent) {
    super(editionComponent);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart#
	 * 			createFigure(org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public Composite createFigure(final Composite parent) {
    view = new Composite(parent, SWT.NONE);
    GridLayout layout = new GridLayout();
    layout.numColumns = 3;
    view.setLayout(layout);
    createControls(view);
    return view;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.parts.ISWTPropertiesEditionPart#
	 * 			createControls(org.eclipse.swt.widgets.Composite)
	 * @generated
	 */
	public void createControls(Composite view) { 
    CompositionSequence modelAliasStep = new BindingCompositionSequence(propertiesEditionComponent);
    CompositionStep propertiesStep = modelAliasStep.addStep(CallchainViewsRepository.ModelAlias.Properties.class);
    propertiesStep.addStep(CallchainViewsRepository.ModelAlias.Properties.aliasName);
    propertiesStep.addStep(CallchainViewsRepository.ModelAlias.Properties.decoratedmodel);
    
    
    composer = new PartComposer(modelAliasStep) {

      @Override
      public Composite addToPart(Composite parent, Object key) {
        if (key == CallchainViewsRepository.ModelAlias.Properties.class) {
          return createPropertiesGroup(parent);
        }
        if (key == CallchainViewsRepository.ModelAlias.Properties.aliasName) {
          return createAliasNameText(parent);
        }
        if (key == CallchainViewsRepository.ModelAlias.Properties.decoratedmodel) {
          return createDecoratedmodelFlatComboViewer(parent);
        }
        return parent;
      }
    };
    composer.compose(view);
  }

	/**
	 * @generated
	 */
	protected Composite createPropertiesGroup(Composite parent) {
    Group propertiesGroup = new Group(parent, SWT.NONE);
    propertiesGroup.setText(CallchainMessages.ModelAliasPropertiesEditionPart_PropertiesGroupLabel);
    GridData propertiesGroupData = new GridData(GridData.FILL_HORIZONTAL);
    propertiesGroupData.horizontalSpan = 3;
    propertiesGroup.setLayoutData(propertiesGroupData);
    GridLayout propertiesGroupLayout = new GridLayout();
    propertiesGroupLayout.numColumns = 3;
    propertiesGroup.setLayout(propertiesGroupLayout);
    return propertiesGroup;
  }

	/**
	 * @generated
	 */
	
	protected Composite createAliasNameText(Composite parent) {
    SWTUtils.createPartLabel(parent, CallchainMessages.ModelAliasPropertiesEditionPart_AliasNameLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.ModelAlias.Properties.aliasName, CallchainViewsRepository.SWT_KIND));
    aliasName = new Text(parent, SWT.BORDER);
    GridData aliasNameData = new GridData(GridData.FILL_HORIZONTAL);
    aliasName.setLayoutData(aliasNameData);
    aliasName.addFocusListener(new FocusAdapter() {

      /**
       * {@inheritDoc}
       * 
       * @see org.eclipse.swt.events.FocusAdapter#focusLost(org.eclipse.swt.events.FocusEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void focusLost(FocusEvent e) {
        if (propertiesEditionComponent != null)
          propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(ModelAliasPropertiesEditionPartImpl.this, CallchainViewsRepository.ModelAlias.Properties.aliasName, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, aliasName.getText()));
      }

    });
    aliasName.addKeyListener(new KeyAdapter() {

      /**
       * {@inheritDoc}
       * 
       * @see org.eclipse.swt.events.KeyAdapter#keyPressed(org.eclipse.swt.events.KeyEvent)
       * @generated
       */
      @Override
      @SuppressWarnings("synthetic-access")
      public void keyPressed(KeyEvent e) {
        if (e.character == SWT.CR) {
          if (propertiesEditionComponent != null)
            propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(ModelAliasPropertiesEditionPartImpl.this, CallchainViewsRepository.ModelAlias.Properties.aliasName, PropertiesEditionEvent.COMMIT, PropertiesEditionEvent.SET, null, aliasName.getText()));
        }
      }

    });
    EditingUtils.setID(aliasName, CallchainViewsRepository.ModelAlias.Properties.aliasName);
    EditingUtils.setEEFtype(aliasName, "eef::Text"); //$NON-NLS-1$
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.ModelAlias.Properties.aliasName, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }

	/**
	 * @param parent the parent composite
	 * @generated
	 */
	protected Composite createDecoratedmodelFlatComboViewer(Composite parent) {
    SWTUtils.createPartLabel(parent, CallchainMessages.ModelAliasPropertiesEditionPart_DecoratedmodelLabel, propertiesEditionComponent.isRequired(CallchainViewsRepository.ModelAlias.Properties.decoratedmodel, CallchainViewsRepository.SWT_KIND));
    decoratedmodel = new EObjectFlatComboViewer(parent, !propertiesEditionComponent.isRequired(CallchainViewsRepository.ModelAlias.Properties.decoratedmodel, CallchainViewsRepository.SWT_KIND));
    decoratedmodel.setLabelProvider(new AdapterFactoryLabelProvider(adapterFactory));

    decoratedmodel.addSelectionChangedListener(new ISelectionChangedListener() {

      public void selectionChanged(SelectionChangedEvent event) {
        propertiesEditionComponent.firePropertiesChanged(new PropertiesEditionEvent(ModelAliasPropertiesEditionPartImpl.this, CallchainViewsRepository.ModelAlias.Properties.decoratedmodel, PropertiesEditionEvent.CHANGE, PropertiesEditionEvent.SET, null, getDecoratedmodel()));
      }

    });
    GridData decoratedmodelData = new GridData(GridData.FILL_HORIZONTAL);
    decoratedmodel.setLayoutData(decoratedmodelData);
    decoratedmodel.setID(CallchainViewsRepository.ModelAlias.Properties.decoratedmodel);
    SWTUtils.createHelpButton(parent, propertiesEditionComponent.getHelpContent(CallchainViewsRepository.ModelAlias.Properties.decoratedmodel, CallchainViewsRepository.SWT_KIND), null); //$NON-NLS-1$
    return parent;
  }



	/**
	 * {@inheritDoc}
	 * 
	 * @see org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionListener#firePropertiesChanged(org.eclipse.emf.eef.runtime.api.notify.IPropertiesEditionEvent)
	 * @generated
	 */
	public void firePropertiesChanged(IPropertiesEditionEvent event) {
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelAliasPropertiesEditionPart#getAliasName()
	 * @generated
	 */
	public String getAliasName() {
    return aliasName.getText();
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelAliasPropertiesEditionPart#setAliasName(String newValue)
	 * @generated
	 */
	public void setAliasName(String newValue) {
    if (newValue != null) {
      aliasName.setText(newValue);
    } else {
      aliasName.setText(""); //$NON-NLS-1$
    }
  }


	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelAliasPropertiesEditionPart#getDecoratedmodel()
	 * @generated
	 */
	public EObject getDecoratedmodel() {
    if (decoratedmodel.getSelection() instanceof StructuredSelection) {
      Object firstElement = ((StructuredSelection) decoratedmodel.getSelection()).getFirstElement();
      if (firstElement instanceof EObject)
        return (EObject) firstElement;
    }
    return null;
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelAliasPropertiesEditionPart#initDecoratedmodel(EObjectFlatComboSettings)
	 */
	public void initDecoratedmodel(EObjectFlatComboSettings settings) {
		decoratedmodel.setInput(settings);
		if (current != null) {
			decoratedmodel.setSelection(new StructuredSelection(settings.getValue()));
		}
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelAliasPropertiesEditionPart#setDecoratedmodel(EObject newValue)
	 * @generated
	 */
	public void setDecoratedmodel(EObject newValue) {
    if (newValue != null) {
      decoratedmodel.setSelection(new StructuredSelection(newValue));
    } else {
      decoratedmodel.setSelection(new StructuredSelection()); //$NON-NLS-1$
    }
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelAliasPropertiesEditionPart#setDecoratedmodelButtonMode(ButtonsModeEnum newValue)
	 */
	public void setDecoratedmodelButtonMode(ButtonsModeEnum newValue) {
		decoratedmodel.setButtonMode(newValue);
	}

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelAliasPropertiesEditionPart#addFilterDecoratedmodel(ViewerFilter filter)
	 * @generated
	 */
	public void addFilterToDecoratedmodel(ViewerFilter filter) {
    decoratedmodel.addFilter(filter);
  }

	/**
	 * {@inheritDoc}
	 * 
	 * @see de.urszeidler.eclipse.callchain.parts.ModelAliasPropertiesEditionPart#addBusinessFilterDecoratedmodel(ViewerFilter filter)
	 * @generated
	 */
	public void addBusinessFilterToDecoratedmodel(ViewerFilter filter) {
    decoratedmodel.addBusinessRuleFilter(filter);
  }







	/**
	 * {@inheritDoc}
	 *
	 * @see org.eclipse.emf.eef.runtime.api.parts.IPropertiesEditionPart#getTitle()
	 * @generated
	 */
	public String getTitle() {
    return CallchainMessages.ModelAlias_Part_Title;
  }



}
