/**
 * 
 */
package de.urszeidler.eclipse.callchain.propertySource;

import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.ui.provider.PropertySource;
import org.eclipse.ui.views.properties.IPropertyDescriptor;

import de.urszeidler.eclipse.callchain.AtlLibary;
import de.urszeidler.eclipse.callchain.AtlRes;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.MM;
import de.urszeidler.eclipse.callchain.Model;

public final class CustomPropertySource extends PropertySource {
	public CustomPropertySource(Object object,
			IItemPropertySource itemPropertySource) {
		super(object, itemPropertySource);
	}

	protected IPropertyDescriptor createPropertyDescriptor(
			IItemPropertyDescriptor itemPropertyDescriptor) {

		String id = itemPropertyDescriptor.getId(this.object);

		if (!id.equals(ItemPropertyDescriptor
				.getDefaultId(CallchainPackage.eINSTANCE
						.getArtifact_Uri())))
			return super
					.createPropertyDescriptor(itemPropertyDescriptor);


		if (object instanceof AtlLibary) {
			return new ElementTreeSelectionDialogPropertySource(object,
					itemPropertyDescriptor, "lib");

		}// end of if (object instanceof AtlLibary)

		if (object instanceof AtlRes) {
			return new ElementTreeSelectionDialogPropertySource(object,
					itemPropertyDescriptor, "atl");
		}// end of if (object instanceof AtlRes)

		if (object instanceof Model) {
			return new ElementTreeSelectionDialogPropertySource(object,
					itemPropertyDescriptor, "");

		}// end of if (object instanceof Model)
		if (object instanceof MM) {
			return new EMFDialog(object, itemPropertyDescriptor);
		}

		return super.createPropertyDescriptor(itemPropertyDescriptor);
	}
}