/*
 * (c) urs zeidler
 */
package de.urszeidler.eclipse.callchain.propertySource;

import org.eclipse.core.resources.IContainer;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.ui.provider.PropertyDescriptor;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.DialogCellEditor;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.ui.dialogs.ElementTreeSelectionDialog;
import org.eclipse.ui.dialogs.ISelectionStatusValidator;
import org.eclipse.ui.model.WorkbenchContentProvider;
import org.eclipse.ui.model.WorkbenchLabelProvider;
import org.eclipse.ui.views.properties.IPropertyDescriptor;

public class ElementTreeSelectionDialogPropertySource extends
        PropertyDescriptor implements IPropertyDescriptor {

    private String type;
    public ElementTreeSelectionDialogPropertySource(Object object, IItemPropertyDescriptor itemPropertyDescriptor, String string) {
        super(object, itemPropertyDescriptor);
       type = string;
    }
@Override
public CellEditor createPropertyEditor(Composite composite) {
    // TODO Auto-generated method stub
    return  new DialogCellEditor(composite){

        @Override
        protected Object openDialogBox(Control cellEditorWindow) {
            ElementTreeSelectionDialog elementTreeSelectionDialog = new ElementTreeSelectionDialog( cellEditorWindow.getShell(), new WorkbenchLabelProvider(), new WorkbenchContentProvider());
            elementTreeSelectionDialog.setInput(ResourcesPlugin.getWorkspace().getRoot());
            //elementTreeSelectionDialog.setMessage(Messages.getString("ModelChoiceTab.CHOOSE") + type); //$NON-NLS-1$
            elementTreeSelectionDialog.setAllowMultiple(false);
            elementTreeSelectionDialog.setDoubleClickSelects(true);

            createFilter(elementTreeSelectionDialog);
            elementTreeSelectionDialog.setValidator(new ISelectionStatusValidator() {
                public IStatus validate(Object[] selection) {
                    IStatus ret = Status.CANCEL_STATUS;
                    
                    if(selection.length == 1) {
                        if(selection[0] instanceof IFile) { // no need to verify again extension here
                            ret = Status.OK_STATUS; 
                        }
                    }
                    
                    return ret;
                }               
            });

            
            int i = elementTreeSelectionDialog.open();
            Object result = elementTreeSelectionDialog.getFirstResult();
            if(i==Window.OK){
                if ((result != null) && (result instanceof IFile)) {
                    //TableItem item = table.getItem(index);
                    IFile currentFile = (IFile)result;
                    return currentFile.getFullPath().toString();
             }

                
                
            }
                
            return null;
        }

        /**
         * @param elementTreeSelectionDialog
         */
        private void createFilter(ElementTreeSelectionDialog elementTreeSelectionDialog) {
            elementTreeSelectionDialog.addFilter(new ViewerFilter() {
                public boolean select(Viewer viewer, Object parentElement, Object element) {
                    boolean ret = false;
                    
                    if(element instanceof IContainer) {
                        ret = true;
                    } else if(element instanceof IFile) {
                        IFile currentFile = (IFile)element;
                        if (currentFile.getFileExtension() == null)
                            return false;
                        if (type =="lib")
                            ret = (currentFile.getFileExtension().toUpperCase()).equals("ASM");
                        if (type =="atl")
                            ret = (currentFile.getFileExtension().toUpperCase()).equals("ATL");
                        else
                            ret = true;/*(
                                    (currentFile.getFileExtension().toUpperCase()).equals("XMI")
                                    ||
                                    (currentFile.getFileExtension().toUpperCase()).equals("ECORE")
                                    );*/
                    }
                    return ret;
                }
            });
        }
        
    };
}
    
}
