/**
 * <copyright>
 * </copyright>
 *
 * $Id: CallchainEditPlugin.java,v 1.2 2008/04/15 22:40:35 urs Exp $
 */
package de.urszeidler.eclipse.callchain.provider;

import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.InvocationTargetException;
import java.net.URL;

import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.emf.common.EMFPlugin;
import org.eclipse.emf.common.util.ResourceLocator;

/**
 * This is the central singleton for the Callchain edit plugin.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public final class CallchainEditPlugin extends EMFPlugin {
	/**
	 * Keep track of the singleton.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final CallchainEditPlugin INSTANCE = new CallchainEditPlugin();

	/**
	 * Keep track of the singleton.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static Implementation plugin;

	/**
	 * Create the instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallchainEditPlugin() {
		super
		  (new ResourceLocator [] {
		   });
	}

	/**
	 * Returns the singleton instance of the Eclipse plugin.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the singleton instance.
	 * @generated
	 */
	@Override
	public ResourceLocator getPluginResourceLocator() {
		return plugin;
	}

	/**
	 * Returns the singleton instance of the Eclipse plugin.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the singleton instance.
	 * @generated
	 */
	public static Implementation getPlugin() {
		return plugin;
	}
	   /**
     * get the Id of the Plugin
     *
     * @return the Plugin Id
     */
    public static String getId()
    {
        return getPlugin().getBundle().getSymbolicName();
    }
	
    /**
     * Log a message with given level into the Eclipse log file
     *
     * @param message the message to log
     * @param level the message priority
     */
    public static void log(String message, int level,Throwable e)
    {
        IStatus status = null;
        status = new Status(level, getId(), IStatus.OK, message, e);
        log(status);
    }
    /**
     * Log a message with given level into the Eclipse log file
     *
     * @param message the message to log
     * @param level the message priority
     */
    public static void log(String message, int level)
    {
        IStatus status = null;
        status = new Status(level, getId(), IStatus.OK, message, null);
        log(status);
    }

    /**
     * Log an IStatus
     *
     * @param status Status of an operation
     */
    public static void log(IStatus status)
    {
        ResourcesPlugin.getPlugin().getLog().log(status);
    }


    /**
     * Log an exception into the Eclipse log file
     *
     * @param e the exception to log
     */
    public static void log(Throwable e) {
        if (e instanceof InvocationTargetException)
            e = ((InvocationTargetException) e).getTargetException();

        IStatus status = null;
        if (e instanceof CoreException)
            status = ((CoreException) e).getStatus();
        else
            status = new Status(IStatus.ERROR, getId(), IStatus.OK, "Error", e);

        log(status);
    }

    
//    /**
//     * Display a dialog box with the specified level
//     * 
//     * @param title title dialog box
//     * @param message message displayed
//     * @param level message level
//     * @generated not
//     */
//    public static void displayDialog(final String title, final String message,
//            int level) {
//        if (level == IStatus.INFO) {
//            Display.getDefault().asyncExec(new Runnable() {
//                public void run() {
//                    MessageDialog.openInformation(getActiveWorkbenchShell(),
//                            (title == null) ? "Information" : title,
//                            (message == null) ? "" : message);
//                }
//            });
//        } else if (level == IStatus.WARNING) {
//            Display.getDefault().asyncExec(new Runnable() {
//                public void run() {
//                    MessageDialog.openWarning(getActiveWorkbenchShell(),
//                            (title == null) ? "Warning" : title,
//                            (message == null) ? "" : message);
//                }
//            });
//        } else if (level == IStatus.ERROR) {
//            Display.getDefault().asyncExec(new Runnable() {
//                public void run() {
//                    MessageDialog.openError(getActiveWorkbenchShell(),
//                            (title == null) ? "Error" : title,
//                            (message == null) ? "" : message);
//                }
//            });
//        }
//    }

/**
	 * The actual implementation of the Eclipse <b>Plugin</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static class Implementation extends EclipsePlugin {
		/**
		 * Creates an instance.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		public Implementation() {
			super();

			// Remember the static instance.
			//
			plugin = this;
		}
    /** Does the work of fetching the image associated with the key.
    * It ensures that the image exists.
    * @param key the key of the image to fetch.
    * @exception IOException if an image doesn't exist.
    * @return the description of the image associated with the key.
    */
   protected Object doGetImage(String key) throws IOException
   {
       Object obj = null;
     try {
       obj = helper.getImage(key);
     
   } catch (Exception e) {
       URL url = new URL(getBaseURL() + "icons/" + key + ".gif");
       InputStream inputStream = url.openStream(); 
       inputStream.close();
       obj = url;
       log(url);
   }
     return obj;
   }

}

}
