/**
 * <copyright>
 * </copyright>
 *
 * $Id: CallchainItemProviderAdapterFactory.java,v 1.2 2008/04/13 20:27:38 urs Exp $
 */
package de.urszeidler.eclipse.callchain.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import de.urszeidler.eclipse.callchain.util.CallchainAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class CallchainItemProviderAdapterFactory extends CallchainAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallchainItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.Model} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelItemProvider modelItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.Model}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createModelAdapter() {
		if (modelItemProvider == null) {
			modelItemProvider = new ModelItemProvider(this);
		}

		return modelItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.AtlRes} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AtlResItemProvider atlResItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.AtlRes}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAtlResAdapter() {
		if (atlResItemProvider == null) {
			atlResItemProvider = new AtlResItemProvider(this);
		}

		return atlResItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.Call} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CallItemProvider callItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.Call}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCallAdapter() {
		if (callItemProvider == null) {
			callItemProvider = new CallItemProvider(this);
		}

		return callItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.MM} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MMItemProvider mmItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.MM}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMMAdapter() {
		if (mmItemProvider == null) {
			mmItemProvider = new MMItemProvider(this);
		}

		return mmItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.Calls} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CallsItemProvider callsItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.Calls}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCallsAdapter() {
		if (callsItemProvider == null) {
			callsItemProvider = new CallsItemProvider(this);
		}

		return callsItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.AtlLibary} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AtlLibaryItemProvider atlLibaryItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.AtlLibary}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAtlLibaryAdapter() {
		if (atlLibaryItemProvider == null) {
			atlLibaryItemProvider = new AtlLibaryItemProvider(this);
		}

		return atlLibaryItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.ModelAlias} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelAliasItemProvider modelAliasItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.ModelAlias}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createModelAliasAdapter() {
		if (modelAliasItemProvider == null) {
			modelAliasItemProvider = new ModelAliasItemProvider(this);
		}

		return modelAliasItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.Artifact} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ArtifactItemProvider artifactItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.Artifact}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createArtifactAdapter() {
		if (artifactItemProvider == null) {
			artifactItemProvider = new ArtifactItemProvider(this);
		}

		return artifactItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.MMAlias} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MMAliasItemProvider mmAliasItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.MMAlias}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMMAliasAdapter() {
		if (mmAliasItemProvider == null) {
			mmAliasItemProvider = new MMAliasItemProvider(this);
		}

		return mmAliasItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.Comment} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CommentItemProvider commentItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.Comment}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCommentAdapter() {
		if (commentItemProvider == null) {
			commentItemProvider = new CommentItemProvider(this);
		}

		return commentItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.Generic_Generator} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Generic_GeneratorItemProvider generic_GeneratorItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.Generic_Generator}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createGeneric_GeneratorAdapter() {
		if (generic_GeneratorItemProvider == null) {
			generic_GeneratorItemProvider = new Generic_GeneratorItemProvider(this);
		}

		return generic_GeneratorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.Property} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyItemProvider propertyItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.Property}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPropertyAdapter() {
		if (propertyItemProvider == null) {
			propertyItemProvider = new PropertyItemProvider(this);
		}

		return propertyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.PredicateSwitch} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PredicateSwitchItemProvider predicateSwitchItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.PredicateSwitch}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPredicateSwitchAdapter() {
		if (predicateSwitchItemProvider == null) {
			predicateSwitchItemProvider = new PredicateSwitchItemProvider(this);
		}

		return predicateSwitchItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.Transition} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TransitionItemProvider transitionItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.Transition}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTransitionAdapter() {
		if (transitionItemProvider == null) {
			transitionItemProvider = new TransitionItemProvider(this);
		}

		return transitionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.PropertyHasValue} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyHasValueItemProvider propertyHasValueItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.PropertyHasValue}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPropertyHasValueAdapter() {
		if (propertyHasValueItemProvider == null) {
			propertyHasValueItemProvider = new PropertyHasValueItemProvider(this);
		}

		return propertyHasValueItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.PropertyExist} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyExistItemProvider propertyExistItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.PropertyExist}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPropertyExistAdapter() {
		if (propertyExistItemProvider == null) {
			propertyExistItemProvider = new PropertyExistItemProvider(this);
		}

		return propertyExistItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.ResourceExistPredicate} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ResourceExistPredicateItemProvider resourceExistPredicateItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.ResourceExistPredicate}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createResourceExistPredicateAdapter() {
		if (resourceExistPredicateItemProvider == null) {
			resourceExistPredicateItemProvider = new ResourceExistPredicateItemProvider(this);
		}

		return resourceExistPredicateItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.AndPredicate} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AndPredicateItemProvider andPredicateItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.AndPredicate}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAndPredicateAdapter() {
		if (andPredicateItemProvider == null) {
			andPredicateItemProvider = new AndPredicateItemProvider(this);
		}

		return andPredicateItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.OrPredicate} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OrPredicateItemProvider orPredicateItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.OrPredicate}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createOrPredicateAdapter() {
		if (orPredicateItemProvider == null) {
			orPredicateItemProvider = new OrPredicateItemProvider(this);
		}

		return orPredicateItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.NotPredicate} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected NotPredicateItemProvider notPredicateItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.NotPredicate}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createNotPredicateAdapter() {
		if (notPredicateItemProvider == null) {
			notPredicateItemProvider = new NotPredicateItemProvider(this);
		}

		return notPredicateItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.PropertyValueSwitch} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PropertyValueSwitchItemProvider propertyValueSwitchItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.PropertyValueSwitch}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPropertyValueSwitchAdapter() {
		if (propertyValueSwitchItemProvider == null) {
			propertyValueSwitchItemProvider = new PropertyValueSwitchItemProvider(this);
		}

		return propertyValueSwitchItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.ExternalCallable} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExternalCallableItemProvider externalCallableItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.ExternalCallable}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createExternalCallableAdapter() {
		if (externalCallableItemProvider == null) {
			externalCallableItemProvider = new ExternalCallableItemProvider(this);
		}

		return externalCallableItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.StopCall} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StopCallItemProvider stopCallItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.StopCall}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createStopCallAdapter() {
		if (stopCallItemProvider == null) {
			stopCallItemProvider = new StopCallItemProvider(this);
		}

		return stopCallItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link de.urszeidler.eclipse.callchain.BooleanPredicate} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BooleanPredicateItemProvider booleanPredicateItemProvider;

	/**
	 * This creates an adapter for a {@link de.urszeidler.eclipse.callchain.BooleanPredicate}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBooleanPredicateAdapter() {
		if (booleanPredicateItemProvider == null) {
			booleanPredicateItemProvider = new BooleanPredicateItemProvider(this);
		}

		return booleanPredicateItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (modelItemProvider != null) modelItemProvider.dispose();
		if (atlResItemProvider != null) atlResItemProvider.dispose();
		if (callItemProvider != null) callItemProvider.dispose();
		if (mmItemProvider != null) mmItemProvider.dispose();
		if (callsItemProvider != null) callsItemProvider.dispose();
		if (atlLibaryItemProvider != null) atlLibaryItemProvider.dispose();
		if (modelAliasItemProvider != null) modelAliasItemProvider.dispose();
		if (artifactItemProvider != null) artifactItemProvider.dispose();
		if (mmAliasItemProvider != null) mmAliasItemProvider.dispose();
		if (commentItemProvider != null) commentItemProvider.dispose();
		if (generic_GeneratorItemProvider != null) generic_GeneratorItemProvider.dispose();
		if (propertyItemProvider != null) propertyItemProvider.dispose();
		if (predicateSwitchItemProvider != null) predicateSwitchItemProvider.dispose();
		if (transitionItemProvider != null) transitionItemProvider.dispose();
		if (propertyHasValueItemProvider != null) propertyHasValueItemProvider.dispose();
		if (propertyExistItemProvider != null) propertyExistItemProvider.dispose();
		if (resourceExistPredicateItemProvider != null) resourceExistPredicateItemProvider.dispose();
		if (andPredicateItemProvider != null) andPredicateItemProvider.dispose();
		if (orPredicateItemProvider != null) orPredicateItemProvider.dispose();
		if (notPredicateItemProvider != null) notPredicateItemProvider.dispose();
		if (propertyValueSwitchItemProvider != null) propertyValueSwitchItemProvider.dispose();
		if (externalCallableItemProvider != null) externalCallableItemProvider.dispose();
		if (stopCallItemProvider != null) stopCallItemProvider.dispose();
		if (booleanPredicateItemProvider != null) booleanPredicateItemProvider.dispose();
	}

}
