/**
 * <copyright>
 * </copyright>
 *
 * $Id: Generic_GeneratorItemProvider.java,v 1.1 2008/04/13 20:27:38 urs Exp $
 */
package de.urszeidler.eclipse.callchain.provider;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.Generic_Generator;
import de.urszeidler.eclipse.callchain.generatorservice.GeneratorDescriptor;
import de.urszeidler.eclipse.callchain.generatorservice.Generatorservice;

/**
 * This is the item provider adapter for a
 * {@link de.urszeidler.eclipse.callchain.Generic_Generator} object. <!--
 * begin-user-doc --> <!-- end-user-doc -->
 * 
 * @generated
 */
public class Generic_GeneratorItemProvider extends GeneratorItemProvider implements IEditingDomainItemProvider,
		IStructuredItemContentProvider, ITreeItemContentProvider, IItemLabelProvider, IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Generic_GeneratorItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addIdPropertyDescriptor(object);
			addGeneratorTypePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Id feature.
	 * <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * @generated
	 */
	protected void addIdPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Generic_Generator_id_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Generic_Generator_id_feature", "_UI_Generic_Generator_type"),
				 CallchainPackage.Literals.GENERIC_GENERATOR__ID,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Generator Type feature. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected void addGeneratorTypePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Generic_Generator_generatorType_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Generic_Generator_generatorType_feature", "_UI_Generic_Generator_type"),
				 CallchainPackage.Literals.GENERIC_GENERATOR__GENERATOR_TYPE,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This returns Useit_Generator.gif. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated not
	 */
	@Override
	public Object getImage(Object object) {
		if (object instanceof Generic_Generator) {
			Generic_Generator gg = (Generic_Generator) object;
			GeneratorDescriptor descriptor = Generatorservice.getDefault().getGenerator(gg.getId());
			if (descriptor != null)
				if (descriptor.getSmallIcon() != null)
					return overlayImage(object, descriptor.getSmallIcon());
		}
		return overlayImage(object, getResourceLocator().getImage("full/obj16/Generic_Generator"));
	}

	/**
	 * This returns the label text for the adapted class. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated not
	 */
	@Override
	public String getText(Object object) {
		if (object instanceof Generic_Generator) {
			Generic_Generator gg = (Generic_Generator) object;
			GeneratorDescriptor descriptor = Generatorservice.getDefault().getGenerator(gg.getId());
			if (descriptor != null)
				if (descriptor.getSmallIcon() != null) {
					String label = ((Generic_Generator) object).getName();
					return label == null || label.length() == 0 ? descriptor.getName() : descriptor.getName() + " "
							+ label;
				}

		}

		String label = ((Generic_Generator) object).getName();
		return label == null || label.length() == 0 ? getString("_UI_Generic_Generator_type")
				: getString("_UI_Useit_Generator_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(Generic_Generator.class)) {
			case CallchainPackage.GENERIC_GENERATOR__ID:
			case CallchainPackage.GENERIC_GENERATOR__GENERATOR_TYPE:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing the children that can be created under this object. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

}
