/*
 * (c) Urs Zeidler 2011
 */
package de.urszeidler.eclipse.callchain.providers;

import org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent;
import org.eclipse.emf.eef.runtime.api.parts.IPropertiesEditionPart;
import org.eclipse.emf.eef.runtime.api.providers.IPropertiesEditionPartProvider;

import de.urszeidler.eclipse.callchain.parts.CallchainViewsRepository;
import de.urszeidler.eclipse.callchain.parts.forms.AndPredicatePropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.ArtifactPropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.AtlLibaryPropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.AtlResPropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.BooleanPredicatePropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.CallPropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.CallsPropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.CommentPropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.ExternalCallablePropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.Generic_GeneratorPropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.MMAliasPropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.MMPropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.ModelAliasPropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.ModelPropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.NotPredicatePropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.OrPredicatePropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.PredicateSwitchPropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.PropertyExistPropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.PropertyHasValuePropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.PropertyPropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.PropertyValueSwitchPropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.ResourceExistPredicatePropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.StopCallPropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.forms.TransitionPropertiesEditionPartForm;
import de.urszeidler.eclipse.callchain.parts.impl.AndPredicatePropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.ArtifactPropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.AtlLibaryPropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.AtlResPropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.BooleanPredicatePropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.CallPropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.CallsPropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.CommentPropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.ExternalCallablePropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.Generic_GeneratorPropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.MMAliasPropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.MMPropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.ModelAliasPropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.ModelPropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.NotPredicatePropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.OrPredicatePropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.PredicateSwitchPropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.PropertyExistPropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.PropertyHasValuePropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.PropertyPropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.PropertyValueSwitchPropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.ResourceExistPredicatePropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.StopCallPropertiesEditionPartImpl;
import de.urszeidler.eclipse.callchain.parts.impl.TransitionPropertiesEditionPartImpl;




/**
 * @author Urs Zeidler
 * @generated
 */
public class CallchainPropertiesEditionPartProvider implements IPropertiesEditionPartProvider {

	/** 
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.api.parts.IPropertiesEditionPartProvider#provides(java.lang.Object)
	 * @generated
	 */
	public boolean provides(Object key) {
    return key == CallchainViewsRepository.class;
  }

	/** 
	 * {@inheritDoc}
	 * @see org.eclipse.emf.eef.runtime.api.parts.IPropertiesEditionPartProvider#getPropertiesEditionPart(java.lang.Object, int, org.eclipse.emf.eef.runtime.api.component.IPropertiesEditionComponent)
	 * @generated
	 */
	public IPropertiesEditionPart getPropertiesEditionPart(Object key, int kind, IPropertiesEditionComponent component) {
    if (key == CallchainViewsRepository.Model.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new ModelPropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new ModelPropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.AtlRes.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new AtlResPropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new AtlResPropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.Call.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new CallPropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new CallPropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.MM.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new MMPropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new MMPropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.Calls.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new CallsPropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new CallsPropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.AtlLibary.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new AtlLibaryPropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new AtlLibaryPropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.ModelAlias.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new ModelAliasPropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new ModelAliasPropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.Artifact.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new ArtifactPropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new ArtifactPropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.MMAlias.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new MMAliasPropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new MMAliasPropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.Comment.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new CommentPropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new CommentPropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.Generic_Generator.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new Generic_GeneratorPropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new Generic_GeneratorPropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.Property.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new PropertyPropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new PropertyPropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.PredicateSwitch.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new PredicateSwitchPropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new PredicateSwitchPropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.Transition.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new TransitionPropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new TransitionPropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.PropertyHasValue.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new PropertyHasValuePropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new PropertyHasValuePropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.PropertyExist.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new PropertyExistPropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new PropertyExistPropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.ResourceExistPredicate.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new ResourceExistPredicatePropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new ResourceExistPredicatePropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.AndPredicate.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new AndPredicatePropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new AndPredicatePropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.OrPredicate.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new OrPredicatePropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new OrPredicatePropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.NotPredicate.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new NotPredicatePropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new NotPredicatePropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.PropertyValueSwitch.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new PropertyValueSwitchPropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new PropertyValueSwitchPropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.ExternalCallable.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new ExternalCallablePropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new ExternalCallablePropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.StopCall.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new StopCallPropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new StopCallPropertiesEditionPartForm(component);
    }
    if (key == CallchainViewsRepository.BooleanPredicate.class) {
      if (kind == CallchainViewsRepository.SWT_KIND)
        return new BooleanPredicatePropertiesEditionPartImpl(component);
      if (kind == CallchainViewsRepository.FORM_KIND)
        return new BooleanPredicatePropertiesEditionPartForm(component);
    }
    return null;
  }

}
