package de.urszeidler.eclipse.callchain.tabbedpropery.sections;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecoretools.tabbedproperties.sections.AbstractStringPropertySection;
import org.eclipse.swt.SWT;

import de.urszeidler.eclipse.callchain.CallchainPackage;

/**
 * A section display a text field to edit/see String features
 *
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 *
 * @generated not
 */
public class CommentDocSection extends AbstractStringPropertySection {
    /**
     * @see org.topcased.tabbedproperties.sections.AbstractTextPropertySection#getLabelText()
     */
    protected String getLabelText()
    {
        return "Doc:";
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractTextPropertySection#getFeature()
     */
    protected EStructuralFeature getFeature()
    {
        return CallchainPackage.eINSTANCE.getComment_Doc();
    }

    /**
     * @see org.topcased.tabbedproperties.sections.AbstractTextPropertySection#getStyle()
     */
    protected int getStyle()
    {
        return SWT.MULTI | SWT.WRAP;
    }

    /**
     * @see org.eclipse.ui.views.properties.tabbed.AbstractPropertySection#shouldUseExtraSpace()
     */
    public boolean shouldUseExtraSpace()
    {
        return true;
    }
	
//	
//    /** The text control for the section. */
//    private Text text;
//
//    /** The label used with to identify the Section */
//    private CLabel nameLabel;
//
//    /** A helper to listen for events that indicate that a text field has been changed. */
//    private TextChangeListener listener;
//
//    //        private Composite sectionComposite;
//
//    /**
//     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#createControls(org.eclipse.swt.widgets.Composite,
//     *      org.eclipse.ui.views.properties.tabbed.TabbedPropertySheetPage)
//     */
//    public void createControls(Composite parent,
//            TabbedPropertySheetPage tabbedPropertySheetPage) {
//        super.createControls(parent, tabbedPropertySheetPage);
//        Composite composite = getWidgetFactory()
//                .createFlatFormComposite(parent);
//
//        //        FormData data = new FormData();
//        //        data.left = new FormAttachment(0, 0);
//        //        data.right = new FormAttachment(100, 0);
//        //        data.top = new FormAttachment(0, 0);
//        //        data.bottom = new FormAttachment(100, 0);
//        //        data.height = 50;
//
//        //        composite.setLayoutData(data);
//
//        createWidgets(composite);
//        setFormData(composite);
//    }
//
//    /**
//     * Creates the label widget and the text field control
//     * 
//     * @param composite The composite holding both widgets
//     */
//    protected void createWidgets(Composite composite) {
//
//        text = getWidgetFactory().createText(composite, "", getStyle());
//
//        if (getFeature() != null) {
//            boolean isChangeable = getFeature().isChangeable();
//
//            text.setEditable(isChangeable);
//            text.setEnabled(isChangeable);
//        }
//
//        nameLabel = getWidgetFactory().createCLabel(composite, getLabelText());
//
//        listener = new TextChangeListener() {
//            public void textChanged(Control control) {
//                handleTextModified();
//            }
//
//            public void focusIn(Control control) {
//                CommentDocSection.this.focusIn();
//            }
//
//            public void focusOut(Control control) {
//                CommentDocSection.this.focusOut();
//            }
//        };
//        listener.startListeningTo(text);
//
//        // Do not listen to the "Enter" key pressed when the widget is a
//        // MultiLine Text
//        if ((getStyle() & SWT.MULTI) == 0) {
//            listener.startListeningForEnter(text);
//        }
//        text.addListener(SWT.Modify, new Listener() {
//            public void handleEvent(Event e) {
//                verifyField(e);
//            }
//        });
//    }
//
//    protected void setFormData(Composite composite) {
//        FormData data = new FormData();
//        data.left = new FormAttachment(0, getStandardLabelWidth(composite,
//                new String[] { getLabelText() }));
//        data.right = new FormAttachment(100, 0);
//        data.top = new FormAttachment(0, ITabbedPropertyConstants.VSPACE);
//        data.bottom = new FormAttachment(100, 0);
//        text.setLayoutData(data);
//
//        data = new FormData();
//        data.left = new FormAttachment(0, 0);
//        data.right = new FormAttachment(text, -ITabbedPropertyConstants.HSPACE);
//        data.top = new FormAttachment(text, 0, SWT.TOP);
//        nameLabel.setLayoutData(data);
//
//    }
//
//    /**
//     * @see org.eclipse.ui.views.properties.tabbed.AbstractPropertySection#refresh()
//     */
//    public void refresh() {
//        getText().setText(getFeatureAsString());
//    }
//
//    /**
//     * Handle the text modified event. When there is any problem while creating and executing the command, the view will
//     * be only refreshed
//     */
//    protected void handleTextModified() {
//        if (isTextValid()) {
//            createCommand(getOldFeatureValue(), getNewFeatureValue(getText()
//                    .getText()));
//        } else {
//            refresh();
//        }
//    }
//
//    /**
//     * Handle action when the focus is gained Default action is to do nothing. Clients may override this method if they
//     * desire a particular action to be executed when the text control gain the focus.
//     */
//    protected void focusIn() {
//        // Do nothing
//    }
//
//    /**
//     * Handle action when the focus is lost. Default action is to do nothing. Clients may override this method if they
//     * desire a particular action to be executed when the text control lost the focus.
//     */
//    protected void focusOut() {
//        // Do nothing
//    }
//
//    /**
//     * @return the listener
//     */
//    protected TextChangeListener getListener() {
//        return listener;
//    }
//
//    /**
//     * @return the text
//     */
//    protected Text getText() {
//        return text;
//    }
//
//    /**
//     * @return the nameLabel
//     */
//    public CLabel getNameLabel() {
//        return nameLabel;
//    }
//
//    /**
//     * Check whether the text entered is valid or not. Subclasses should override this method to provide their own
//     * check. By default, return true.
//     * 
//     * @return true if the text entered is valid
//     */
//    protected boolean isTextValid() {
//        return true;
//    }
//
//    /**
//     * @see org.topcased.tabbedproperties.sections.AbstractTextPropertySection#verifyField(Event)
//     */
//    protected void verifyField(Event e) {
//        // do nothing
//    }
//
//    /**
//     * @see org.topcased.tabbedproperties.sections.AbstractTextPropertySection#getFeatureAsString()
//     */
//    protected String getFeatureAsString() {
//        String string = getEObject() == null ? null : (String) getEObject()
//                .eGet(getFeature());
//        if (string == null) {
//            return "";
//        }
//        return string;
//    }
//
//    /**
//     * @see org.topcased.tabbedproperties.sections.AbstractTextPropertySection#getNewFeatureValue(java.lang.String)
//     */
//    protected Object getNewFeatureValue(String newText) {
//        return newText;
//    }
//
//    /**
//     * @see org.topcased.tabbedproperties.sections.AbstractTextPropertySection#getOldFeatureValue()
//     */
//    protected Object getOldFeatureValue() {
//        return getFeatureAsString();
//    }
//
//    /**
//     * <!-- begin-user-doc -->
//     * <!-- end-user-doc -->
//     *
//     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#getLabelText()
//     * @generated
//     */
//    protected String getLabelText() {
//        return "Doc:";
//    }
//
//    /**
//     * <!-- begin-user-doc -->
//     * <!-- end-user-doc -->
//     *
//     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#getFeature()
//     * @generated
//     */
//    protected EStructuralFeature getFeature() {
//        return CallchainPackage.eINSTANCE.getComment_Doc();
//    }
//
//    /**
//     * <!-- begin-user-doc -->
//     * <!-- end-user-doc -->
//     *
//     * @see org.topcased.tabbedproperties.sections.AbstractTextPropertySection#getStyle()
//     * @generated
//     */
//    protected int getStyle() {
//        return SWT.MULTI;
//    }
}