package de.urszeidler.eclipse.callchain.tabbedpropery.sections;

import java.util.Arrays;
import java.util.List;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.presentation.EcoreActionBarContributor.ExtendedLoadResourceAction.ExtendedLoadResourceDialog;
import org.eclipse.emf.ecore.presentation.EcoreActionBarContributor.ExtendedLoadResourceAction.RegisteredPackageDialog;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Button;
import org.eclipse.ui.PlatformUI;

import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.tabbedpropery.basicsections.AbstractTextButtonSection;

/**
 * A section display a text field to edit/see String features
 *
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 *
 * @generated not
 */
public class MMUriSection extends AbstractTextButtonSection {
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     *
     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#getLabelText()
     * @generated
     */
    protected String getLabelText() {
        return "Uri:";
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     *
     * @see org.topcased.tabbedproperties.sections.AbstractTabbedPropertySection#getFeature()
     * @generated
     */
    protected EStructuralFeature getFeature() {
        return CallchainPackage.eINSTANCE.getArtifact_Uri();
    }

    @Override
    protected void handleButtonPressed() {
        ExtendedLoadResourceDialog loadResourceDialog = new ExtendedLoadResourceDialog(
                PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(),
                (EditingDomain) null) {

            protected void prepareBrowseRegisteredPackagesButton(
                    Button browseRegisteredPackagesButton) {
                uriText = getText().getText();
                browseRegisteredPackagesButton
                        .addSelectionListener(new SelectionAdapter() {
                            public void widgetSelected(SelectionEvent event) {
                                RegisteredPackageDialog registeredPackageDialog = new RegisteredPackageDialog(
                                        getShell());
                                registeredPackageDialog.open();
                                Object[] result = registeredPackageDialog
                                        .getResult();
                                if (result != null) {
                                    List<?> nsURIs = Arrays.asList(result);
                                    for (Object uri : nsURIs) {
                                        uriField.setText((uriField.getText()
                                                + "  uri:" + uri.toString())
                                                .trim());
                                    }
                                }
                            }
                        });
            }

        };


        int i = loadResourceDialog.open();
        if (i == Window.OK)
            getText().setText(loadResourceDialog.getURIText());

    }

}