package de.urszeidler.eclipse.callchain.topcasedgenerators.preferences;

import java.io.File;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;

import de.urszeidler.eclipse.callchain.topcasedgenerators.AbstractTopcasedUMLimporter;
import de.urszeidler.eclipse.callchain.topcasedgenerators.Activator;
import de.urszeidler.eclipse.callchain.topcasedgenerators.DiagramGenerator;
import de.urszeidler.eclipse.callchain.topcasedgenerators.EditorGenerator;
import de.urszeidler.eclipse.callchain.topcasedgenerators.PropertyGenerator;
import de.urszeidler.eclipse.callchain.topcasedgenerators.TopcasedDiagramExchanger;

/**
 * Class used to initialize default preference values.
 */
public class PreferenceInitializer extends AbstractPreferenceInitializer {

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer#
	 * initializeDefaultPreferences()
	 */
	public void initializeDefaultPreferences() {
		IPreferenceStore store = Activator.getDefault().getPreferenceStore();
		store.setDefault(PreferenceConstants.UML_IMPORTER_URIS, AbstractTopcasedUMLimporter.UML2_MODEL_2_0_0
				+ File.pathSeparator + "\n\r" + AbstractTopcasedUMLimporter.UML2_MODEL_2_1_0 + File.pathSeparator
				+ "\n\r" + AbstractTopcasedUMLimporter.UML2_MODEL_3_0_0 + File.pathSeparator + "\n\r");
		store.setDefault(PreferenceConstants.DIAGRAM_URIS, DiagramGenerator.TC_DIAGRAM_CONFIGURATOR_0_10
				+ File.pathSeparator + "\n\r" + DiagramGenerator.TC_DIAGRAM_CONFIGURATOR_1_0 + File.pathSeparator
				+ "\n\r");
		store.setDefault(PreferenceConstants.EDITOR_URIS, EditorGenerator.TC_EDITOR_CONFIGURATOR_0_10
				+ File.pathSeparator + "\n\r" + EditorGenerator.TC_EDITOR_CONFIGURATOR_1_0 + File.pathSeparator
				+ "\n\r");
		store.setDefault(PreferenceConstants.PROPERTIES_URIS, PropertyGenerator.TC_PROPERTYCONFIGURATOR
				+ File.pathSeparator + "\n\r");
		store.setDefault(PreferenceConstants.DIAGRAM_EXCHANGE_URIS, TopcasedDiagramExchanger.TOPCASED_DIA_1_0
				+ File.pathSeparator + "\n\r");
		store.setDefault(PreferenceConstants.DIAGRAM_EXCHANGE_KEEP_TYPES, "Usage" + File.pathSeparator + "\n\r"
				+ "Comment" + File.pathSeparator + "\n\r");

	}

}
