/**
 * 
 */
package de.urszeidler.eclipse.callchain.ui.emf.actions;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;

import de.urszeidler.eclipse.callchain.Generator;
import de.urszeidler.eclipse.callchain.Generic_Generator;
import de.urszeidler.eclipse.callchain.executors.GenericExecutorStep;
import de.urszeidler.eclipse.callchain.generatorservice.GeneratorDescriptor;
import de.urszeidler.eclipse.callchain.generatorservice.GeneratorExecutable;
import de.urszeidler.eclipse.callchain.generatorservice.Generatorservice;
import de.urszeidler.eclipse.callchain.provider.CallchainEditPlugin;
import de.urszeidler.eclipse.callchain.util.CallchainSwitch;

/**
 * a switch deciding which gegeratorExecutor should be usesd
 * 
 * @author urs
 *
 */
final public class CallchainDoGenerationSwitch extends CallchainSwitch<Object> {
	private IProgressMonitor monitor;


	@Override
	public Object caseGeneric_Generator(Generic_Generator object) {
		GeneratorDescriptor descriptor = Generatorservice.getDefault()
				.getGenerator(object.getId());
		if (descriptor != null) {
			GeneratorExecutable executor;
			try {
				executor = descriptor.createExecutable();
				//executor.execute(monitor);
				new GenericExecutorStep(executor, object).generate(monitor);
			} catch (InstantiationException e) {
				CallchainEditPlugin.log("error while Instantiation : "+descriptor.getClassName(), IStatus.ERROR, e);
			} catch (IllegalAccessException e) {
				CallchainEditPlugin.log("error while Accessing : "+descriptor.getClassName(), IStatus.ERROR, e);
			}
		}
		return null;
	}

	@Override
	public Object caseGenerator(Generator object) {		// startGenerator(object);
		return super.caseGenerator(object);
	}

	public void setMonitor(IProgressMonitor pmon) {
		this.monitor = pmon;

	}
}