/*
 * (c) urs zeidler
 */
package de.urszeidler.eclipse.callchain.ui.emf.actions;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.Path;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.viewers.SelectionChangedEvent;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.PartInitException;

import de.urszeidler.eclipse.callchain.Artifact;

/** 
 * <p> 
 * OpenResourceAction 
 * </p> 
 * Created : 08.05.2007 
 * @author urs 
 */
@Deprecated
public class OpenResourceAction extends SelectionAction {

    
    public static final String ID = "OpenResourceAction";
	//private EditingDomainActionBarContributor fConstibuter;
    private IWorkbenchPage page;//this.fConstibuter.getPage()


    
    protected OpenResourceAction(String text, ImageDescriptor image) {
        super(text, image);
        
    }
    protected OpenResourceAction(String text, int style) {
        super(text, style);
        
    }
    protected OpenResourceAction(String text) {
        super(text);
        
    }
    public OpenResourceAction(IWorkbenchPart part) {
        super("open Resource");
         setWPart(part);
    }
    public OpenResourceAction() {
        this((IWorkbenchPart)null);
    }

    public OpenResourceAction(IWorkbenchPage workbenchPage) {
		this(workbenchPage.getActivePart());
	}
	public boolean isEnabled() {
		if(selection==null)
			return true;
		
    	boolean en = false;
    	if (selection instanceof Artifact) {
			Artifact art = (Artifact) selection;
			String uri = art.getUri();
			if(uri!=null){
				Path path = new Path(uri);
				IFile file = ResourcesPlugin.getWorkspace().getRoot().getFile(path);
				en = file.exists();
			}
				
		}
    	
        return super.isEnabled() && en;
    }

    @Override
    public void run() {
        
        if (selection instanceof Artifact) {
            Artifact af = (Artifact) selection;
            openArtifact(af);
        }//end of if (selection instanceof Artifact)
        // TODO Auto-generated method stub
        //super.run();
    }
    
    
    @Override
    public void selectionChanged(SelectionChangedEvent event) {
        super.selectionChanged(event);
    }
    
    private void openArtifact(Artifact af) {
        if (af.getUri() == null)
            return;

        Path path = new Path(af.getUri());

        IFile file = ResourcesPlugin.getWorkspace().getRoot().getFile(path);
        //FileEditorInput input = new FileEditorInput(file);
        try {
            org.eclipse.ui.ide.IDE
                    .openEditor(page, file);
                } catch (PartInitException e) {
         }

        if(parentViewer!=null)
        parentViewer.refresh();

        
    }
    /**
     * @param page the page to set
     */
    public void setPage(IWorkbenchPage page) {
        this.page = page;
    }
    /* (non-Javadoc)
     * @see de.urszeidler.eclipse.tcdiasupport.action.SelectionAction#setWPart(org.eclipse.ui.IWorkbenchPart)
     */
    @Override
    public void setWPart(IWorkbenchPart part) {
        super.setWPart(part);
        if(part!=null)
        setPage(part.getSite().getPage());
    }
    @Override
    protected void initAction() {
       setId(ID);
       setActionDefinitionId("OpenResourceAction");
        
    }
    
}
