/**
 * <copyright>
 * </copyright>
 *
 * $Id: CallchainAdapterFactory.java,v 1.2 2008/04/13 20:29:20 urs Exp $
 */
package de.urszeidler.eclipse.callchain.util;

import de.urszeidler.eclipse.callchain.*;
import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

import de.urszeidler.eclipse.callchain.AndPredicate;
import de.urszeidler.eclipse.callchain.Artifact;
import de.urszeidler.eclipse.callchain.AtlLibary;
import de.urszeidler.eclipse.callchain.AtlRes;
import de.urszeidler.eclipse.callchain.Call;
import de.urszeidler.eclipse.callchain.Callable;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.Calls;
import de.urszeidler.eclipse.callchain.Comment;
import de.urszeidler.eclipse.callchain.CompositePredicate;
import de.urszeidler.eclipse.callchain.Documentable;
import de.urszeidler.eclipse.callchain.ExternalCallable;
import de.urszeidler.eclipse.callchain.Generator;
import de.urszeidler.eclipse.callchain.Generic_Generator;
import de.urszeidler.eclipse.callchain.MM;
import de.urszeidler.eclipse.callchain.MMAlias;
import de.urszeidler.eclipse.callchain.Model;
import de.urszeidler.eclipse.callchain.ModelAlias;
import de.urszeidler.eclipse.callchain.NamedSwitch;
import de.urszeidler.eclipse.callchain.NotPredicate;
import de.urszeidler.eclipse.callchain.OrPredicate;
import de.urszeidler.eclipse.callchain.Predicate;
import de.urszeidler.eclipse.callchain.PredicateSwitch;
import de.urszeidler.eclipse.callchain.Property;
import de.urszeidler.eclipse.callchain.PropertyExist;
import de.urszeidler.eclipse.callchain.PropertyHasValue;
import de.urszeidler.eclipse.callchain.PropertyPredicate;
import de.urszeidler.eclipse.callchain.PropertyValueSwitch;
import de.urszeidler.eclipse.callchain.ResourceExistPredicate;
import de.urszeidler.eclipse.callchain.ResourcePredicate;
import de.urszeidler.eclipse.callchain.Switch;
import de.urszeidler.eclipse.callchain.Transition;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see de.urszeidler.eclipse.callchain.CallchainPackage
 * @generated
 */
public class CallchainAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static CallchainPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallchainAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = CallchainPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CallchainSwitch<Adapter> modelSwitch =
		new CallchainSwitch<Adapter>() {
			@Override
			public Adapter caseModel(Model object) {
				return createModelAdapter();
			}
			@Override
			public Adapter caseAtlRes(AtlRes object) {
				return createAtlResAdapter();
			}
			@Override
			public Adapter caseCall(Call object) {
				return createCallAdapter();
			}
			@Override
			public Adapter caseMM(MM object) {
				return createMMAdapter();
			}
			@Override
			public Adapter caseCalls(Calls object) {
				return createCallsAdapter();
			}
			@Override
			public Adapter caseAtlLibary(AtlLibary object) {
				return createAtlLibaryAdapter();
			}
			@Override
			public Adapter caseModelAlias(ModelAlias object) {
				return createModelAliasAdapter();
			}
			@Override
			public Adapter caseGenerator(Generator object) {
				return createGeneratorAdapter();
			}
			@Override
			public Adapter caseArtifact(Artifact object) {
				return createArtifactAdapter();
			}
			@Override
			public Adapter caseMMAlias(MMAlias object) {
				return createMMAliasAdapter();
			}
			@Override
			public Adapter caseDocumentable(Documentable object) {
				return createDocumentableAdapter();
			}
			@Override
			public Adapter caseComment(Comment object) {
				return createCommentAdapter();
			}
			@Override
			public Adapter caseCallable(Callable object) {
				return createCallableAdapter();
			}
			@Override
			public Adapter caseGeneric_Generator(Generic_Generator object) {
				return createGeneric_GeneratorAdapter();
			}
			@Override
			public Adapter caseProperty(Property object) {
				return createPropertyAdapter();
			}
			@Override
			public Adapter caseSwitch(Switch object) {
				return createSwitchAdapter();
			}
			@Override
			public Adapter casePredicateSwitch(PredicateSwitch object) {
				return createPredicateSwitchAdapter();
			}
			@Override
			public Adapter caseNamedSwitch(NamedSwitch object) {
				return createNamedSwitchAdapter();
			}
			@Override
			public Adapter caseTransition(Transition object) {
				return createTransitionAdapter();
			}
			@Override
			public Adapter casePredicate(Predicate object) {
				return createPredicateAdapter();
			}
			@Override
			public Adapter casePropertyPredicate(PropertyPredicate object) {
				return createPropertyPredicateAdapter();
			}
			@Override
			public Adapter casePropertyHasValue(PropertyHasValue object) {
				return createPropertyHasValueAdapter();
			}
			@Override
			public Adapter casePropertyExist(PropertyExist object) {
				return createPropertyExistAdapter();
			}
			@Override
			public Adapter caseResourcePredicate(ResourcePredicate object) {
				return createResourcePredicateAdapter();
			}
			@Override
			public Adapter caseResourceExistPredicate(ResourceExistPredicate object) {
				return createResourceExistPredicateAdapter();
			}
			@Override
			public Adapter caseCompositePredicate(CompositePredicate object) {
				return createCompositePredicateAdapter();
			}
			@Override
			public Adapter caseAndPredicate(AndPredicate object) {
				return createAndPredicateAdapter();
			}
			@Override
			public Adapter caseOrPredicate(OrPredicate object) {
				return createOrPredicateAdapter();
			}
			@Override
			public Adapter caseNotPredicate(NotPredicate object) {
				return createNotPredicateAdapter();
			}
			@Override
			public Adapter casePropertyValueSwitch(PropertyValueSwitch object) {
				return createPropertyValueSwitchAdapter();
			}
			@Override
			public Adapter caseExternalCallable(ExternalCallable object) {
				return createExternalCallableAdapter();
			}
			@Override
			public Adapter caseStopCall(StopCall object) {
				return createStopCallAdapter();
			}
			@Override
			public Adapter caseBooleanPredicate(BooleanPredicate object) {
				return createBooleanPredicateAdapter();
			}
			@Override
			public Adapter caseEavaluateable(Eavaluateable object) {
				return createEavaluateableAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.Model <em>Model</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.Model
	 * @generated
	 */
	public Adapter createModelAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.AtlRes <em>Atl Res</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.AtlRes
	 * @generated
	 */
	public Adapter createAtlResAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.Call <em>Call</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.Call
	 * @generated
	 */
	public Adapter createCallAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.MM <em>MM</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.MM
	 * @generated
	 */
	public Adapter createMMAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.Calls <em>Calls</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.Calls
	 * @generated
	 */
	public Adapter createCallsAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.AtlLibary <em>Atl Libary</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.AtlLibary
	 * @generated
	 */
	public Adapter createAtlLibaryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.ModelAlias <em>Model Alias</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.ModelAlias
	 * @generated
	 */
	public Adapter createModelAliasAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.Generator <em>Generator</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.Generator
	 * @generated
	 */
	public Adapter createGeneratorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.Artifact <em>Artifact</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.Artifact
	 * @generated
	 */
	public Adapter createArtifactAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.MMAlias <em>MM Alias</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.MMAlias
	 * @generated
	 */
	public Adapter createMMAliasAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.Documentable <em>Documentable</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.Documentable
	 * @generated
	 */
	public Adapter createDocumentableAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.Comment <em>Comment</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.Comment
	 * @generated
	 */
	public Adapter createCommentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.Callable <em>Callable</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.Callable
	 * @generated
	 */
	public Adapter createCallableAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.Generic_Generator <em>Generic Generator</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.Generic_Generator
	 * @generated
	 */
	public Adapter createGeneric_GeneratorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.Property <em>Property</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.Property
	 * @generated
	 */
	public Adapter createPropertyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.Switch <em>Switch</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.Switch
	 * @generated
	 */
	public Adapter createSwitchAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.PredicateSwitch <em>Predicate Switch</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.PredicateSwitch
	 * @generated
	 */
	public Adapter createPredicateSwitchAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.NamedSwitch <em>Named Switch</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.NamedSwitch
	 * @generated
	 */
	public Adapter createNamedSwitchAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.Transition <em>Transition</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.Transition
	 * @generated
	 */
	public Adapter createTransitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.Predicate <em>Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.Predicate
	 * @generated
	 */
	public Adapter createPredicateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.PropertyPredicate <em>Property Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.PropertyPredicate
	 * @generated
	 */
	public Adapter createPropertyPredicateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.PropertyHasValue <em>Property Has Value</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.PropertyHasValue
	 * @generated
	 */
	public Adapter createPropertyHasValueAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.PropertyExist <em>Property Exist</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.PropertyExist
	 * @generated
	 */
	public Adapter createPropertyExistAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.ResourcePredicate <em>Resource Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.ResourcePredicate
	 * @generated
	 */
	public Adapter createResourcePredicateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.ResourceExistPredicate <em>Resource Exist Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.ResourceExistPredicate
	 * @generated
	 */
	public Adapter createResourceExistPredicateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.CompositePredicate <em>Composite Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.CompositePredicate
	 * @generated
	 */
	public Adapter createCompositePredicateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.AndPredicate <em>And Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.AndPredicate
	 * @generated
	 */
	public Adapter createAndPredicateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.OrPredicate <em>Or Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.OrPredicate
	 * @generated
	 */
	public Adapter createOrPredicateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.NotPredicate <em>Not Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.NotPredicate
	 * @generated
	 */
	public Adapter createNotPredicateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.PropertyValueSwitch <em>Property Value Switch</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.PropertyValueSwitch
	 * @generated
	 */
	public Adapter createPropertyValueSwitchAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.ExternalCallable <em>External Callable</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.ExternalCallable
	 * @generated
	 */
	public Adapter createExternalCallableAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.StopCall <em>Stop Call</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.StopCall
	 * @generated
	 */
	public Adapter createStopCallAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.BooleanPredicate <em>Boolean Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.BooleanPredicate
	 * @generated
	 */
	public Adapter createBooleanPredicateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link de.urszeidler.eclipse.callchain.Eavaluateable <em>Eavaluateable</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see de.urszeidler.eclipse.callchain.Eavaluateable
	 * @generated
	 */
	public Adapter createEavaluateableAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //CallchainAdapterFactory
