<?xml version="1.0"?>
<xsl:stylesheet version="1.1"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:output method="html" indent="no" encoding="UTF-8" />

	<xsl:template match="toc">
		<h1>
			<xsl:value-of select="@label" />
		</h1>
		<ul>
			<xsl:apply-templates />
		</ul>
	</xsl:template>

	<xsl:template match="topic">
		<li>
			<xsl:choose>
				<xsl:when test="@href">
					<!-- Only add a hyperlink when there is something to link to -->
					<xsl:element name="a">
						<xsl:attribute name="href">
                   <xsl:variable name="ref" select="@href" />                  
                   <xsl:value-of select="substring-after($ref, 'html/')" />
               </xsl:attribute>
						<xsl:value-of select="@label" />
					</xsl:element>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="@label" />
					<xsl:choose>
						<xsl:when test="@label='Generators'">
							<ul>
								<li>
									<a href="generators/generators.html">
										<xsl:value-of select="@label" />
									</a>
								</li>
							</ul>
						</xsl:when>
						<xsl:when test="@label='Samples'">
							<ul>
								<li>
									<a href="samples/templateProject.html">template project</a>
								</li>
								<li>
									<a href="samples/eef-process.html">eef-process</a>
								</li>
								<li>
									<a href="samples/generateGMF.html">generate-gmf</a>
								</li>
								<li>
									<a href="samples/generic-emf.html">generic-emf</a>
								</li>
								<li>
									generated reports
									<ul>
										<xsl:apply-templates mode="inner" />
									</ul>
								</li>
								<li>
									<a href="samples/ant.html">ant</a>
								</li>

							</ul>
						</xsl:when>
					</xsl:choose>

				</xsl:otherwise>
			</xsl:choose>

			<!-- If there are any nested topics, then start a new sub-list <xsl:if 
				test="descendant::topic"> <ul> <xsl:apply-templates /> </ul> </xsl:if> -->
		</li>
	</xsl:template>

	<xsl:template mode="inner" match="/toc/topic/topic/link">
		<li>
			<xsl:variable name="ref" select="@toc" />
			<xsl:variable name="label"
				select="substring-before(substring-after($ref, 'eclipse.html/samples/'),'-toc.xml')" />
			<xsl:element name="a">
				<xsl:attribute name="href">
                    <xsl:value-of select="concat('samples/',$label,'.html' )" />            
               </xsl:attribute>
				<xsl:value-of select="$label" />
			</xsl:element>
		</li>
	</xsl:template>

</xsl:stylesheet>